/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

extern int internal_dfa_insn_code_ev6 (rtx_insn *);
extern int insn_default_latency_ev6 (rtx_insn *);
extern int internal_dfa_insn_code_ev5 (rtx_insn *);
extern int insn_default_latency_ev5 (rtx_insn *);
extern int internal_dfa_insn_code_ev4 (rtx_insn *);
extern int insn_default_latency_ev4 (rtx_insn *);

int (*internal_dfa_insn_code) (rtx_insn *);
int (*insn_default_latency) (rtx_insn *);

void
init_sched_attrs (void)
{
  if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV6)))))
    {
      internal_dfa_insn_code
        = internal_dfa_insn_code_ev6;
      insn_default_latency
        = insn_default_latency_ev6;
    }
  else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))))
    {
      internal_dfa_insn_code
        = internal_dfa_insn_code_ev5;
      insn_default_latency
        = insn_default_latency_ev5;
    }
  else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))))
    {
      internal_dfa_insn_code
        = internal_dfa_insn_code_ev4;
      insn_default_latency
        = insn_default_latency_ev4;
    }
  else
    gcc_unreachable ();
}

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 344:  /* *call_value_osf_1_noreturn */
    case 340:  /* *call_value_osf_1_er_noreturn */
    case 197:  /* *call_osf_1_noreturn */
    case 193:  /* *call_osf_1_er_noreturn */
    case 2:  /* *extendsidi2_1 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 4;
        }
      else
        {
	  return 8;
        }

    case 349:  /* *sibcall_value_osf_1 */
    case 348:  /* *sibcall_value_osf_1_er */
    case 200:  /* *sibcall_osf_1 */
    case 199:  /* *sibcall_osf_1_er */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else
        {
	  return 8;
        }

    case 347:  /* *call_value_osf_1 */
    case 341:  /* *call_value_osf_1_er */
    case 198:  /* *call_osf_1 */
    case 194:  /* *call_osf_1_er */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 12 /* 0xc */;
        }
      else if (which_alternative == 1)
        {
	  return 4;
        }
      else
        {
	  return 16 /* 0x10 */;
        }

    case 346:  /* call_value_osf_tlsldm */
    case 345:  /* call_value_osf_tlsgd */
    case 261:  /* prologue_stack_probe_loop */
      return 16 /* 0x10 */;

    case 343:  /* *call_value_osf_2_er */
    case 273:  /* *exception_receiver_1 */
    case 267:  /* prologue_mcount */
    case 196:  /* *call_osf_2_er */
    case 45:  /* *divmoddi_internal */
    case 43:  /* *divmoddi_internal_er */
    case 42:  /* *divmodsi_internal */
    case 40:  /* *divmodsi_internal_er */
      return 8;

    case 270:  /* *builtin_setjmp_receiver_1 */
      return 12 /* 0xc */;

    case 201:  /* blockage */
      return 0;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 4;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 344:  /* *call_value_osf_1_noreturn */
    case 340:  /* *call_value_osf_1_er_noreturn */
    case 197:  /* *call_osf_1_noreturn */
    case 193:  /* *call_osf_1_er_noreturn */
    case 2:  /* *extendsidi2_1 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 4;
        }
      else
        {
	  return 8;
        }

    case 349:  /* *sibcall_value_osf_1 */
    case 348:  /* *sibcall_value_osf_1_er */
    case 200:  /* *sibcall_osf_1 */
    case 199:  /* *sibcall_osf_1_er */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else
        {
	  return 8;
        }

    case 347:  /* *call_value_osf_1 */
    case 341:  /* *call_value_osf_1_er */
    case 198:  /* *call_osf_1 */
    case 194:  /* *call_osf_1_er */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 12 /* 0xc */;
        }
      else if (which_alternative == 1)
        {
	  return 4;
        }
      else
        {
	  return 16 /* 0x10 */;
        }

    case 346:  /* call_value_osf_tlsldm */
    case 345:  /* call_value_osf_tlsgd */
    case 261:  /* prologue_stack_probe_loop */
      return 16 /* 0x10 */;

    case 343:  /* *call_value_osf_2_er */
    case 273:  /* *exception_receiver_1 */
    case 267:  /* prologue_mcount */
    case 196:  /* *call_osf_2_er */
    case 45:  /* *divmoddi_internal */
    case 43:  /* *divmoddi_internal_er */
    case 42:  /* *divmodsi_internal */
    case 40:  /* *divmodsi_internal_er */
      return 8;

    case 270:  /* *builtin_setjmp_receiver_1 */
      return 12 /* 0xc */;

    case 201:  /* blockage */
      return 0;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 4;

    }
}

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;
  enum attr_opsize cached_opsize ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 224:  /* *movhi */
    case 223:  /* *movqi */
      extract_constrain_insn_cached (insn);
      if (((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && (((1ULL << which_alternative) & 0x3ULL))) || ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && (((1ULL << which_alternative) & 0x7ULL))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 213:  /* *movsi */
      extract_constrain_insn_cached (insn);
      if (((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && (((1ULL << which_alternative) & 0x7ULL))) || ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && (!((1ULL << which_alternative) & 0x28ULL))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 186:  /* *fbcc_ext_normal */
    case 185:  /* *fbcc_normal */
      if (((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV6))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 293:  /* load_locked_di */
    case 292:  /* load_locked_si */
    case 290:  /* *unpkbw */
    case 289:  /* *unpkbl */
    case 288:  /* *pkwb */
    case 287:  /* *pklb */
    case 286:  /* builtin_perr */
    case 274:  /* prefetch */
    case 272:  /* *exception_receiver_2 */
    case 239:  /* uminv4hi3 */
    case 238:  /* umaxv4hi3 */
    case 237:  /* sminv4hi3 */
    case 236:  /* smaxv4hi3 */
    case 235:  /* uminv8qi3 */
    case 234:  /* umaxv8qi3 */
    case 233:  /* sminv8qi3 */
    case 232:  /* smaxv8qi3 */
    case 219:  /* *movdi_er_gottp */
    case 218:  /* *movdi_er_gotdtp */
    case 215:  /* movdi_er_high_g */
    case 168:  /* uminhi3 */
    case 167:  /* umaxhi3 */
    case 166:  /* sminhi3 */
    case 165:  /* smaxhi3 */
    case 164:  /* uminqi3 */
    case 163:  /* umaxqi3 */
    case 162:  /* sminqi3 */
    case 161:  /* smaxqi3 */
    case 68:  /* popcountdi2 */
    case 67:  /* ctzdi2 */
    case 66:  /* clzdi2 */
      if (((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 349:  /* *sibcall_value_osf_1 */
    case 348:  /* *sibcall_value_osf_1_er */
    case 347:  /* *call_value_osf_1 */
    case 346:  /* call_value_osf_tlsldm */
    case 345:  /* call_value_osf_tlsgd */
    case 344:  /* *call_value_osf_1_noreturn */
    case 343:  /* *call_value_osf_2_er */
    case 342:  /* *call_value_osf_2_er_nogp */
    case 341:  /* *call_value_osf_1_er */
    case 340:  /* *call_value_osf_1_er_noreturn */
    case 339:  /* atomic_nand_fetchdi */
    case 338:  /* atomic_nand_fetchsi */
    case 337:  /* atomic_and_fetchdi */
    case 336:  /* atomic_xor_fetchdi */
    case 335:  /* atomic_or_fetchdi */
    case 334:  /* atomic_sub_fetchdi */
    case 333:  /* atomic_add_fetchdi */
    case 332:  /* atomic_and_fetchsi */
    case 331:  /* atomic_xor_fetchsi */
    case 330:  /* atomic_or_fetchsi */
    case 329:  /* atomic_sub_fetchsi */
    case 328:  /* atomic_add_fetchsi */
    case 327:  /* atomic_fetch_nanddi */
    case 326:  /* atomic_fetch_nandsi */
    case 325:  /* atomic_fetch_anddi */
    case 324:  /* atomic_fetch_xordi */
    case 323:  /* atomic_fetch_ordi */
    case 322:  /* atomic_fetch_subdi */
    case 321:  /* atomic_fetch_adddi */
    case 320:  /* atomic_fetch_andsi */
    case 319:  /* atomic_fetch_xorsi */
    case 318:  /* atomic_fetch_orsi */
    case 317:  /* atomic_fetch_subsi */
    case 316:  /* atomic_fetch_addsi */
    case 315:  /* atomic_nanddi */
    case 314:  /* atomic_nandsi */
    case 313:  /* atomic_anddi */
    case 312:  /* atomic_xordi */
    case 311:  /* atomic_ordi */
    case 310:  /* atomic_subdi */
    case 309:  /* atomic_adddi */
    case 308:  /* atomic_andsi */
    case 307:  /* atomic_xorsi */
    case 306:  /* atomic_orsi */
    case 305:  /* atomic_subsi */
    case 304:  /* atomic_addsi */
    case 303:  /* atomic_exchangehi_1 */
    case 302:  /* atomic_exchangeqi_1 */
    case 301:  /* atomic_exchangedi */
    case 300:  /* atomic_exchangesi */
    case 299:  /* atomic_compare_and_swaphi_1 */
    case 298:  /* atomic_compare_and_swapqi_1 */
    case 297:  /* *atomic_compare_and_swapdi */
    case 296:  /* *atomic_compare_and_swapsi */
    case 295:  /* store_conditional_di */
    case 294:  /* store_conditional_si */
    case 291:  /* *memory_barrier */
    case 275:  /* trapb */
    case 273:  /* *exception_receiver_1 */
    case 270:  /* *builtin_setjmp_receiver_1 */
    case 269:  /* builtin_longjmp_internal */
    case 267:  /* prologue_mcount */
    case 261:  /* prologue_stack_probe_loop */
    case 209:  /* *set_tp */
    case 208:  /* get_thread_pointerdi */
    case 207:  /* trap */
    case 206:  /* imb */
    case 205:  /* *tablejump_internal */
    case 204:  /* indirect_jump */
    case 203:  /* *return_internal */
    case 202:  /* jump */
    case 201:  /* blockage */
    case 200:  /* *sibcall_osf_1 */
    case 199:  /* *sibcall_osf_1_er */
    case 198:  /* *call_osf_1 */
    case 197:  /* *call_osf_1_noreturn */
    case 196:  /* *call_osf_2_er */
    case 195:  /* *call_osf_2_er_nogp */
    case 194:  /* *call_osf_1_er */
    case 193:  /* *call_osf_1_er_noreturn */
    case 174:  /* *blbc_normal */
    case 173:  /* *blbs_normal */
    case 172:  /* *bcc_reverse */
    case 171:  /* *bcc_normal */
    case 129:  /* sqrtdf2 */
    case 128:  /* sqrtsf2 */
    case 127:  /* *divdf_ext3 */
    case 126:  /* *divdf_ext2 */
    case 125:  /* *divdf_ext1 */
    case 124:  /* divdf3 */
    case 123:  /* divsf3 */
    case 45:  /* *divmoddi_internal */
    case 44:  /* *divmoddi_internal_er_1 */
    case 43:  /* *divmoddi_internal_er */
    case 42:  /* *divmodsi_internal */
    case 41:  /* *divmodsi_internal_er_1 */
    case 40:  /* *divmodsi_internal_er */
      return 0;

    case 2:  /* *extendsidi2_1 */
      extract_constrain_insn_cached (insn);
      if (((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && (which_alternative == 0)) || (((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 277:  /* fnop */
    case 184:  /* *movdfcc_ext4 */
    case 183:  /* *movdfcc_ext3 */
    case 182:  /* *movdfcc_ext2 */
    case 181:  /* *movdfcc_ext1 */
    case 180:  /* *movdfcc_internal */
    case 179:  /* *movsfcc_internal */
    case 178:  /* *cmpdf_ext3 */
    case 177:  /* *cmpdf_ext2 */
    case 176:  /* *cmpdf_ext1 */
    case 175:  /* *cmpdf_internal */
    case 145:  /* truncdfsf2 */
    case 143:  /* *extendsfdf2_ieee */
    case 140:  /* floatdidf2 */
    case 137:  /* floatdisf2 */
    case 136:  /* *fix_truncsfdi2 */
    case 135:  /* *fix_truncsfsi_internal */
    case 134:  /* *fix_truncsfsi_ieee */
    case 133:  /* *fix_truncdfdi2 */
    case 132:  /* *fix_truncdfsi_internal */
    case 131:  /* *fix_truncdfsi_ieee */
    case 130:  /* *cvtql */
    case 122:  /* *muldf_ext2 */
    case 121:  /* *muldf_ext1 */
    case 120:  /* muldf3 */
    case 119:  /* mulsf3 */
    case 118:  /* *subdf_ext3 */
    case 117:  /* *subdf_ext2 */
    case 116:  /* *subdf_ext1 */
    case 115:  /* subdf3 */
    case 114:  /* subsf3 */
    case 113:  /* *adddf_ext2 */
    case 112:  /* *adddf_ext1 */
    case 111:  /* adddf3 */
    case 110:  /* addsf3 */
    case 109:  /* *ncopysigndf3 */
    case 108:  /* *ncopysignsf3 */
    case 107:  /* copysigndf3 */
    case 106:  /* copysignsf3 */
    case 104:  /* negdf2 */
    case 103:  /* negsf2 */
    case 101:  /* *nabsdf2 */
    case 100:  /* *nabssf2 */
    case 99:  /* absdf2 */
    case 98:  /* abssf2 */
    case 1:  /* *cvtlq */
      if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) || (((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV6)))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 46:  /* *andsi_internal */
    case 47:  /* anddi3 */
    case 48:  /* zero_extendqihi2 */
    case 49:  /* zero_extendqisi2 */
    case 50:  /* zero_extendqidi2 */
    case 51:  /* zero_extendhisi2 */
    case 52:  /* zero_extendhidi2 */
    case 69:  /* ashldi3 */
    case 144:  /* *extendsfdf2_internal */
    case 210:  /* *movsf */
    case 211:  /* *movdf */
    case 220:  /* *movdi */
    case 229:  /* *movv8qi_fix */
    case 230:  /* *movv4hi_fix */
    case 231:  /* *movv2si_fix */
      if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && (((cached_type = get_attr_type (insn)) == TYPE_IADD) || (cached_type == TYPE_ILOG)))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && (((cached_type = get_attr_type (insn)) == TYPE_SHIFT) || (cached_type == TYPE_ICMOV)))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && ((cached_type = get_attr_type (insn)) == TYPE_ICMP))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && ((cached_type = get_attr_type (insn)) == TYPE_IMUL) && ((cached_opsize = get_attr_opsize (insn)) == OPSIZE_SI))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && ((cached_type = get_attr_type (insn)) == TYPE_IMUL) && (! ((cached_opsize = get_attr_opsize (insn)) == OPSIZE_SI)))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) && (((cached_type = get_attr_type (insn)) == TYPE_FADD) || (cached_type == TYPE_FMUL) || (cached_type == TYPE_FCPYS) || (cached_type == TYPE_FCMOV)))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && (((cached_type = get_attr_type (insn)) == TYPE_ILD) || (cached_type == TYPE_FLD) || (cached_type == TYPE_LDSYM)))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_LD_L))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_SHIFT))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_MVI))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_ICMOV))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_IADD))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && (((cached_type = get_attr_type (insn)) == TYPE_ILOG) || (cached_type == TYPE_ICMP)))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_IMUL) && ((cached_opsize = get_attr_opsize (insn)) == OPSIZE_SI))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_IMUL) && ((cached_opsize = get_attr_opsize (insn)) == OPSIZE_DI))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))) && ((cached_type = get_attr_type (insn)) == TYPE_IMUL) && ((cached_opsize = get_attr_opsize (insn)) == OPSIZE_UDI))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV6)))) && ((cached_type = get_attr_type (insn)) == TYPE_FMUL))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV6)))) && (((cached_type = get_attr_type (insn)) == TYPE_FADD) || (cached_type == TYPE_FCPYS) || (cached_type == TYPE_FBR)))
        {
	  return 1;
        }
      else if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV6)))) && ((cached_type = get_attr_type (insn)) == TYPE_FCMOV))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    default:
      if ((((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV4)))) || (((
#line 120 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_tune) alpha_tune))) == (
(TUNE_EV5)))))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

enum attr_cannot_copy
get_attr_cannot_copy (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 196:  /* *call_osf_2_er */
    case 262:  /* *ldgp_er_1 */
    case 263:  /* *ldgp_er_2 */
    case 264:  /* *prologue_ldgp_er_2 */
    case 265:  /* *prologue_ldgp_1 */
    case 343:  /* *call_value_osf_2_er */
      return CANNOT_COPY_TRUE;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return CANNOT_COPY_FALSE;

    }
}

int
get_attr_enabled (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_isa cached_isa ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 231:  /* *movv2si_fix */
    case 230:  /* *movv4hi_fix */
    case 229:  /* *movv8qi_fix */
      extract_constrain_insn_cached (insn);
      if (!((1ULL << which_alternative) & 0x7fULL))
        {
	  return 
#line 204 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_FIX);
        }
      else
        {
	  return 1;
        }

    case 224:  /* *movhi */
    case 223:  /* *movqi */
      extract_constrain_insn_cached (insn);
      if (!((1ULL << which_alternative) & 0x3ULL))
        {
	  return 
#line 202 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_BWX);
        }
      else
        {
	  return 1;
        }

    case 220:  /* *movdi */
      extract_constrain_insn_cached (insn);
      if (!((1ULL << which_alternative) & 0xfffULL))
        {
	  return 
#line 204 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_FIX);
        }
      else if (which_alternative == 6)
        {
	  return 
#line 207 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(!TARGET_EXPLICIT_RELOCS);
        }
      else if (((1ULL << which_alternative) & 0x18ULL))
        {
	  return 
#line 208 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS);
        }
      else
        {
	  return 1;
        }

    case 213:  /* *movsi */
      extract_constrain_insn_cached (insn);
      if (!((1ULL << which_alternative) & 0x3fULL))
        {
	  return 
#line 206 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_ABI_OPEN_VMS);
        }
      else
        {
	  return 1;
        }

    case 211:  /* *movdf */
    case 210:  /* *movsf */
      extract_constrain_insn_cached (insn);
      if (!((1ULL << which_alternative) & 0x3fULL))
        {
	  return 
#line 204 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_FIX);
        }
      else
        {
	  return 1;
        }

    case 52:  /* zero_extendhidi2 */
    case 51:  /* zero_extendhisi2 */
    case 50:  /* zero_extendqidi2 */
    case 49:  /* zero_extendqisi2 */
    case 48:  /* zero_extendqihi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative != 0)
        {
	  return 
#line 202 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_BWX);
        }
      else
        {
	  return 1;
        }

    case 110:  /* addsf3 */
    case 111:  /* adddf3 */
    case 114:  /* subsf3 */
    case 115:  /* subdf3 */
    case 119:  /* mulsf3 */
    case 120:  /* muldf3 */
    case 123:  /* divsf3 */
    case 124:  /* divdf3 */
    case 128:  /* sqrtsf2 */
    case 129:  /* sqrtdf2 */
    case 133:  /* *fix_truncdfdi2 */
    case 136:  /* *fix_truncsfdi2 */
    case 137:  /* floatdisf2 */
    case 140:  /* floatdidf2 */
    case 145:  /* truncdfsf2 */
    case 175:  /* *cmpdf_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 
#line 2612 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(alpha_fptm < ALPHA_FPTM_SU);
        }
      else
        {
	  return 
(true);
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      extract_constrain_insn_cached (insn);
      if ((cached_isa = get_attr_isa (insn)) == ISA_BWX)
        {
	  return 
#line 202 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_BWX);
        }
      else if (cached_isa == ISA_MAX)
        {
	  return 
#line 203 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_MAX);
        }
      else if (cached_isa == ISA_FIX)
        {
	  return 
#line 204 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_FIX);
        }
      else if (cached_isa == ISA_CIX)
        {
	  return 
#line 205 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_CIX);
        }
      else if (cached_isa == ISA_VMS)
        {
	  return 
#line 206 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_ABI_OPEN_VMS);
        }
      else if (cached_isa == ISA_NER)
        {
	  return 
#line 207 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(!TARGET_EXPLICIT_RELOCS);
        }
      else if (cached_isa == ISA_ER)
        {
	  return 
#line 208 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS);
        }
      else
        {
	  return 1;
        }

    default:
      return 1;

    }
}

enum attr_isa
get_attr_isa (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 231:  /* *movv2si_fix */
    case 230:  /* *movv4hi_fix */
    case 229:  /* *movv8qi_fix */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7fULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_FIX;
        }

    case 224:  /* *movhi */
    case 223:  /* *movqi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_BWX;
        }

    case 220:  /* *movdi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return ISA_BASE;
        }
      else if (((1ULL << which_alternative) & 0x18ULL))
        {
	  return ISA_ER;
        }
      else if (which_alternative == 5)
        {
	  return ISA_BASE;
        }
      else if (which_alternative == 6)
        {
	  return ISA_NER;
        }
      else if (((1ULL << which_alternative) & 0xf80ULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_FIX;
        }

    case 213:  /* *movsi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_VMS;
        }

    case 211:  /* *movdf */
    case 210:  /* *movsf */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_FIX;
        }

    case 48:  /* zero_extendqihi2 */
    case 49:  /* zero_extendqisi2 */
    case 50:  /* zero_extendqidi2 */
    case 51:  /* zero_extendhisi2 */
    case 52:  /* zero_extendhidi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return ISA_BASE;
        }
      else
        {
	  return ISA_BWX;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return ISA_BASE;

    }
}

enum attr_opsize
get_attr_opsize (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 39:  /* umuldi3_highpart */
      return OPSIZE_UDI;

    case 34:  /* mulsi3 */
    case 36:  /* *mulsi_se */
    case 37:  /* mulvsi3 */
    case 123:  /* divsf3 */
    case 128:  /* sqrtsf2 */
      return OPSIZE_SI;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return OPSIZE_DI;

    }
}

enum attr_round_suffix
get_attr_round_suffix (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 133:  /* *fix_truncdfdi2 */
    case 136:  /* *fix_truncsfdi2 */
      return ROUND_SUFFIX_C;

    case 110:  /* addsf3 */
    case 111:  /* adddf3 */
    case 112:  /* *adddf_ext1 */
    case 113:  /* *adddf_ext2 */
    case 114:  /* subsf3 */
    case 115:  /* subdf3 */
    case 116:  /* *subdf_ext1 */
    case 117:  /* *subdf_ext2 */
    case 118:  /* *subdf_ext3 */
    case 119:  /* mulsf3 */
    case 120:  /* muldf3 */
    case 121:  /* *muldf_ext1 */
    case 122:  /* *muldf_ext2 */
    case 123:  /* divsf3 */
    case 124:  /* divdf3 */
    case 125:  /* *divdf_ext1 */
    case 126:  /* *divdf_ext2 */
    case 127:  /* *divdf_ext3 */
    case 128:  /* sqrtsf2 */
    case 129:  /* sqrtdf2 */
    case 137:  /* floatdisf2 */
    case 140:  /* floatdidf2 */
    case 145:  /* truncdfsf2 */
      return ROUND_SUFFIX_NORMAL;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return ROUND_SUFFIX_NONE;

    }
}

enum attr_trap_suffix
get_attr_trap_suffix (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 110:  /* addsf3 */
    case 111:  /* adddf3 */
    case 112:  /* *adddf_ext1 */
    case 113:  /* *adddf_ext2 */
    case 114:  /* subsf3 */
    case 115:  /* subdf3 */
    case 116:  /* *subdf_ext1 */
    case 117:  /* *subdf_ext2 */
    case 118:  /* *subdf_ext3 */
    case 119:  /* mulsf3 */
    case 120:  /* muldf3 */
    case 121:  /* *muldf_ext1 */
    case 122:  /* *muldf_ext2 */
    case 123:  /* divsf3 */
    case 124:  /* divdf3 */
    case 125:  /* *divdf_ext1 */
    case 126:  /* *divdf_ext2 */
    case 127:  /* *divdf_ext3 */
    case 128:  /* sqrtsf2 */
    case 129:  /* sqrtdf2 */
    case 145:  /* truncdfsf2 */
      return TRAP_SUFFIX_U_SU_SUI;

    case 133:  /* *fix_truncdfdi2 */
    case 136:  /* *fix_truncsfdi2 */
      return TRAP_SUFFIX_V_SV_SVI;

    case 130:  /* *cvtql */
      return TRAP_SUFFIX_V_SV;

    case 137:  /* floatdisf2 */
    case 140:  /* floatdidf2 */
      return TRAP_SUFFIX_SUI;

    case 175:  /* *cmpdf_internal */
    case 176:  /* *cmpdf_ext1 */
    case 177:  /* *cmpdf_ext2 */
    case 178:  /* *cmpdf_ext3 */
      return TRAP_SUFFIX_SU;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return TRAP_SUFFIX_NONE;

    }
}

enum attr_trap
get_attr_trap (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 110:  /* addsf3 */
    case 111:  /* adddf3 */
    case 112:  /* *adddf_ext1 */
    case 113:  /* *adddf_ext2 */
    case 114:  /* subsf3 */
    case 115:  /* subdf3 */
    case 116:  /* *subdf_ext1 */
    case 117:  /* *subdf_ext2 */
    case 118:  /* *subdf_ext3 */
    case 119:  /* mulsf3 */
    case 120:  /* muldf3 */
    case 121:  /* *muldf_ext1 */
    case 122:  /* *muldf_ext2 */
    case 123:  /* divsf3 */
    case 124:  /* divdf3 */
    case 125:  /* *divdf_ext1 */
    case 126:  /* *divdf_ext2 */
    case 127:  /* *divdf_ext3 */
    case 128:  /* sqrtsf2 */
    case 129:  /* sqrtdf2 */
    case 130:  /* *cvtql */
    case 131:  /* *fix_truncdfsi_ieee */
    case 132:  /* *fix_truncdfsi_internal */
    case 133:  /* *fix_truncdfdi2 */
    case 134:  /* *fix_truncsfsi_ieee */
    case 135:  /* *fix_truncsfsi_internal */
    case 136:  /* *fix_truncsfdi2 */
    case 137:  /* floatdisf2 */
    case 140:  /* floatdidf2 */
    case 143:  /* *extendsfdf2_ieee */
    case 145:  /* truncdfsf2 */
    case 175:  /* *cmpdf_internal */
    case 176:  /* *cmpdf_ext1 */
    case 177:  /* *cmpdf_ext2 */
    case 178:  /* *cmpdf_ext3 */
      return TRAP_YES;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return TRAP_NO;

    }
}

enum attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 281:  /* *builtin_zap_1 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return TYPE_SHIFT;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_ILOG;
        }
      else
        {
	  return TYPE_SHIFT;
        }

    case 220:  /* *movdi */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ILOG;
        }
      else if (((1ULL << which_alternative) & 0xeULL))
        {
	  return TYPE_IADD;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_LDSYM;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_MULTI;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_LDSYM;
        }
      else if (which_alternative == 7)
        {
	  return TYPE_ILD;
        }
      else if (which_alternative == 8)
        {
	  return TYPE_IST;
        }
      else if (which_alternative == 9)
        {
	  return TYPE_FCPYS;
        }
      else if (which_alternative == 10)
        {
	  return TYPE_FLD;
        }
      else if (which_alternative == 11)
        {
	  return TYPE_FST;
        }
      else if (which_alternative == 12)
        {
	  return TYPE_FTOI;
        }
      else
        {
	  return TYPE_ITOF;
        }

    case 213:  /* *movsi */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ILOG;
        }
      else if (((1ULL << which_alternative) & 0x6ULL))
        {
	  return TYPE_IADD;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_MULTI;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_ILD;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_IST;
        }
      else
        {
	  return TYPE_LDSYM;
        }

    case 47:  /* anddi3 */
    case 46:  /* *andsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return TYPE_ILOG;
        }
      else
        {
	  return TYPE_SHIFT;
        }

    case 2:  /* *extendsidi2_1 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_IADD;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_ILD;
        }
      else
        {
	  return TYPE_FLD;
        }

    case 48:  /* zero_extendqihi2 */
    case 49:  /* zero_extendqisi2 */
    case 50:  /* zero_extendqidi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ILOG;
        }
      else
        {
	  return TYPE_ILD;
        }

    case 51:  /* zero_extendhisi2 */
    case 52:  /* zero_extendhidi2 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_SHIFT;
        }
      else
        {
	  return TYPE_ILD;
        }

    case 69:  /* ashldi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_IADD;
        }
      else
        {
	  return TYPE_SHIFT;
        }

    case 144:  /* *extendsfdf2_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_FCPYS;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_FLD;
        }
      else
        {
	  return TYPE_FST;
        }

    case 210:  /* *movsf */
    case 211:  /* *movdf */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_FCPYS;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_FLD;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_ILOG;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_ILD;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_FST;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_IST;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_ITOF;
        }
      else
        {
	  return TYPE_FTOI;
        }

    case 223:  /* *movqi */
    case 224:  /* *movhi */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ILOG;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_IADD;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_ILD;
        }
      else
        {
	  return TYPE_IST;
        }

    case 229:  /* *movv8qi_fix */
    case 230:  /* *movv4hi_fix */
    case 231:  /* *movv2si_fix */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ILOG;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_MULTI;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_ILD;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_IST;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_FCPYS;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_FLD;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_FST;
        }
      else if (which_alternative == 7)
        {
	  return TYPE_FTOI;
        }
      else
        {
	  return TYPE_ITOF;
        }

    case 201:  /* blockage */
      return TYPE_NONE;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 261:  /* prologue_stack_probe_loop */
    case 267:  /* prologue_mcount */
    case 270:  /* *builtin_setjmp_receiver_1 */
    case 273:  /* *exception_receiver_1 */
    case 296:  /* *atomic_compare_and_swapsi */
    case 297:  /* *atomic_compare_and_swapdi */
    case 298:  /* atomic_compare_and_swapqi_1 */
    case 299:  /* atomic_compare_and_swaphi_1 */
    case 300:  /* atomic_exchangesi */
    case 301:  /* atomic_exchangedi */
    case 302:  /* atomic_exchangeqi_1 */
    case 303:  /* atomic_exchangehi_1 */
    case 304:  /* atomic_addsi */
    case 305:  /* atomic_subsi */
    case 306:  /* atomic_orsi */
    case 307:  /* atomic_xorsi */
    case 308:  /* atomic_andsi */
    case 309:  /* atomic_adddi */
    case 310:  /* atomic_subdi */
    case 311:  /* atomic_ordi */
    case 312:  /* atomic_xordi */
    case 313:  /* atomic_anddi */
    case 314:  /* atomic_nandsi */
    case 315:  /* atomic_nanddi */
    case 316:  /* atomic_fetch_addsi */
    case 317:  /* atomic_fetch_subsi */
    case 318:  /* atomic_fetch_orsi */
    case 319:  /* atomic_fetch_xorsi */
    case 320:  /* atomic_fetch_andsi */
    case 321:  /* atomic_fetch_adddi */
    case 322:  /* atomic_fetch_subdi */
    case 323:  /* atomic_fetch_ordi */
    case 324:  /* atomic_fetch_xordi */
    case 325:  /* atomic_fetch_anddi */
    case 326:  /* atomic_fetch_nandsi */
    case 327:  /* atomic_fetch_nanddi */
    case 328:  /* atomic_add_fetchsi */
    case 329:  /* atomic_sub_fetchsi */
    case 330:  /* atomic_or_fetchsi */
    case 331:  /* atomic_xor_fetchsi */
    case 332:  /* atomic_and_fetchsi */
    case 333:  /* atomic_add_fetchdi */
    case 334:  /* atomic_sub_fetchdi */
    case 335:  /* atomic_or_fetchdi */
    case 336:  /* atomic_xor_fetchdi */
    case 337:  /* atomic_and_fetchdi */
    case 338:  /* atomic_nand_fetchsi */
    case 339:  /* atomic_nand_fetchdi */
      return TYPE_MULTI;

    case 294:  /* store_conditional_si */
    case 295:  /* store_conditional_di */
      return TYPE_ST_C;

    case 292:  /* load_locked_si */
    case 293:  /* load_locked_di */
      return TYPE_LD_L;

    case 291:  /* *memory_barrier */
      return TYPE_MB;

    case 66:  /* clzdi2 */
    case 67:  /* ctzdi2 */
    case 68:  /* popcountdi2 */
    case 161:  /* smaxqi3 */
    case 162:  /* sminqi3 */
    case 163:  /* umaxqi3 */
    case 164:  /* uminqi3 */
    case 165:  /* smaxhi3 */
    case 166:  /* sminhi3 */
    case 167:  /* umaxhi3 */
    case 168:  /* uminhi3 */
    case 232:  /* smaxv8qi3 */
    case 233:  /* sminv8qi3 */
    case 234:  /* umaxv8qi3 */
    case 235:  /* uminv8qi3 */
    case 236:  /* smaxv4hi3 */
    case 237:  /* sminv4hi3 */
    case 238:  /* umaxv4hi3 */
    case 239:  /* uminv4hi3 */
    case 286:  /* builtin_perr */
    case 287:  /* *pklb */
    case 288:  /* *pkwb */
    case 289:  /* *unpkbl */
    case 290:  /* *unpkbw */
      return TYPE_MVI;

    case 275:  /* trapb */
      return TYPE_MISC;

    case 128:  /* sqrtsf2 */
    case 129:  /* sqrtdf2 */
      return TYPE_FSQRT;

    case 123:  /* divsf3 */
    case 124:  /* divdf3 */
    case 125:  /* *divdf_ext1 */
    case 126:  /* *divdf_ext2 */
    case 127:  /* *divdf_ext3 */
      return TYPE_FDIV;

    case 98:  /* abssf2 */
    case 99:  /* absdf2 */
    case 277:  /* fnop */
      return TYPE_FCPYS;

    case 119:  /* mulsf3 */
    case 120:  /* muldf3 */
    case 121:  /* *muldf_ext1 */
    case 122:  /* *muldf_ext2 */
      return TYPE_FMUL;

    case 1:  /* *cvtlq */
    case 100:  /* *nabssf2 */
    case 101:  /* *nabsdf2 */
    case 103:  /* negsf2 */
    case 104:  /* negdf2 */
    case 106:  /* copysignsf3 */
    case 107:  /* copysigndf3 */
    case 108:  /* *ncopysignsf3 */
    case 109:  /* *ncopysigndf3 */
    case 110:  /* addsf3 */
    case 111:  /* adddf3 */
    case 112:  /* *adddf_ext1 */
    case 113:  /* *adddf_ext2 */
    case 114:  /* subsf3 */
    case 115:  /* subdf3 */
    case 116:  /* *subdf_ext1 */
    case 117:  /* *subdf_ext2 */
    case 118:  /* *subdf_ext3 */
    case 130:  /* *cvtql */
    case 131:  /* *fix_truncdfsi_ieee */
    case 132:  /* *fix_truncdfsi_internal */
    case 133:  /* *fix_truncdfdi2 */
    case 134:  /* *fix_truncsfsi_ieee */
    case 135:  /* *fix_truncsfsi_internal */
    case 136:  /* *fix_truncsfdi2 */
    case 137:  /* floatdisf2 */
    case 140:  /* floatdidf2 */
    case 143:  /* *extendsfdf2_ieee */
    case 145:  /* truncdfsf2 */
    case 175:  /* *cmpdf_internal */
    case 176:  /* *cmpdf_ext1 */
    case 177:  /* *cmpdf_ext2 */
    case 178:  /* *cmpdf_ext3 */
      return TYPE_FADD;

    case 34:  /* mulsi3 */
    case 35:  /* muldi3 */
    case 36:  /* *mulsi_se */
    case 37:  /* mulvsi3 */
    case 38:  /* mulvdi3 */
    case 39:  /* umuldi3_highpart */
      return TYPE_IMUL;

    case 146:  /* *setcc_internal */
    case 147:  /* *setcc_swapped_internal */
    case 148:  /* *setne_internal */
    case 280:  /* builtin_cmpbge */
      return TYPE_ICMP;

    case 179:  /* *movsfcc_internal */
    case 180:  /* *movdfcc_internal */
    case 181:  /* *movdfcc_ext1 */
    case 182:  /* *movdfcc_ext2 */
    case 183:  /* *movdfcc_ext3 */
    case 184:  /* *movdfcc_ext4 */
      return TYPE_FCMOV;

    case 149:  /* *movqicc_internal */
    case 150:  /* *movhicc_internal */
    case 151:  /* *movsicc_internal */
    case 152:  /* *movdicc_internal */
    case 153:  /* *movqicc_lbc */
    case 154:  /* *movhicc_lbc */
    case 155:  /* *movsicc_lbc */
    case 156:  /* *movdicc_lbc */
    case 157:  /* *movqicc_lbs */
    case 158:  /* *movhicc_lbs */
    case 159:  /* *movsicc_lbs */
    case 160:  /* *movdicc_lbs */
    case 169:  /* *smax_const0 */
    case 170:  /* *smin_const0 */
      return TYPE_ICMOV;

    case 53:  /* zero_extendsidi2 */
    case 72:  /* lshrdi3 */
    case 73:  /* ashrdi3 */
    case 74:  /* extendqihi2 */
    case 75:  /* extendqisi2 */
    case 76:  /* *extendqidi2_bwx */
    case 77:  /* extendhisi2 */
    case 78:  /* *extendhidi2_bwx */
    case 79:  /* *extxl_const */
    case 80:  /* extxl */
    case 81:  /* *extxl_1 */
    case 82:  /* *extql_2 */
    case 83:  /* extqh */
    case 84:  /* extwh */
    case 85:  /* extlh */
    case 86:  /* insbl_const */
    case 87:  /* inswl_const */
    case 88:  /* insll_const */
    case 89:  /* insbl */
    case 90:  /* inswl */
    case 91:  /* insll */
    case 92:  /* insql */
    case 93:  /* *insxl */
    case 94:  /* insxh */
    case 95:  /* mskxl */
    case 96:  /* mskxh */
    case 282:  /* *builtin_zapnot_1 */
      return TYPE_SHIFT;

    case 54:  /* andnotsi3 */
    case 55:  /* andnotdi3 */
    case 56:  /* *iorsi_internal */
    case 57:  /* iordi3 */
    case 58:  /* *one_cmplsi_internal */
    case 59:  /* one_cmpldi2 */
    case 60:  /* *iornotsi3 */
    case 61:  /* *iornotdi3 */
    case 62:  /* *xorsi_internal */
    case 63:  /* xordi3 */
    case 64:  /* *xornotsi3 */
    case 65:  /* *xornotdi3 */
    case 221:  /* force_movdi */
    case 240:  /* one_cmplv8qi2 */
    case 241:  /* one_cmplv4hi2 */
    case 242:  /* one_cmplv2si2 */
    case 243:  /* andv8qi3 */
    case 244:  /* andv4hi3 */
    case 245:  /* andv2si3 */
    case 246:  /* *andnotv8qi3 */
    case 247:  /* *andnotv4hi3 */
    case 248:  /* *andnotv2si3 */
    case 249:  /* iorv8qi3 */
    case 250:  /* iorv4hi3 */
    case 251:  /* iorv2si3 */
    case 252:  /* *iornotv8qi3 */
    case 253:  /* *iornotv4hi3 */
    case 254:  /* *iornotv2si3 */
    case 255:  /* xorv8qi3 */
    case 256:  /* xorv4hi3 */
    case 257:  /* xorv2si3 */
    case 258:  /* *xornotv8qi3 */
    case 259:  /* *xornotv4hi3 */
    case 260:  /* *xornotv2si3 */
    case 276:  /* nop */
    case 283:  /* builtin_amask */
    case 284:  /* builtin_implver */
    case 285:  /* builtin_rpcc */
      return TYPE_ILOG;

    case 40:  /* *divmodsi_internal_er */
    case 41:  /* *divmodsi_internal_er_1 */
    case 42:  /* *divmodsi_internal */
    case 43:  /* *divmoddi_internal_er */
    case 44:  /* *divmoddi_internal_er_1 */
    case 45:  /* *divmoddi_internal */
    case 193:  /* *call_osf_1_er_noreturn */
    case 194:  /* *call_osf_1_er */
    case 195:  /* *call_osf_2_er_nogp */
    case 196:  /* *call_osf_2_er */
    case 197:  /* *call_osf_1_noreturn */
    case 198:  /* *call_osf_1 */
    case 199:  /* *sibcall_osf_1_er */
    case 200:  /* *sibcall_osf_1 */
    case 340:  /* *call_value_osf_1_er_noreturn */
    case 341:  /* *call_value_osf_1_er */
    case 342:  /* *call_value_osf_2_er_nogp */
    case 343:  /* *call_value_osf_2_er */
    case 344:  /* *call_value_osf_1_noreturn */
    case 345:  /* call_value_osf_tlsgd */
    case 346:  /* call_value_osf_tlsldm */
    case 347:  /* *call_value_osf_1 */
    case 348:  /* *sibcall_value_osf_1_er */
    case 349:  /* *sibcall_value_osf_1 */
      return TYPE_JSR;

    case 185:  /* *fbcc_normal */
    case 186:  /* *fbcc_ext_normal */
      return TYPE_FBR;

    case 206:  /* imb */
    case 207:  /* trap */
    case 208:  /* get_thread_pointerdi */
    case 209:  /* *set_tp */
      return TYPE_CALLPAL;

    case 171:  /* *bcc_normal */
    case 172:  /* *bcc_reverse */
    case 173:  /* *blbs_normal */
    case 174:  /* *blbc_normal */
    case 202:  /* jump */
    case 203:  /* *return_internal */
    case 204:  /* indirect_jump */
    case 205:  /* *tablejump_internal */
    case 269:  /* builtin_longjmp_internal */
      return TYPE_IBR;

    case 215:  /* movdi_er_high_g */
      return TYPE_LDSYM;

    case 218:  /* *movdi_er_gotdtp */
    case 219:  /* *movdi_er_gottp */
    case 272:  /* *exception_receiver_2 */
    case 274:  /* prefetch */
      return TYPE_ILD;

    default:
      return TYPE_IADD;

    }
}

enum attr_usegp
get_attr_usegp (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 274:  /* prefetch */
    case 272:  /* *exception_receiver_2 */
      extract_constrain_insn_cached (insn);
      return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));

    case 231:  /* *movv2si_fix */
    case 230:  /* *movv4hi_fix */
    case 229:  /* *movv8qi_fix */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x6cULL))
        {
	  return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));
        }
      else
        {
	  return USEGP_NO;
        }

    case 224:  /* *movhi */
    case 223:  /* *movqi */
      extract_constrain_insn_cached (insn);
      if (!((1ULL << which_alternative) & 0x3ULL))
        {
	  return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));
        }
      else
        {
	  return USEGP_NO;
        }

    case 220:  /* *movdi */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return USEGP_NO;
        }
      else if (which_alternative == 3)
        {
	  return USEGP_YES;
        }
      else
        {
	  if (((1ULL << which_alternative) & 0x50ULL))
	    {
	      return USEGP_YES;
	    }
	  else if (((1ULL << which_alternative) & 0xd80ULL))
	    {
	      return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));
	    }
	  else
	    {
	      return USEGP_NO;
	    }
        }

    case 213:  /* *movsi */
      extract_constrain_insn_cached (insn);
      if (!((1ULL << which_alternative) & 0x3fULL))
        {
	  return USEGP_YES;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));
        }
      else
        {
	  return USEGP_NO;
        }

    case 211:  /* *movdf */
    case 210:  /* *movsf */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3aULL))
        {
	  return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));
        }
      else
        {
	  return USEGP_NO;
        }

    case 144:  /* *extendsfdf2_internal */
    case 52:  /* zero_extendhidi2 */
    case 51:  /* zero_extendhisi2 */
    case 50:  /* zero_extendqidi2 */
    case 49:  /* zero_extendqisi2 */
    case 48:  /* zero_extendqihi2 */
    case 2:  /* *extendsidi2_1 */
      extract_constrain_insn_cached (insn);
      if (which_alternative != 0)
        {
	  return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));
        }
      else
        {
	  return USEGP_NO;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      extract_constrain_insn_cached (insn);
      if (((cached_type = get_attr_type (insn)) == TYPE_LDSYM) || (cached_type == TYPE_JSR))
        {
	  return USEGP_YES;
        }
      else if ((cached_type == TYPE_ILD) || (cached_type == TYPE_FLD) || (cached_type == TYPE_IST) || (cached_type == TYPE_FST))
        {
	  return 
#line 182 "../../gcc-14.1.1-20240508/gcc/config/alpha/alpha.md"
(((enum attr_usegp) alpha_find_lo_sum_using_gp (insn)));
        }
      else
        {
	  return USEGP_NO;
        }

    case 349:  /* *sibcall_value_osf_1 */
    case 348:  /* *sibcall_value_osf_1_er */
    case 347:  /* *call_value_osf_1 */
    case 346:  /* call_value_osf_tlsldm */
    case 345:  /* call_value_osf_tlsgd */
    case 344:  /* *call_value_osf_1_noreturn */
    case 343:  /* *call_value_osf_2_er */
    case 342:  /* *call_value_osf_2_er_nogp */
    case 341:  /* *call_value_osf_1_er */
    case 340:  /* *call_value_osf_1_er_noreturn */
    case 215:  /* movdi_er_high_g */
    case 200:  /* *sibcall_osf_1 */
    case 199:  /* *sibcall_osf_1_er */
    case 198:  /* *call_osf_1 */
    case 197:  /* *call_osf_1_noreturn */
    case 196:  /* *call_osf_2_er */
    case 195:  /* *call_osf_2_er_nogp */
    case 194:  /* *call_osf_1_er */
    case 193:  /* *call_osf_1_er_noreturn */
    case 45:  /* *divmoddi_internal */
    case 44:  /* *divmoddi_internal_er_1 */
    case 43:  /* *divmoddi_internal_er */
    case 42:  /* *divmodsi_internal */
    case 41:  /* *divmodsi_internal_er_1 */
    case 40:  /* *divmodsi_internal_er */
    case 12:  /* *adddi_er_high_l */
    case 214:  /* *movdi_er_low_l */
    case 218:  /* *movdi_er_gotdtp */
    case 219:  /* *movdi_er_gottp */
      return USEGP_YES;

    default:
      return USEGP_NO;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 2;
