/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2238 */
rtx
gen_mul64 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (gen_rtx_REG (DImode,
	58),
	gen_rtx_MULT (DImode,
	gen_rtx_SIGN_EXTEND (DImode,
	operand0),
	gen_rtx_SIGN_EXTEND (DImode,
	operand1)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2251 */
rtx
gen_umulsidi_600 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	gen_rtx_ZERO_EXTEND (DImode,
	operand2))),
		gen_hard_reg_clobber (DImode, 58)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2273 */
rtx
gen_mulu64 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (gen_rtx_REG (DImode,
	58),
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand0),
	gen_rtx_ZERO_EXTEND (DImode,
	operand1)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2294 */
rtx
gen_mulsi3_700 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2307 */
rtx
gen_mulsi3_v2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2371 */
rtx
gen_mulsidi64 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_MULT (DImode,
	gen_rtx_SIGN_EXTEND (DImode,
	operand1),
	gen_rtx_SIGN_EXTEND (DImode,
	operand2))),
		gen_hard_reg_clobber (DImode, 56)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2393 */
rtx
gen_mul64_600 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (gen_rtx_REG (DImode,
	56),
	gen_rtx_MULT (DImode,
	gen_rtx_SIGN_EXTEND (DImode,
	operand0),
	gen_rtx_ZERO_EXTRACT (DImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)],
	const0_rtx)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2411 */
rtx
gen_mac64_600 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (DImode,
	56),
	gen_rtx_PLUS (DImode,
	gen_rtx_MULT (DImode,
	gen_rtx_SIGN_EXTEND (DImode,
	operand1),
	gen_rtx_ASHIFT (DImode,
	gen_rtx_SIGN_EXTRACT (DImode,
	operand2,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)],
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)])),
	gen_rtx_REG (DImode,
	56))),
		gen_rtx_SET (operand0,
	gen_rtx_ZERO_EXTRACT (SImode,
	gen_rtx_PLUS (DImode,
	gen_rtx_MULT (DImode,
	gen_rtx_SIGN_EXTEND (DImode,
	copy_rtx (operand1)),
	gen_rtx_ASHIFT (DImode,
	gen_rtx_SIGN_EXTRACT (DImode,
	copy_rtx (operand2),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)],
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)])),
	gen_rtx_REG (DImode,
	56)),
	const_int_rtx[MAX_SAVED_CONST_INT + (32)],
	const_int_rtx[MAX_SAVED_CONST_INT + (32)]))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2439 */
rtx
gen_mulsidi3_700 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (DImode,
	gen_rtx_SIGN_EXTEND (DImode,
	operand1),
	gen_rtx_SIGN_EXTEND (DImode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2459 */
rtx
gen_mulsi3_highpart (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (SImode,
	gen_rtx_LSHIFTRT (DImode,
	gen_rtx_MULT (DImode,
	gen_rtx_SIGN_EXTEND (DImode,
	operand1),
	gen_rtx_SIGN_EXTEND (DImode,
	operand2)),
	const_int_rtx[MAX_SAVED_CONST_INT + (32)])));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2494 */
rtx
gen_umulsi3_highpart_int (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (SImode,
	gen_rtx_LSHIFTRT (DImode,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	operand2),
	const_int_rtx[MAX_SAVED_CONST_INT + (32)])));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2584 */
rtx
gen_umulsidi64 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	gen_rtx_ZERO_EXTEND (DImode,
	operand2))),
		gen_hard_reg_clobber (DImode, 56)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2608 */
rtx
gen_umul64_600 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (gen_rtx_REG (DImode,
	56),
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand0),
	gen_rtx_ZERO_EXTRACT (DImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)],
	const0_rtx)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2625 */
rtx
gen_umac64_600 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (DImode,
	56),
	gen_rtx_PLUS (DImode,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	gen_rtx_ASHIFT (DImode,
	gen_rtx_ZERO_EXTRACT (DImode,
	operand2,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)],
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)])),
	gen_rtx_REG (DImode,
	56))),
		gen_rtx_SET (operand0,
	gen_rtx_ZERO_EXTRACT (SImode,
	gen_rtx_PLUS (DImode,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	copy_rtx (operand1)),
	gen_rtx_ASHIFT (DImode,
	gen_rtx_ZERO_EXTRACT (DImode,
	copy_rtx (operand2),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)],
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)])),
	gen_rtx_REG (DImode,
	56)),
	const_int_rtx[MAX_SAVED_CONST_INT + (32)],
	const_int_rtx[MAX_SAVED_CONST_INT + (32)]))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2652 */
rtx
gen_umulsidi3_700 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	gen_rtx_ZERO_EXTEND (DImode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2737 */
rtx
gen_add_f (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CC_Cmode,
	61),
	gen_rtx_COMPARE (CC_Cmode,
	gen_rtx_PLUS (SImode,
	operand1,
	operand2),
	copy_rtx (operand1))),
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	copy_rtx (operand1),
	copy_rtx (operand2)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2772 */
rtx
gen_adc (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx),
	operand1),
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2792 */
rtx
gen_adc_f (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CC_Cmode,
	61),
	gen_rtx_COMPARE (CC_Cmode,
	gen_rtx_ZERO_EXTEND (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx),
	operand1),
	operand2)),
	gen_rtx_PLUS (DImode,
	gen_rtx_LTU (DImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx),
	gen_rtx_ZERO_EXTEND (DImode,
	copy_rtx (operand1))))),
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx),
	copy_rtx (operand1)),
	copy_rtx (operand2)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2888 */
rtx
gen_subsi3_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2962 */
rtx
gen_sbc (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MINUS (SImode,
	gen_rtx_MINUS (SImode,
	operand1,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx)),
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:2982 */
rtx
gen_sub_f (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCmode,
	61),
	gen_rtx_COMPARE (CCmode,
	operand1,
	operand2)),
		gen_rtx_SET (operand0,
	gen_rtx_MINUS (SImode,
	copy_rtx (operand1),
	copy_rtx (operand2)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3192 */
rtx
gen_andsi3_i (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_AND (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3293 */
rtx
gen_iorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3327 */
rtx
gen_xorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3351 */
rtx
gen_negsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NEG (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3360 */
rtx
gen_one_cmplsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3368 */
rtx
gen_one_cmpldi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (DImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3453 */
rtx
gen_rotlsi2_cnt16 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ROTATE (SImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3453 */
rtx
gen_rotrsi2_cnt16 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ROTATERT (SImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3462 */
rtx
gen_ashlsi2_cnt16 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3473 */
rtx
gen_lshrsi2_cnt16 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3516 */
rtx
gen_ashlsi3_loop (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2)),
		gen_hard_reg_clobber (SImode, 60),
		gen_hard_reg_clobber (CCmode, 61)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3516 */
rtx
gen_ashrsi3_loop (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2)),
		gen_hard_reg_clobber (SImode, 60),
		gen_hard_reg_clobber (CCmode, 61)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3516 */
rtx
gen_lshrsi3_loop (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2)),
		gen_hard_reg_clobber (SImode, 60),
		gen_hard_reg_clobber (CCmode, 61)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3516 */
rtx
gen_rotlsi3_loop (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_ROTATE (SImode,
	operand1,
	operand2)),
		gen_hard_reg_clobber (SImode, 60),
		gen_hard_reg_clobber (CCmode, 61)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3516 */
rtx
gen_rotrsi3_loop (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_ROTATERT (SImode,
	operand1,
	operand2)),
		gen_hard_reg_clobber (SImode, 60),
		gen_hard_reg_clobber (CCmode, 61)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3621 */
rtx
gen_rotrsi3_insn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ROTATERT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3662 */
rtx
gen_rrcsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	const1_rtx),
	gen_rtx_ASHIFT (SImode,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx),
	const_int_rtx[MAX_SAVED_CONST_INT + (31)])));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3675 */
rtx
gen_rrcsi2_carry (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CC_Cmode,
	61),
	gen_rtx_UNSPEC (CC_Cmode,
	gen_rtvec (1,
		gen_rtx_AND (SImode,
	operand1,
	const1_rtx)),
	33)),
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	gen_rtx_LSHIFTRT (SImode,
	copy_rtx (operand1),
	const1_rtx),
	gen_rtx_ASHIFT (SImode,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx),
	const_int_rtx[MAX_SAVED_CONST_INT + (31)])))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3780 */
rtx
gen_cmpsi_cc_insn_mixed (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (gen_rtx_REG (CCmode,
	61),
	gen_rtx_COMPARE (CCmode,
	operand0,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3895 */
rtx
gen_scc_ltu_cc_c (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CC_Cmode,
	61),
	const0_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:3895 */
rtx
gen_scc_ltu_cc (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LTU (SImode,
	gen_rtx_REG (CCmode,
	61),
	const0_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4108 */
rtx
gen_jump_i (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4136 */
rtx
gen_indirect_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	operand0);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4185 */
rtx
gen_casesi_dispatch (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand0,
		gen_rtx_LABEL_REF (VOIDmode,
	operand1)),
	16));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4208 */
rtx
gen_casesi_load (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_MEM (SImode,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	16))),
		gen_rtx_USE (VOIDmode,
	gen_rtx_LABEL_REF (VOIDmode,
	operand3))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4268 */
rtx
gen_casesi_jump (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	operand0),
		gen_rtx_USE (VOIDmode,
	gen_rtx_LABEL_REF (VOIDmode,
	operand1))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4370 */
rtx
gen_trap (void)
{
  return gen_rtx_TRAP_IF (VOIDmode,
	const1_rtx,
	const0_rtx);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4377 */
rtx
gen_nop (void)
{
  return const0_rtx;
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4386 */
rtx
gen_nopv (void)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	49);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4394 */
rtx
gen_blockage (void)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	58);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4402 */
rtx
gen_arc600_stall (void)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	61);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4545 */
rtx
gen_clrsbsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CLRSB (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4553 */
rtx
gen_norm_f (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_CLRSB (SImode,
	operand1)),
		gen_rtx_SET (gen_rtx_REG (CC_ZNmode,
	61),
	gen_rtx_COMPARE (CC_ZNmode,
	copy_rtx (operand1),
	const0_rtx))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4563 */
rtx
gen_clrsbhi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CLRSB (HImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4572 */
rtx
gen_normw (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ZERO_EXTEND (SImode,
	gen_rtx_CLRSB (HImode,
	operand1)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4640 */
rtx
gen_arc_ctzsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_CTZ (SImode,
	operand1)),
		gen_hard_reg_clobber (CC_ZNmode, 61),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4676 */
rtx
gen_divaw (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		gen_rtx_DIV (SImode,
	operand1,
	operand2)),
	13));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4689 */
rtx
gen_flag (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	37);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4702 */
rtx
gen_brk (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	36);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4710 */
rtx
gen_rtie (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		ret_rtx,
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	34)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4719 */
rtx
gen_sync (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	35);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4727 */
rtx
gen_swi (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	39);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4742 */
rtx
gen_sleep (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	38);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4750 */
rtx
gen_core_read (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC_VOLATILE (SImode,
	gen_rtvec (1,
		operand1),
	40));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4763 */
rtx
gen_core_write (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (2,
		operand0,
		operand1),
	41);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4776 */
rtx
gen_lr (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC_VOLATILE (SImode,
	gen_rtvec (1,
		operand1),
	42));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4785 */
rtx
gen_sr (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (2,
		operand0,
		operand1),
	43);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4797 */
rtx
gen_lddiqi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC_VOLATILE (QImode,
	gen_rtvec (1,
		operand1),
	62));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4797 */
rtx
gen_lddihi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (1,
		operand1),
	62));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4797 */
rtx
gen_lddisi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC_VOLATILE (SImode,
	gen_rtvec (1,
		operand1),
	62));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4797 */
rtx
gen_lddidi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC_VOLATILE (DImode,
	gen_rtvec (1,
		operand1),
	62));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4805 */
rtx
gen_stdiqi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (2,
		operand0,
		operand1),
	63);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4805 */
rtx
gen_stdihi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (2,
		operand0,
		operand1),
	63);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4805 */
rtx
gen_stdisi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (2,
		operand0,
		operand1),
	63);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4805 */
rtx
gen_stdidi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (2,
		operand0,
		operand1),
	63);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4852 */
rtx
gen_trap_s (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	44);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4870 */
rtx
gen_unimp_s (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	45);
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:4994 */
rtx
gen_simple_return (void)
{
  return simple_return_rtx;
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:5003 */
rtx
gen_arc600_rtie (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		ret_rtx,
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	60)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/arc/arc.md:5013 */
rtx
gen_p_return_i (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_fmt_ee (GET_CODE (operand0), VOIDmode,
		gen_rtx_REG (VOIDmode,
	61),
		const0_rtx),
	simple_return_rtx,
	pc_rtx));
}

