/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1065 */
rtx
gen_sub_with_carry (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2)),
		gen_rtx_SET (operand3,
	gen_rtx_LEU (BImode,
	copy_rtx (operand2),
	copy_rtx (operand1)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1189 */
rtx
gen_mulhisi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1197 */
rtx
gen_umulhisi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SImode,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1),
	gen_rtx_ZERO_EXTEND (SImode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1205 */
rtx
gen_usmulhisi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SImode,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1216 */
rtx
gen_addsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1229 */
rtx
gen_ssaddsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_PLUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1237 */
rtx
gen_subsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1261 */
rtx
gen_sssubsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_MINUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1271 */
rtx
gen_addpdi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_PLUS (PDImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1279 */
rtx
gen_sum_of_accumulators (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_SS_TRUNCATE (SImode,
	gen_rtx_SS_PLUS (PDImode,
	operand2,
	operand3))),
		gen_rtx_SET (operand1,
	gen_rtx_SS_PLUS (PDImode,
	copy_rtx (operand2),
	copy_rtx (operand3)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1290 */
rtx
gen_us_truncpdisi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_US_TRUNCATE (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1378 */
rtx
gen_iorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1388 */
rtx
gen_xorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1398 */
rtx
gen_ones (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_POPCOUNT (SImode,
	operand1)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1427 */
rtx
gen_smaxsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SMAX (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1435 */
rtx
gen_sminsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SMIN (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1443 */
rtx
gen_abssi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ABS (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1450 */
rtx
gen_ssabssi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_ABS (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1457 */
rtx
gen_negsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NEG (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1464 */
rtx
gen_ssnegsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_NEG (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1471 */
rtx
gen_one_cmplsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1488 */
rtx
gen_signbitssi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_CLRSB (SImode,
	operand1)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1495 */
rtx
gen_ssroundsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_LSHIFTRT (SImode,
	gen_rtx_SS_PLUS (SImode,
	operand1,
	GEN_INT (32768L)),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)])));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1505 */
rtx
gen_smaxhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SMAX (HImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1513 */
rtx
gen_sminhi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SMIN (HImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1521 */
rtx
gen_abshi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ABS (HImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1528 */
rtx
gen_neghi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NEG (HImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1535 */
rtx
gen_ssneghi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_NEG (HImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1542 */
rtx
gen_clrsbhi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CLRSB (HImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1549 */
rtx
gen_mulsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1689 */
rtx
gen_ashrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1699 */
rtx
gen_rotl16 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ROTATE (SImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1730 */
rtx
gen_ror_one (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_IOR (SImode,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	const1_rtx),
	gen_rtx_ASHIFT (SImode,
	gen_rtx_ZERO_EXTEND (SImode,
	gen_rtx_REG (BImode,
	34)),
	const_int_rtx[MAX_SAVED_CONST_INT + (31)]))),
		gen_rtx_SET (gen_rtx_REG (BImode,
	34),
	gen_rtx_ZERO_EXTRACT (BImode,
	copy_rtx (operand1),
	const1_rtx,
	const0_rtx))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1740 */
rtx
gen_rol_one (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_IOR (SImode,
	gen_rtx_ASHIFT (SImode,
	operand1,
	const1_rtx),
	gen_rtx_ZERO_EXTEND (SImode,
	gen_rtx_REG (BImode,
	34)))),
		gen_rtx_SET (gen_rtx_REG (BImode,
	34),
	gen_rtx_ZERO_EXTRACT (BImode,
	copy_rtx (operand1),
	const1_rtx,
	const_int_rtx[MAX_SAVED_CONST_INT + (31)]))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1814 */
rtx
gen_lshrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1825 */
rtx
gen_lshrpdi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LSHIFTRT (PDImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/bfin/bfin.md:1833 */
rtx
gen_ashrpdi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ASHIFTRT (PDImode,
	operand1,
	operand2));
}

