/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1461 */
rtx
gen_spkernel (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	gen_rtx_UNSPEC_VOLATILE (SImode,
	gen_rtvec (2,
		operand0,
		operand1),
	2),
	const1_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand2),
	pc_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1476 */
rtx
gen_loop_end (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	operand3,
	const1_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1),
	pc_rtx)),
		gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	copy_rtx (operand3),
	constm1_rtx)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (SImode))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1519 */
rtx
gen_real_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		const0_rtx),
	10);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1534 */
rtx
gen_real_call (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		const1_rtx),
	10),
		gen_hard_reg_clobber (SImode, 35)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1547 */
rtx
gen_real_ret (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (2,
		operand0,
		const_int_rtx[MAX_SAVED_CONST_INT + (2)]),
	10);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1560 */
rtx
gen_indirect_jump_shadow (void)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const1_rtx),
	13));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1568 */
rtx
gen_indirect_call_value_shadow (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		pc_rtx),
	13),
	const0_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1576 */
rtx
gen_indirect_sibcall_shadow (void)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		pc_rtx),
	13),
	const0_rtx);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1583 */
rtx
gen_indirect_call_shadow (void)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		pc_rtx),
	13),
	const0_rtx);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1590 */
rtx
gen_call_value_shadow (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand1),
	13),
	const0_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1598 */
rtx
gen_call_shadow (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand0),
	13),
	const0_rtx);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1605 */
rtx
gen_sibcall_shadow (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand0),
	13),
	const0_rtx);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1612 */
rtx
gen_jump_shadow (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand0),
	13));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1618 */
rtx
gen_condjump_shadow (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	13),
	const0_rtx),
	operand0,
	pc_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1628 */
rtx
gen_return_shadow (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	13),
		ret_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1639 */
rtx
gen_addsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1715 */
rtx
gen_subsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1743 */
rtx
gen_addsidi3_widen (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (DImode,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1),
	gen_rtx_ZERO_EXTEND (DImode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1776 */
rtx
gen_addsf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (SFmode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1788 */
rtx
gen_adddf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_PLUS (DFmode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1800 */
rtx
gen_subsf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MINUS (SFmode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1812 */
rtx
gen_subdf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MINUS (DFmode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1828 */
rtx
gen_andsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_AND (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1843 */
rtx
gen_iorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1858 */
rtx
gen_xorsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1872 */
rtx
gen_extendsfdf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_EXTEND (DFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1881 */
rtx
gen_truncdfsf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_TRUNCATE (SFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1891 */
rtx
gen_floatsisf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT (SFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1900 */
rtx
gen_floatunssisf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSIGNED_FLOAT (SFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1909 */
rtx
gen_floatsidf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT (DFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1918 */
rtx
gen_floatunssidf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSIGNED_FLOAT (DFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1927 */
rtx
gen_fix_truncsfsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FIX (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1936 */
rtx
gen_fix_truncdfsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FIX (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1949 */
rtx
gen_saddsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_PLUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1958 */
rtx
gen_ssubsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_MINUS (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:1967 */
rtx
gen_subcsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	21));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2018 */
rtx
gen_call_internal (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (VOIDmode,
	operand0),
	const0_rtx);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2029 */
rtx
gen_call_value_internal (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (VOIDmode,
	operand1),
	const0_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2041 */
rtx
gen_sibcall_internal (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (VOIDmode,
	operand0),
	const0_rtx);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2051 */
rtx
gen_callp (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (VOIDmode,
	operand0),
	const0_rtx),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const_int_rtx[MAX_SAVED_CONST_INT + (6)]),
	0)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2063 */
rtx
gen_callp_value (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (VOIDmode,
	operand1),
	const0_rtx)),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const_int_rtx[MAX_SAVED_CONST_INT + (6)]),
	0)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2076 */
rtx
gen_return_internal (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		ret_rtx,
		gen_rtx_USE (VOIDmode,
	operand0)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2085 */
rtx
gen_addkpc (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	3)),
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		operand2),
	0)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2098 */
rtx
gen_negsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NEG (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2106 */
rtx
gen_one_cmplsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2114 */
rtx
gen_clrsbsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CLRSB (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2122 */
rtx
gen_clzsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CLZ (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2160 */
rtx
gen_ssabssi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_ABS (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2179 */
rtx
gen_ss_ashlsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_SS_ASHIFT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2179 */
rtx
gen_ashlsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2179 */
rtx
gen_ashrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2179 */
rtx
gen_lshrsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2190 */
rtx
gen_rotrdi3_16 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ROTATERT (DImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2199 */
rtx
gen_shlmbsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (SImode,
	gen_rtx_ASHIFT (SImode,
	operand1,
	const_int_rtx[MAX_SAVED_CONST_INT + (8)]),
	gen_rtx_LSHIFTRT (SImode,
	operand2,
	const_int_rtx[MAX_SAVED_CONST_INT + (24)])));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2250 */
rtx
gen_bswapv2hi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_BSWAP (V2HImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2275 */
rtx
gen_divsi3_insn (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (13,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_DIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 37),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2296 */
rtx
gen_divsi3_insn_indcall (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (14,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_DIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 37),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2318 */
rtx
gen_udivsi3_insn (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (12,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_UDIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2338 */
rtx
gen_udivsi3_insn_indcall (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (13,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_UDIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2359 */
rtx
gen_modsi3_insn (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (12,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_MOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 5),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2379 */
rtx
gen_modsi3_insn_indcall (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (13,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_MOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 5),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2400 */
rtx
gen_divmodsi4_insn (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (12,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_DIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_SET (gen_rtx_REG (SImode,
	5),
	gen_rtx_MOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2420 */
rtx
gen_divmodsi4_insn_indcall (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (14,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_DIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_SET (gen_rtx_REG (SImode,
	5),
	gen_rtx_MOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 5),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2442 */
rtx
gen_umodsi3_insn (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (11,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_UMOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 5),
		gen_hard_reg_clobber (SImode, 7),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2461 */
rtx
gen_umodsi3_insn_indcall (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (12,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_UMOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 5),
		gen_hard_reg_clobber (SImode, 7),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2481 */
rtx
gen_udivmodsi4_insn (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (13,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_UDIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_SET (gen_rtx_REG (SImode,
	5),
	gen_rtx_UMOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2502 */
rtx
gen_udivmodsi4_insn_indcall (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (14,
		gen_rtx_SET (gen_rtx_REG (SImode,
	4),
	gen_rtx_UDIV (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_SET (gen_rtx_REG (SImode,
	5),
	gen_rtx_UMOD (SImode,
	gen_rtx_REG (SImode,
	4),
	gen_rtx_REG (SImode,
	36))),
		gen_rtx_USE (VOIDmode,
	operand0),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2524 */
rtx
gen_divmodsi4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (16,
		gen_rtx_SET (operand0,
	gen_rtx_DIV (SImode,
	operand1,
	operand2)),
		gen_rtx_SET (operand3,
	gen_rtx_MOD (SImode,
	copy_rtx (operand1),
	copy_rtx (operand2))),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 4),
		gen_hard_reg_clobber (SImode, 5),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 37),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2597 */
rtx
gen_udivmodsi4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (16,
		gen_rtx_SET (operand0,
	gen_rtx_UDIV (SImode,
	operand1,
	operand2)),
		gen_rtx_SET (operand3,
	gen_rtx_UMOD (SImode,
	copy_rtx (operand1),
	copy_rtx (operand2))),
		gen_hard_reg_clobber (SImode, 0),
		gen_hard_reg_clobber (SImode, 1),
		gen_hard_reg_clobber (SImode, 2),
		gen_hard_reg_clobber (SImode, 4),
		gen_hard_reg_clobber (SImode, 5),
		gen_hard_reg_clobber (SImode, 6),
		gen_hard_reg_clobber (SImode, 7),
		gen_hard_reg_clobber (SImode, 32),
		gen_hard_reg_clobber (SImode, 33),
		gen_hard_reg_clobber (SImode, 34),
		gen_hard_reg_clobber (SImode, 35),
		gen_hard_reg_clobber (SImode, 36),
		gen_hard_reg_clobber (SImode, 62),
		gen_hard_reg_clobber (SImode, 63)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2731 */
rtx
gen_mulsf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (SFmode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2741 */
rtx
gen_muldf3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_MULT (DFmode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2777 */
rtx
gen_rcpsf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SFmode,
	gen_rtvec (1,
		operand1),
	1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2786 */
rtx
gen_rcpdf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (DFmode,
	gen_rtvec (1,
		operand1),
	1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2870 */
rtx
gen_blockage (void)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	0);
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2876 */
rtx
gen_push_rts (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (10,
		gen_rtx_SET (gen_rtx_MEM (SImode,
	gen_rtx_REG (SImode,
	47)),
	gen_rtx_REG (SImode,
	46)),
		gen_rtx_SET (gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (-8)])),
	gen_rtx_REG (DImode,
	14)),
		gen_rtx_SET (gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (-16)])),
	gen_rtx_REG (DImode,
	44)),
		gen_rtx_SET (gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (-24)])),
	gen_rtx_REG (DImode,
	12)),
		gen_rtx_SET (gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (-32)])),
	gen_rtx_REG (DImode,
	42)),
		gen_rtx_SET (gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (-40)])),
	gen_rtx_REG (DImode,
	10)),
		gen_rtx_SET (gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (-48)])),
	gen_rtx_REG (DImode,
	34)),
		gen_rtx_SET (gen_rtx_REG (SImode,
	47),
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (-56)])),
		gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	0),
		gen_hard_reg_clobber (SImode, 3)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2894 */
rtx
gen_pop_rts (void)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (10,
		gen_rtx_SET (gen_rtx_REG (SImode,
	46),
	gen_rtx_MEM (SImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (56)]))),
		gen_rtx_SET (gen_rtx_REG (DImode,
	14),
	gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (48)]))),
		gen_rtx_SET (gen_rtx_REG (DImode,
	44),
	gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (40)]))),
		gen_rtx_SET (gen_rtx_REG (DImode,
	12),
	gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (32)]))),
		gen_rtx_SET (gen_rtx_REG (DImode,
	42),
	gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (24)]))),
		gen_rtx_SET (gen_rtx_REG (DImode,
	10),
	gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (16)]))),
		gen_rtx_SET (gen_rtx_REG (DImode,
	34),
	gen_rtx_MEM (DImode,
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (8)]))),
		gen_rtx_SET (gen_rtx_REG (SImode,
	47),
	gen_rtx_PLUS (SImode,
	gen_rtx_REG (SImode,
	47),
	const_int_rtx[MAX_SAVED_CONST_INT + (56)])),
		gen_hard_reg_clobber (SImode, 3),
		ret_rtx));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2930 */
rtx
gen_setup_dsbt (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand0,
		operand1),
	4));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2946 */
rtx
gen_epilogue_barrier (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (1,
		operand1),
	16));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2968 */
rtx
gen_andv2hi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_AND (V2HImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2968 */
rtx
gen_iorv2hi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (V2HImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2968 */
rtx
gen_xorv2hi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_XOR (V2HImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/c6x/c6x.md:2968 */
rtx
gen_andv4qi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_AND (V4QImode,
	operand1,
	operand2));
}

