/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:24 */
rtx
gen_divsi3 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_DIV (SImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:34 */
rtx
gen_divhi3_clobber_flags (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_DIV (HImode,
	operand1,
	operand2)),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:34 */
rtx
gen_divsi3_clobber_flags (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_DIV (SImode,
	operand1,
	operand2)),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:43 */
rtx
gen_udivmodqi4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_UDIV (HImode,
	operand1,
	gen_rtx_ZERO_EXTEND (HImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_UMOD (HImode,
	copy_rtx (operand1),
	gen_rtx_ZERO_EXTEND (HImode,
	copy_rtx (operand2)))))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:66 */
rtx
gen_udivmodqi4_clobber_flags (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_UDIV (HImode,
	operand1,
	gen_rtx_ZERO_EXTEND (HImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_UMOD (HImode,
	copy_rtx (operand1),
	gen_rtx_ZERO_EXTEND (HImode,
	copy_rtx (operand2))))),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:87 */
rtx
gen_divmodqi4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_DIV (HImode,
	operand1,
	gen_rtx_SIGN_EXTEND (HImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_MOD (HImode,
	copy_rtx (operand1),
	gen_rtx_SIGN_EXTEND (HImode,
	copy_rtx (operand2)))))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:109 */
rtx
gen_divmodqi4_clobber_flags (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_DIV (HImode,
	operand1,
	gen_rtx_SIGN_EXTEND (HImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (QImode,
	gen_rtx_MOD (HImode,
	copy_rtx (operand1),
	gen_rtx_SIGN_EXTEND (HImode,
	copy_rtx (operand2))))),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:130 */
rtx
gen_udivmodhi4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_UDIV (SImode,
	operand1,
	gen_rtx_ZERO_EXTEND (SImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_UMOD (SImode,
	copy_rtx (operand1),
	gen_rtx_ZERO_EXTEND (SImode,
	copy_rtx (operand2)))))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:152 */
rtx
gen_udivmodhi4_clobber_flags (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_UDIV (SImode,
	operand1,
	gen_rtx_ZERO_EXTEND (SImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_UMOD (SImode,
	copy_rtx (operand1),
	gen_rtx_ZERO_EXTEND (SImode,
	copy_rtx (operand2))))),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:173 */
rtx
gen_divmodhi4 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_DIV (SImode,
	operand1,
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_MOD (SImode,
	copy_rtx (operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	copy_rtx (operand2)))))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/divmod.md:195 */
rtx
gen_divmodhi4_clobber_flags (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_DIV (SImode,
	operand1,
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)))),
		gen_rtx_SET (operand3,
	gen_rtx_TRUNCATE (HImode,
	gen_rtx_MOD (SImode,
	copy_rtx (operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	copy_rtx (operand2))))),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:57 */
rtx
gen_andqi3_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_AND (QImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:158 */
rtx
gen_iorqi3_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_IOR (QImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:158 */
rtx
gen_xorqi3_1 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_XOR (QImode,
	operand1,
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:239 */
rtx
gen_one_cmplqi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (QImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:239 */
rtx
gen_one_cmplhi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (HImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:239 */
rtx
gen_one_cmplsi2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_NOT (SImode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:248 */
rtx
gen_one_cmplqi2_ (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_NOT (QImode,
	operand1)),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:248 */
rtx
gen_one_cmplqi2__cczn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCZNmode,
	12),
	gen_rtx_COMPARE (CCZNmode,
	gen_rtx_NOT (QImode,
	operand1),
	const0_rtx)),
		gen_rtx_SET (operand0,
	gen_rtx_NOT (QImode,
	copy_rtx (operand1)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:248 */
rtx
gen_one_cmplhi2_ (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_NOT (HImode,
	operand1)),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:248 */
rtx
gen_one_cmplhi2__cczn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCZNmode,
	12),
	gen_rtx_COMPARE (CCZNmode,
	gen_rtx_NOT (HImode,
	operand1),
	const0_rtx)),
		gen_rtx_SET (operand0,
	gen_rtx_NOT (HImode,
	copy_rtx (operand1)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:248 */
rtx
gen_one_cmplsi2_ (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_NOT (SImode,
	operand1)),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/logical.md:248 */
rtx
gen_one_cmplsi2__cczn (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (gen_rtx_REG (CCZNmode,
	12),
	gen_rtx_COMPARE (CCZNmode,
	gen_rtx_NOT (SImode,
	operand1),
	const0_rtx)),
		gen_rtx_SET (operand0,
	gen_rtx_NOT (SImode,
	copy_rtx (operand1)))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/other.md:5 */
rtx
gen_abssf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_ABS (SFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/other.md:14 */
rtx
gen_abssf2_clobber_flags (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_ABS (SFmode,
	operand1)),
		gen_hard_reg_clobber (CCmode, 12)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/other.md:22 */
rtx
gen_nop (void)
{
  return const0_rtx;
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:194 */
rtx
gen_jump (rtx operand0 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:244 */
rtx
gen_tablejumphi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	operand0),
		gen_rtx_USE (VOIDmode,
	gen_rtx_LABEL_REF (VOIDmode,
	operand1))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:244 */
rtx
gen_tablejumpsi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (pc_rtx,
	operand0),
		gen_rtx_USE (VOIDmode,
	gen_rtx_LABEL_REF (VOIDmode,
	operand1))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:290 */
rtx
gen_call_insn_hi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand0),
	operand1);
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:290 */
rtx
gen_call_insn_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand0),
	operand1);
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:327 */
rtx
gen_call_value_insn_hi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand1),
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:327 */
rtx
gen_call_value_insn_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand1),
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:360 */
rtx
gen_sibcall_insn_hi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand0),
	operand1);
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:360 */
rtx
gen_sibcall_insn_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand0),
	operand1);
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:397 */
rtx
gen_sibcall_value_insn_hi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand1),
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/jumpcall.md:397 */
rtx
gen_sibcall_value_insn_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_CALL (VOIDmode,
	gen_rtx_MEM (QImode,
	operand1),
	operand2));
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/proepi.md:29 */
rtx
gen_ldm_h8300sx (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return operand0;
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/proepi.md:41 */
rtx
gen_stm_h8300sx (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return operand0;
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/proepi.md:53 */
rtx
gen_return_h8sx (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return operand0;
}

/* ../../gcc-14.1.1-20240508/gcc/config/h8300/proepi.md:105 */
rtx
gen_monitor_prologue (void)
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	1);
}

