/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_1[] = {
  "add.n\t%0, %1, %2",
  "addi.n\t%0, %1, %d2",
  "add\t%0, %1, %2",
  "addi\t%0, %1, %d2",
  "addmi\t%0, %1, %x2",
};

static const char *
output_2 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 181 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  operands[3] = GEN_INT (1 << INTVAL (operands[3]));
  switch (GET_CODE (operands[4]))
    {
    case PLUS:
      return "addx%3\t%0, %1, %2";
    case MINUS:
      return "subx%3\t%0, %1, %2";
    default:
      gcc_unreachable ();
    }
}
}

static const char * const output_10[] = {
  "mul16s\t%0, %1, %2",
  "mul.aa.ll\t%1, %2",
};

static const char * const output_11[] = {
  "mul16u\t%0, %1, %2",
  "umul.aa.ll\t%1, %2",
};

static const char *
output_28 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 563 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  sprintf (result, "clamps\t%%0, %%1, %d", floor_log2 (-INTVAL (operands[2])));
  return result;
}
}

static const char *
output_32 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 658 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  rtx_insn *prev_insn = prev_nonnote_nondebug_insn (insn);
  const char *init = "ssai\t8\n\t";
  static char result[128];
  if (prev_insn && NONJUMP_INSN_P (prev_insn))
    {
      rtx x = PATTERN (prev_insn);
      if (GET_CODE (x) == PARALLEL && XVECLEN (x, 0) == 2
	  && GET_CODE (XVECEXP (x, 0, 0)) == SET
	  && GET_CODE (XVECEXP (x, 0, 1)) == CLOBBER)
	{
	  x = XEXP (XVECEXP (x, 0, 0), 1);
	  if (GET_CODE (x) == BSWAP && GET_MODE (x) == SImode)
	    init = "";
	}
    }
  sprintf (result,
	   (which_alternative == 0)
	   ? "%s" "srli\t%%2, %%1, 16\n\tsrc\t%%2, %%2, %%1\n\tsrc\t%%2, %%2, %%2\n\tsrc\t%%0, %%1, %%2"
	   : "%s" "srli\t%%0, %%1, 16\n\tsrc\t%%0, %%0, %%1\n\tsrc\t%%0, %%0, %%0\n\tsrc\t%%0, %%1, %%0",
	   init);
  return result;
}
}

static const char * const output_36[] = {
  "extui\t%0, %1, 0, %K2",
  "and\t%0, %1, %2",
};

static const char * const output_44[] = {
  "extui\t%0, %1, 0, 16",
  "%v1l16ui\t%0, %1",
};

static const char * const output_45[] = {
  "extui\t%0, %1, 0, 8",
  "%v1l8ui\t%0, %1",
};

static const char * const output_46[] = {
  "sext\t%0, %1, 15",
  "%v1l16si\t%0, %1",
};

static const char *
output_48 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1044 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  int fldsz = INTVAL (operands[2]);
  operands[2] = GEN_INT (fldsz - 1);
  return "sext\t%0, %1, %2";
}
}

static const char *
output_49 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1073 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  int shift;
  if (BITS_BIG_ENDIAN)
    shift = (32 - (INTVAL (operands[2]) + INTVAL (operands[3]))) & 0x1f;
  else
    shift = INTVAL (operands[3]) & 0x1f;
  operands[3] = GEN_INT (shift);
  return "extui\t%0, %1, %3, %2";
}
}

static const char * const output_57[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov.n\t%0, %1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "movsp\t%0, %1",
  "movi\t%0, %x1",
  "movi\t%0, %1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32r\t%0, %1",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_58[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "movi\t%0, %1",
  "%v1l32r\t%0, %1",
  "%v1l16ui\t%0, %1",
  "%v0s16i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_59[] = {
  "movi.n\t%0, %x1",
  "mov.n\t%0, %1",
  "mov\t%0, %1",
  "movi\t%0, %x1",
  "%v1l8ui\t%0, %1",
  "%v0s8i\t%1, %0",
  "rsr\t%0, ACCLO",
  "wsr\t%1, ACCLO",
};

static const char * const output_60[] = {
  "mov.s\t%0, %1",
  "%v1lsi\t%0, %1",
  "%v0ssi\t%1, %0",
  "mov.n\t%0, %1",
  "%v1l32i.n\t%0, %1",
  "%v0s32i.n\t%1, %0",
  "mov\t%0, %1",
  "wfr\t%0, %1",
  "rfr\t%0, %1",
  "movi\t%0, %y1",
  "const16\t%0, %t1\n\tconst16\t%0, %b1",
  "%v1l32r\t%0, %1",
  "%v1l32i\t%0, %1",
  "%v0s32i\t%1, %0",
};

static const char *
output_61 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1485 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "lsiu\t%0, %1, %2";
}
}

static const char *
output_62 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1501 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "ssiu\t%2, %0, %1";
}
}

static const char *
output_63 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1517 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "lsip\t%0, %1, %2";
}
}

static const char *
output_64 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1533 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_SERIALIZE_VOLATILE && volatile_refs_p (PATTERN (insn)))
    output_asm_insn ("memw", operands);
  return "ssip\t%1, %0, %2";
}
}

static const char * const output_66[] = {
  "slli\t%0, %1, %R2",
  "ssl\t%2\n\tsll\t%0, %1",
};

static const char * const output_67[] = {
  "srai\t%0, %1, %R2",
  "ssr\t%2\n\tsra\t%0, %1",
};

static const char *
output_68 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1675 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (which_alternative == 0)
    {
      if ((INTVAL (operands[2]) & 0x1f) < 16)
	return "srli\t%0, %1, %R2";
      else
	return "extui\t%0, %1, %R2, %L2";
    }
  return "ssr\t%2\n\tsrl\t%0, %1";
}
}

static const char *
output_69 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1696 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case ASHIFT:	return "ssa8b\t%2\n\tsll\t%0, %1";
    case ASHIFTRT:	return "ssa8l\t%2\n\tsra\t%0, %1";
    case LSHIFTRT:	return "ssa8l\t%2\n\tsrl\t%0, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_72 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1766 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssl\t%3\n\tsrc\t%0, %1, %2";
    case LSHIFTRT:	return "ssr\t%3\n\tsrc\t%0, %2, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_74 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1819 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[5], operands[6]))
    {
    case ASHIFT:	return "ssai\t%L3\n\tsrc\t%0, %1, %2";
    case LSHIFTRT:	return "ssai\t%R3\n\tsrc\t%0, %2, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char *
output_75 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1844 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  switch (xtensa_shlrd_which_direction (operands[4], operands[5]))
    {
    case ASHIFT:	return "ssa8b\t%2\n\tsrc\t%0, %1, %3";
    case LSHIFTRT:	return "ssa8l\t%2\n\tsrc\t%0, %3, %1";
    default:		gcc_unreachable ();
    }
}
}

static const char * const output_77[] = {
  "ssai\t%L2\n\tsrc\t%0, %1, %1",
  "ssl\t%2\n\tsrc\t%0, %1, %1",
};

static const char * const output_78[] = {
  "ssai\t%R2\n\tsrc\t%0, %1, %1",
  "ssr\t%2\n\tsrc\t%0, %1, %1",
};

static const char *
output_79 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1950 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (which_alternative == 0, operands);
}
}

static const char *
output_81 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2003 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_branch (which_alternative == 0, operands);
}
}

static const char *
output_82 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2022 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  static char result[64];
  char op;
  switch (GET_CODE (operands[3]))
    {
    case EQ:	op = 'c'; break;
    case NE:	op = 's'; break;
    default:	gcc_unreachable ();
    }
  if (which_alternative == 0)
    {
      operands[1] = GEN_INT (INTVAL (operands[1]) & 0x1f);
      sprintf (result, "bb%ci\t%%0, %%d1, %%2", op);
    }
  else
    sprintf (result, "bb%c\t%%0, %%1, %%2", op);
  return result;
}
}

static const char *
output_83 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2053 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:	return "bnone\t%0, %1, %2";
    case NE:	return "bany\t%0, %1, %2";
    default:	gcc_unreachable ();
    }
}
}

static const char *
output_84 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2074 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  switch (GET_CODE (operands[3]))
    {
    case EQ:	return "ball\t%0, %1, %2";
    case NE:	return "bnall\t%0, %1, %2";
    default:	gcc_unreachable ();
    }
}
}

static const char *
output_91 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2339 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  xtensa_emit_loop_end (insn, operands);
  return "";
}
}

static const char *
output_94 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2483 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc (which_alternative == 1, false, false, operands);
}
}

static const char *
output_95 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2498 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc (which_alternative == 1, false, true, operands);
}
}

static const char *
output_96 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2513 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc ((which_alternative & 1) == 1,
			    which_alternative >= 2, false, operands);
}
}

static const char *
output_97 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2529 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_movcc ((which_alternative & 1) == 1,
			    which_alternative >= 2, true, operands);
}
}

static const char *
output_108 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2633 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (0, operands);
}
}

static const char *
output_109 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2655 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_call (1, operands);
}
}

static const char *
output_110 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2675 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_sibcall (0, operands);
}
}

static const char *
output_111 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2697 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return xtensa_emit_sibcall (1, operands);
}
}

static const char *
output_113 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2739 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return TARGET_WINDOWED_ABI ?
      (TARGET_DENSITY ? "retw.n" : "retw") :
      (TARGET_DENSITY ? "ret.n" : "ret");
}
}

static const char *
output_114 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2807 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  return (TARGET_DENSITY ? "nop.n" : "nop");
}
}

static const char *
output_119 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2907 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_DEBUG)
    return "break\t1, 15";
  else
    return (TARGET_DENSITY ? "ill.n" : "ill");
}
}

static const char *
output_120 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2938 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (frame_pointer_needed)
    return (TARGET_DENSITY ? "mov.n\ta7, sp" : "mov\ta7, sp");
  return "";
}
}

static const char *
output_126 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 3026 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (TARGET_WINDOWED_ABI)
    return "callx8.tls %1, %2@TLSCALL";
  else
    return "callx0.tls %1, %2@TLSCALL";
}
}

static const char *
output_127 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 3047 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (GET_CODE (operands[2]) == EQ)
    return "bf\t%0, %1";
  else
    return "bt\t%0, %1";
}
}

static const char *
output_128 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 3065 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
{
  if (GET_CODE (operands[2]) == EQ)
    return "bt\t%0, %1";
  else
    return "bf\t%0, %1";
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=D,D,a,a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%d,d,r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_operand,
    "d,O,r,J,N",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    addsubx_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    addsub_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=C,A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=A",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&a",
    E_HImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,&a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&a,X",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "%r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    mask_operand,
    "P,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    shifted_mask_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "r,U",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=B,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    sext_operand,
    "r,U",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=B",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    sext_fldsz_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    lsbitnum_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    extui_fldsz_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    addsub_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "=a,W,a,a,U",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,i,T,U,r",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,D,a,U,D,R,R,a,q,a,a,W,a,*a,*A",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,D,d,U,r,R,D,d,r,r,I,Y,i,T,*A,*r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,a,a,U,*a,*A",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,Y,T,U,r,*A,*r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=D,D,a,a,a,U,*a,*A",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "M,d,r,I,U,r,*A,*r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "=f,f,U,D,D,R,a,f,a,a,W,a,a,U",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "f,U,f,d,R,d,r,r,f,Y,iF,T,U,r",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "+a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    fpmem_offset_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "+a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    fpmem_offset_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "=a,a,W,a,a,U",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    move_operand,
    "r,Y,iF,T,U,r",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_shift_per_byte_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_shift_per_byte_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    xtensa_bit_join_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    xtensa_bit_join_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    logical_shift_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    xtensa_bit_join_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operand,
    "K,?r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operand,
    "L,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    ubranch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "J,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    shifted_mask_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "=a,m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,0",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    scratch_operand,
    "=X,&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b,b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a,f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,r,r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0,f,0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r,0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    branch_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a,a,f,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b,b,b,b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r,0,f,0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r,0,f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "f",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nir",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nir",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nic",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_insn_operand,
    "nic",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    tls_symbol_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    tls_symbol_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "i",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "b",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    mem_operand,
    "=U",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "+U",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=a,&a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "0,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    scratch_operand,
    "=&a,X",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "=a",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    boolean_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    constantpool_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=&r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    nonimmed_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_BLKmode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    xtensa_cstoresi_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_SImode,
    0,
    1,
    0,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmed_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    add_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    mem_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:159 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_1 },
#else
    { 0, output_1, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[1],
    3,
    3,
    0,
    5,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:174 */
  {
    "*addsubx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_2 },
#else
    { 0, 0, output_2 },
#endif
    { 0 },
    &operand_data[4],
    5,
    5,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:240 */
  {
    "addsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsf3 },
    &operand_data[9],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:253 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:263 */
  {
    "*subsi3_from_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[12],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:310 */
  {
    "subsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsf3 },
    &operand_data[15],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:359 */
  {
    "mulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mulsh\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3_highpart },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:359 */
  {
    "umulsi3_highpart",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muluh\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsi3_highpart },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:372 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mull\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:382 */
  {
    "mulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulhisi3 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:382 */
  {
    "umulhisi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_11 },
#else
    { 0, output_11, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulhisi3 },
    &operand_data[21],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:396 */
  {
    "muladdhisi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mula.aa.ll\t%1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_muladdhisi },
    &operand_data[24],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:409 */
  {
    "mulsubhisi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "muls.aa.ll\t%2, %3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsubhisi },
    &operand_data[28],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:422 */
  {
    "mulsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mul.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsf3 },
    &operand_data[9],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:432 */
  {
    "fmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "madd.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fmasf4 },
    &operand_data[32],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:444 */
  {
    "fnmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "msub.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fnmasf4 },
    &operand_data[32],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:458 */
  {
    "divsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "quos\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:468 */
  {
    "udivsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "quou\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:481 */
  {
    "modsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rems\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_modsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:491 */
  {
    "umodsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "remu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umodsi3 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:504 */
  {
    "abssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "abs\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:513 */
  {
    "abssf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "abs.s\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssf2 },
    &operand_data[15],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:525 */
  {
    "sminsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "min\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sminsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:525 */
  {
    "uminsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "minu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_uminsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:525 */
  {
    "smaxsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "max\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_smaxsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:525 */
  {
    "umaxsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "maxu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umaxsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:538 */
  {
    "*xtensa_clamps",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[36],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:556 */
  {
    "*xtensa_clamps",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_28 },
#else
    { 0, 0, output_28 },
#endif
    { 0 },
    &operand_data[36],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:576 */
  {
    "clrsbsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nsa\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clrsbsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:585 */
  {
    "clzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nsau\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_clzsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:625 */
  {
    "bswaphi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "extui\t%2, %1, 8, 8\n\tslli\t%0, %1, 8\n\tor\t%0, %0, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswaphi2 },
    &operand_data[40],
    2,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:653 */
  {
    "bswapsi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_32 },
#else
    { 0, 0, output_32 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapsi2_internal },
    &operand_data[43],
    2,
    3,
    0,
    2,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:701 */
  {
    "negsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:710 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:731 */
  {
    "negsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "neg.s\t%0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_negsf2 },
    &operand_data[15],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:743 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_36 },
#else
    { 0, output_36, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[46],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:755 */
  {
    "*andsi3_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:775 */
  {
    "*andsi3_const_pow2_minus_one",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[36],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:799 */
  {
    "*andsi3_const_negative_pow2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[36],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:819 */
  {
    "*andsi3_const_shifted_mask",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[49],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:852 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "or\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:886 */
  {
    "xorsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "xor\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3_internal },
    &operand_data[18],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:896 */
  {
    "*splice_bits",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[52],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:946 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_44 },
#else
    { 0, output_44, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[57],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:957 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_45 },
#else
    { 0, output_45, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[59],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:983 */
  {
    "extendhisi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_46 },
#else
    { 0, output_46, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2_internal },
    &operand_data[61],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1006 */
  {
    "extendqisi2_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sext\t%0, %1, 7",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2_internal },
    &operand_data[63],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1038 */
  {
    "extvsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_48 },
#else
    { 0, 0, output_48 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extvsi_internal },
    &operand_data[65],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1067 */
  {
    "extzvsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_49 },
#else
    { 0, 0, output_49 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzvsi_internal },
    &operand_data[69],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1086 */
  {
    "*extzvsi-1bit_ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[73],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1127 */
  {
    "*extzvsi-1bit_addsubx",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[78],
    7,
    7,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1173 */
  {
    "fix_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "trunc.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fix_truncsfsi2 },
    &operand_data[85],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1182 */
  {
    "fixuns_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "utrunc.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fixuns_truncsfsi2 },
    &operand_data[85],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1191 */
  {
    "floatsisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "float.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatsisf2 },
    &operand_data[87],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1200 */
  {
    "floatunssisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ufloat.s\t%0, %1, 0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatunssisf2 },
    &operand_data[87],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1243 */
  {
    "movdi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi_internal },
    &operand_data[89],
    2,
    2,
    0,
    5,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1286 */
  {
    "movsi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_57 },
#else
    { 0, output_57, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_internal },
    &operand_data[91],
    2,
    2,
    0,
    16,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1350 */
  {
    "movhi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_58 },
#else
    { 0, output_58, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi_internal },
    &operand_data[93],
    2,
    2,
    0,
    10,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1380 */
  {
    "movqi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_59 },
#else
    { 0, output_59, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi_internal },
    &operand_data[95],
    2,
    2,
    0,
    8,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1452 */
  {
    "movsf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_60 },
#else
    { 0, output_60, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf_internal },
    &operand_data[97],
    2,
    2,
    0,
    14,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1478 */
  {
    "*lsiu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_61 },
#else
    { 0, 0, output_61 },
#endif
    { 0 },
    &operand_data[99],
    3,
    3,
    3,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1494 */
  {
    "*ssiu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_62 },
#else
    { 0, 0, output_62 },
#endif
    { 0 },
    &operand_data[100],
    3,
    3,
    3,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1510 */
  {
    "*lsip",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_63 },
#else
    { 0, 0, output_63 },
#endif
    { 0 },
    &operand_data[99],
    3,
    3,
    2,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1526 */
  {
    "*ssip",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_64 },
#else
    { 0, 0, output_64 },
#endif
    { 0 },
    &operand_data[103],
    3,
    3,
    2,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1578 */
  {
    "movdf_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf_internal },
    &operand_data[106],
    2,
    2,
    0,
    6,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1637 */
  {
    "ashlsi3_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_66 },
#else
    { 0, output_66, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3_internal },
    &operand_data[108],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1658 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_67 },
#else
    { 0, output_67, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[108],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1670 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_68 },
#else
    { 0, 0, output_68 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[108],
    3,
    3,
    0,
    2,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1689 */
  {
    "*shift_per_byte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_69 },
#else
    { 0, 0, output_69 },
#endif
    { 0 },
    &operand_data[111],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1709 */
  {
    "*shift_per_byte_omit_AND_0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[115],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1730 */
  {
    "*shift_per_byte_omit_AND_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[115],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1755 */
  {
    "*shlrd_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_72 },
#else
    { 0, 0, output_72 },
#endif
    { 0 },
    &operand_data[120],
    7,
    7,
    1,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1778 */
  {
    "*shlrd_reg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[120],
    7,
    7,
    1,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1805 */
  {
    "*shlrd_const",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_74 },
#else
    { 0, 0, output_74 },
#endif
    { 0 },
    &operand_data[127],
    8,
    8,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1831 */
  {
    "*shlrd_per_byte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_75 },
#else
    { 0, 0, output_75 },
#endif
    { 0 },
    &operand_data[120],
    7,
    7,
    1,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1856 */
  {
    "*shlrd_per_byte_omit_AND",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[135],
    8,
    8,
    2,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1889 */
  {
    "rotlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_77 },
#else
    { 0, output_77, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotlsi3 },
    &operand_data[108],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1901 */
  {
    "rotrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_78 },
#else
    { 0, output_78, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_rotrsi3 },
    &operand_data[108],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1942 */
  {
    "*btrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_79 },
#else
    { 0, 0, output_79 },
#endif
    { 0 },
    &operand_data[143],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1964 */
  {
    "*btrue_INT_MIN",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[147],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1995 */
  {
    "*ubtrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_81 },
#else
    { 0, 0, output_81 },
#endif
    { 0 },
    &operand_data[150],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2012 */
  {
    "*bittrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_82 },
#else
    { 0, 0, output_82 },
#endif
    { 0 },
    &operand_data[154],
    4,
    4,
    0,
    2,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2044 */
  {
    "*masktrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_83 },
#else
    { 0, 0, output_83 },
#endif
    { 0 },
    &operand_data[158],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2065 */
  {
    "*masktrue_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_84 },
#else
    { 0, 0, output_84 },
#endif
    { 0 },
    &operand_data[158],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2086 */
  {
    "*masktrue_const_bitcmpl",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[162],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2170 */
  {
    "*masktrue_const_pow2_minus_one",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[166],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2210 */
  {
    "*masktrue_const_negative_pow2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[166],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2245 */
  {
    "*masktrue_const_shifted_mask",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[171],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2295 */
  {
    "zero_cost_loop_start",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "loop\t%0, %l1_LEND",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_cost_loop_start },
    &operand_data[176],
    3,
    3,
    1,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2311 */
  {
    "zero_cost_loop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_cost_loop_end },
    &operand_data[179],
    3,
    4,
    1,
    2,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2328 */
  {
    "loop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_91 },
#else
    { 0, 0, output_91 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_loop_end },
    &operand_data[176],
    3,
    3,
    1,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2415 */
  {
    "salt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "salt\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_salt },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2425 */
  {
    "saltu",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "saltu\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_saltu },
    &operand_data[4],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2475 */
  {
    "movsicc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_94 },
#else
    { 0, 0, output_94 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc_internal0 },
    &operand_data[183],
    5,
    5,
    0,
    2,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2490 */
  {
    "movsicc_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_95 },
#else
    { 0, 0, output_95 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc_internal1 },
    &operand_data[188],
    5,
    5,
    0,
    2,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2505 */
  {
    "movsfcc_internal0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_96 },
#else
    { 0, 0, output_96 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc_internal0 },
    &operand_data[193],
    5,
    5,
    0,
    4,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2521 */
  {
    "movsfcc_internal1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_97 },
#else
    { 0, 0, output_97 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc_internal1 },
    &operand_data[198],
    5,
    5,
    0,
    4,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2540 */
  {
    "seq_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "oeq.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_seq_sf },
    &operand_data[203],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2540 */
  {
    "slt_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "olt.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_slt_sf },
    &operand_data[203],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2540 */
  {
    "sle_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ole.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sle_sf },
    &operand_data[203],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2540 */
  {
    "suneq_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ueq.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_suneq_sf },
    &operand_data[203],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2540 */
  {
    "sunlt_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ult.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunlt_sf },
    &operand_data[203],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2540 */
  {
    "sunle_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ule.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunle_sf },
    &operand_data[203],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2540 */
  {
    "sunordered_sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "un.s\t%0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sunordered_sf },
    &operand_data[203],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2553 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "j\t%l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[145],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2575 */
  {
    "indirect_jump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump_internal },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2602 */
  {
    "tablejump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jx\t%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump_internal },
    &operand_data[147],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2629 */
  {
    "call_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_108 },
#else
    { 0, 0, output_108 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_internal },
    &operand_data[206],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2650 */
  {
    "call_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_109 },
#else
    { 0, 0, output_109 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value_internal },
    &operand_data[208],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2671 */
  {
    "sibcall_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_110 },
#else
    { 0, 0, output_110 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_internal },
    &operand_data[211],
    2,
    2,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2692 */
  {
    "sibcall_value_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_111 },
#else
    { 0, 0, output_111 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_value_internal },
    &operand_data[213],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2725 */
  {
    "entry",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "entry\tsp, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_entry },
    &operand_data[13],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2735 */
  {
    "return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_113 },
#else
    { 0, 0, output_113 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2804 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_114 },
#else
    { 0, 0, output_114 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2846 */
  {
    "eh_set_a0_windowed",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_windowed },
    &operand_data[216],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2859 */
  {
    "eh_set_a0_call0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_set_a0_call0 },
    &operand_data[216],
    1,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2875 */
  {
    "blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_blockage },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2895 */
  {
    "*frame_blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[218],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2904 */
  {
    "trap",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_119 },
#else
    { 0, 0, output_119 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_trap },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2935 */
  {
    "set_frame_ptr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_120 },
#else
    { 0, 0, output_120 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_frame_ptr },
    &operand_data[0],
    0,
    0,
    0,
    0,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2960 */
  {
    "*unspec_nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2981 */
  {
    "get_thread_pointersi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rur\t%0, THREADPTR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_get_thread_pointersi },
    &operand_data[4],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2990 */
  {
    "set_thread_pointersi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "wur\t%0, THREADPTR",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_thread_pointersi },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2999 */
  {
    "tls_func",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "movi\t%0, %1@TLSFUNC",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_func },
    &operand_data[220],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3009 */
  {
    "tls_arg",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "movi\t%0, %1@TLSARG",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_arg },
    &operand_data[220],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3019 */
  {
    "tls_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_126 },
#else
    { 0, 0, output_126 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tls_call },
    &operand_data[222],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3039 */
  {
    "*booltrue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_127 },
#else
    { 0, 0, output_127 },
#endif
    { 0 },
    &operand_data[226],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3057 */
  {
    "*boolfalse",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_128 },
#else
    { 0, 0, output_128 },
#endif
    { 0 },
    &operand_data[226],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3087 */
  {
    "*memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "memw",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[218],
    1,
    1,
    1,
    0,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3098 */
  {
    "sync_lock_releasesi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "s32ri\t%1, %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_releasesi },
    &operand_data[229],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3109 */
  {
    "sync_compare_and_swapsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "wsr\t%2, SCOMPARE1\n\ts32c1i\t%3, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swapsi },
    &operand_data[231],
    4,
    4,
    2,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3185 */
  {
    "*round_up_to_even",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3209 */
  {
    "*signed_ge_zero",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3230 */
  {
    "eq_zero_NSA",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eq_zero_NSA },
    &operand_data[4],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3247 */
  {
    "eqne_zero",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eqne_zero },
    &operand_data[235],
    3,
    4,
    0,
    2,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3284 */
  {
    "*eqne_zero_masked_bits",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[239],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3313 */
  {
    "*eqne_INT_MIN",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[243],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:211 */
  {
    "adddi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_adddi3 },
    &operand_data[246],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:287 */
  {
    "subdi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subdi3 },
    &operand_data[246],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:323 */
  {
    "mulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsidi3 },
    &operand_data[248],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:337 */
  {
    "umulsidi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umulsidi3 },
    &operand_data[248],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:594 */
  {
    "ctzsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ctzsi2 },
    &operand_data[249],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:608 */
  {
    "ffssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ffssi2 },
    &operand_data[249],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:635 */
  {
    "bswapsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapsi2 },
    &operand_data[249],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:685 */
  {
    "bswapdi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_bswapdi2 },
    &operand_data[246],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:862 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[249],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:971 */
  {
    "extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendhisi2 },
    &operand_data[252],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:994 */
  {
    "extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extendqisi2 },
    &operand_data[254],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1018 */
  {
    "extvsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extvsi },
    &operand_data[256],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1053 */
  {
    "extzvsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_extzvsi },
    &operand_data[256],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1214 */
  {
    "movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi },
    &operand_data[260],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1277 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[262],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1341 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[264],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1371 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[266],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1399 */
  {
    "reloadhi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadhi_literal },
    &operand_data[268],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1399 */
  {
    "reloadqi_literal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reloadqi_literal },
    &operand_data[271],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1433 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[274],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1563 */
  {
    "movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf },
    &operand_data[276],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1599 */
  {
    "cpymemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cpymemsi },
    &operand_data[278],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1613 */
  {
    "setmemsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_setmemsi },
    &operand_data[282],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1628 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[286],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1918 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[289],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:1929 */
  {
    "cbranchsf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsf4 },
    &operand_data[293],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2383 */
  {
    "doloop_end",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_doloop_end },
    &operand_data[297],
    2,
    2,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2403 */
  {
    "cstoresi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresi4 },
    &operand_data[299],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2435 */
  {
    "cstoresf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresf4 },
    &operand_data[303],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2451 */
  {
    "movsicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc },
    &operand_data[307],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2463 */
  {
    "movsfcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc },
    &operand_data[311],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2562 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[315],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2584 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[316],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2615 */
  {
    "sym_PLT",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_PLT },
    &operand_data[219],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2620 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[318],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2640 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[320],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2662 */
  {
    "sibcall",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall },
    &operand_data[318],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2682 */
  {
    "sibcall_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_value },
    &operand_data[320],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2704 */
  {
    "untyped_call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_untyped_call },
    &operand_data[322],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2758 */
  {
    "allocate_stack",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_allocate_stack },
    &operand_data[325],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2780 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2788 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2796 */
  {
    "sibcall_epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2817 */
  {
    "nonlocal_goto",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nonlocal_goto },
    &operand_data[327],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2835 */
  {
    "eh_return",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_eh_return },
    &operand_data[331],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2885 */
  {
    "frame_blockage",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_frame_blockage },
    &operand_data[0],
    0,
    0,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2971 */
  {
    "sym_TPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_TPOFF },
    &operand_data[219],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:2976 */
  {
    "sym_DTPOFF",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sym_DTPOFF },
    &operand_data[219],
    1,
    1,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3078 */
  {
    "memory_barrier",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_memory_barrier },
    &operand_data[0],
    0,
    0,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3125 */
  {
    "sync_compare_and_swaphi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swaphi },
    &operand_data[332],
    4,
    4,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3125 */
  {
    "sync_compare_and_swapqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_compare_and_swapqi },
    &operand_data[336],
    4,
    4,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_lock_test_and_sethi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_test_and_sethi },
    &operand_data[340],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3142 */
  {
    "sync_lock_test_and_setqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_lock_test_and_setqi },
    &operand_data[343],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_andhi },
    &operand_data[341],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_iorhi },
    &operand_data[341],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_xorhi },
    &operand_data[341],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_addhi },
    &operand_data[341],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_subhi },
    &operand_data[341],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_nandhi },
    &operand_data[341],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_andqi },
    &operand_data[344],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_iorqi },
    &operand_data[344],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_xorqi },
    &operand_data[344],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_addqi },
    &operand_data[344],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_subqi },
    &operand_data[344],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3152 */
  {
    "sync_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_nandqi },
    &operand_data[344],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_andhi },
    &operand_data[340],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_iorhi },
    &operand_data[340],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_xorhi },
    &operand_data[340],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_addhi },
    &operand_data[340],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_subhi },
    &operand_data[340],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_nandhi },
    &operand_data[340],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_andqi },
    &operand_data[343],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_iorqi },
    &operand_data[343],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_xorqi },
    &operand_data[343],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_addqi },
    &operand_data[343],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_subqi },
    &operand_data[343],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3162 */
  {
    "sync_old_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_old_nandqi },
    &operand_data[343],
    3,
    3,
    2,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_andhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_andhi },
    &operand_data[340],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_iorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_iorhi },
    &operand_data[340],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_xorhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_xorhi },
    &operand_data[340],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_addhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_addhi },
    &operand_data[340],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_subhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_subhi },
    &operand_data[340],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_nandhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_nandhi },
    &operand_data[340],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_andqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_andqi },
    &operand_data[343],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_iorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_iorqi },
    &operand_data[343],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_xorqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_xorqi },
    &operand_data[343],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_addqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_addqi },
    &operand_data[343],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_subqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_subqi },
    &operand_data[343],
    3,
    3,
    3,
    0,
    0
  },
  /* ../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md:3174 */
  {
    "sync_new_nandqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sync_new_nandqi },
    &operand_data[343],
    3,
    3,
    3,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
