/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
internal_dfa_insn_code (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_tune_arc700 cached_tune_arc700 ATTRIBUTE_UNUSED;
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 472:  /* vld32_insn */
    case 471:  /* vld64_insn */
    case 470:  /* vld64w_insn */
    case 469:  /* vld32wl_insn */
    case 468:  /* vld32wh_insn */
    case 444:  /* vmovw_insn */
    case 442:  /* vd6tapf_insn */
    case 440:  /* vmvw_insn */
      return 68 /* 0x44 */;

    case 459:  /* vupsbw_insn */
    case 457:  /* vupbw_insn */
    case 455:  /* vexch4_insn */
    case 454:  /* vexch2_insn */
    case 453:  /* vexch1_insn */
    case 446:  /* vsr8_insn */
    case 438:  /* vsr8i_insn */
    case 436:  /* vasrrpwbi_insn */
    case 435:  /* vasrpwbi_insn */
    case 433:  /* vasrsrwi_insn */
    case 432:  /* vasrrwi_insn */
    case 429:  /* vbmulw_insn */
    case 428:  /* vbmulfw_insn */
    case 418:  /* vmrb_insn */
    case 417:  /* vmr7w_insn */
    case 415:  /* vmr6w_insn */
    case 413:  /* vmr5w_insn */
    case 411:  /* vmr4w_insn */
    case 409:  /* vmr3w_insn */
    case 407:  /* vmr2w_insn */
    case 405:  /* vmr1w_insn */
    case 392:  /* vsummw_insn */
    case 389:  /* vmulw_insn */
    case 388:  /* vmulfw_insn */
      return 66 /* 0x42 */;

    case 452:  /* vsignw_insn */
    case 451:  /* vaddsuw_insn */
    case 450:  /* vabsw_insn */
    case 447:  /* vasrw_insn */
    case 445:  /* vmovzw_insn */
    case 441:  /* vmvzw_insn */
    case 434:  /* vasrwi_insn */
    case 431:  /* vbsubw_insn */
    case 430:  /* vbrsubw_insn */
    case 426:  /* vbminw_insn */
    case 425:  /* vbmaxw_insn */
    case 424:  /* vbaddw_insn */
    case 403:  /* vnew_insn */
    case 402:  /* vltw_insn */
    case 401:  /* vlew_insn */
    case 400:  /* veqw_insn */
    case 398:  /* vxor_insn */
    case 397:  /* vor_insn */
    case 395:  /* vbic_insn */
    case 393:  /* vand_insn */
    case 391:  /* vsubw_insn */
    case 385:  /* vminw_insn */
    case 383:  /* vmaxw_insn */
    case 381:  /* vdifw_insn */
    case 379:  /* vavrb_insn */
    case 378:  /* vavb_insn */
    case 377:  /* vaddw_insn */
      return 65 /* 0x41 */;

    case 375:  /* movti_insn */
    case 374:  /* movv8hi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 1)
        {
	  return 64 /* 0x40 */;
        }
      else if (!((1ULL << which_alternative) & 0x3ULL))
        {
	  return 65 /* 0x41 */;
        }
      else
        {
	  return 67 /* 0x43 */;
        }

    case 475:  /* vinti_insn */
    case 474:  /* vst32_n_insn */
    case 473:  /* vst16_n_insn */
    case 467:  /* vendrec_insn */
    case 466:  /* vrecrun_insn */
    case 465:  /* vrun_insn */
    case 464:  /* vrec_insn */
    case 463:  /* vdowr_insn */
    case 462:  /* vdiwr_insn */
    case 461:  /* vdorun_insn */
    case 460:  /* vdirun_insn */
    case 373:  /* vst64_insn */
    case 372:  /* vst128_insn */
      return 64 /* 0x40 */;

    case 458:  /* vupsbaw_insn */
    case 456:  /* vupbaw_insn */
    case 449:  /* vabsaw_insn */
    case 448:  /* vsr8aw_insn */
    case 443:  /* vmovaw_insn */
    case 439:  /* vmvaw_insn */
    case 437:  /* vsr8awi_insn */
    case 427:  /* vbmulaw_insn */
    case 423:  /* vvc1ft_insn */
    case 422:  /* vvc1f_insn */
    case 421:  /* vh264fw_insn */
    case 420:  /* vh264ft_insn */
    case 419:  /* vh264f_insn */
    case 416:  /* vmr7aw_insn */
    case 414:  /* vmr6aw_insn */
    case 412:  /* vmr5aw_insn */
    case 410:  /* vmr4aw_insn */
    case 408:  /* vmr3aw_insn */
    case 406:  /* vmr2aw_insn */
    case 404:  /* vmr1aw_insn */
    case 399:  /* vxoraw_insn */
    case 396:  /* vbicaw_insn */
    case 394:  /* vandaw_insn */
    case 390:  /* vsubaw_insn */
    case 387:  /* vmulfaw_insn */
    case 386:  /* vmulaw_insn */
    case 384:  /* vminaw_insn */
    case 382:  /* vmaxaw_insn */
    case 380:  /* vdifaw_insn */
    case 376:  /* vaddaw_insn */
    case 371:  /* vld128_insn */
      return 67 /* 0x43 */;

    case 776:  /* *p divdf3 */
    case 349:  /* sqrtdf2 */
    case 348:  /* divdf3 */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 57 /* 0x39 */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 770:  /* *p *divsf3_fpu */
    case 341:  /* sqrtsf2_fpu */
    case 340:  /* *divsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 56 /* 0x38 */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 769:  /* *p fnmadf4_fpu */
    case 768:  /* *p fmadf4_fpu */
    case 767:  /* *p fnmasf4_fpu */
    case 766:  /* *p fmasf4_fpu */
    case 339:  /* fnmadf4_fpu */
    case 338:  /* fmadf4_fpu */
    case 335:  /* fnmasf4_fpu */
    case 334:  /* fmasf4_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 55 /* 0x37 */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 796:  /* *p fix_truncdfsi2 */
    case 795:  /* *p fixuns_truncdfsi2 */
    case 794:  /* *p floatunsdisf2 */
    case 793:  /* *p floatdisf2 */
    case 792:  /* *p truncdfsf2 */
    case 791:  /* *p fix_truncdfdi2 */
    case 790:  /* *p fixuns_truncdfdi2 */
    case 789:  /* *p floatunsdidf2 */
    case 788:  /* *p floatdidf2 */
    case 787:  /* *p fix_truncsfsi2_fpu */
    case 786:  /* *p fixuns_truncsfsi2 */
    case 785:  /* *p floatunssisf2 */
    case 784:  /* *p floatsisf2_fpu */
    case 783:  /* *p fix_truncsfdi2 */
    case 782:  /* *p fixuns_truncsfdi2 */
    case 781:  /* *p floatunssidf2 */
    case 780:  /* *p floatsidf2 */
    case 779:  /* *p extendsfdf2 */
    case 778:  /* *p *cmpdf_fpu_trap */
    case 777:  /* *p *cmpdf_fpu */
    case 775:  /* *p *muldf3_fpu */
    case 774:  /* *p *subdf3_fpu */
    case 773:  /* *p *adddf3_fpu */
    case 772:  /* *p *cmpsf_fpu_trap */
    case 771:  /* *p *cmpsf_fpu */
    case 765:  /* *p *mulsf3_fpu */
    case 764:  /* *p *subsf3_fpu */
    case 763:  /* *p *addsf3_fpu */
    case 370:  /* fix_truncdfsi2 */
    case 369:  /* fixuns_truncdfsi2 */
    case 368:  /* floatunsdisf2 */
    case 367:  /* floatdisf2 */
    case 366:  /* truncdfsf2 */
    case 365:  /* fix_truncdfdi2 */
    case 364:  /* fixuns_truncdfdi2 */
    case 363:  /* floatunsdidf2 */
    case 362:  /* floatdidf2 */
    case 361:  /* fix_truncsfsi2_fpu */
    case 360:  /* fixuns_truncsfsi2 */
    case 359:  /* floatunssisf2 */
    case 358:  /* floatsisf2_fpu */
    case 357:  /* fix_truncsfdi2 */
    case 356:  /* fixuns_truncsfdi2 */
    case 355:  /* floatunssidf2 */
    case 354:  /* floatsidf2 */
    case 353:  /* extendsfdf2 */
    case 352:  /* *cmpdf_fpu_uneq */
    case 351:  /* *cmpdf_fpu_trap */
    case 350:  /* *cmpdf_fpu */
    case 347:  /* *muldf3_fpu */
    case 346:  /* *subdf3_fpu */
    case 345:  /* *adddf3_fpu */
    case 344:  /* *cmpsf_fpu_uneq */
    case 343:  /* *cmpsf_fpu_trap */
    case 342:  /* *cmpsf_fpu */
    case 333:  /* *mulsf3_fpu */
    case 332:  /* *subsf3_fpu */
    case 331:  /* *addsf3_fpu */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 54 /* 0x36 */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 320:  /* *dmulh_peep2_insn */
    case 317:  /* muldf3_insn */
      extract_constrain_insn_cached (insn);
      if (
#line 37 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET))
        {
	  return 61 /* 0x3d */;
        }
      else if (
#line 47 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET))
        {
	  return 63 /* 0x3f */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 321:  /* *dsubh_peep2_insn */
    case 319:  /* *daddh_peep2_insn */
    case 318:  /* subdf3_insn */
    case 316:  /* adddf3_insn */
    case 308:  /* cmpdfpx_raw */
      extract_constrain_insn_cached (insn);
      if (
#line 37 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET))
        {
	  return 62 /* 0x3e */;
        }
      else if (
#line 47 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET))
        {
	  return 63 /* 0x3f */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 307:  /* cmpsfpx_raw */
    case 306:  /* *mulsf3_fpx */
    case 305:  /* *subsf3_fpx */
    case 304:  /* *addsf3_fpx */
      extract_constrain_insn_cached (insn);
      if (
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET))
        {
	  return 59 /* 0x3b */;
        }
      else if (
#line 32 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET))
        {
	  return 60 /* 0x3c */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 180:  /* divaw */
      if (get_attr_tune_arc700 (insn) == TUNE_ARC700_TRUE)
        {
	  return 13 /* 0xd */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 210:  /* arc_lp */
    case 207:  /* p_return_i */
    case 206:  /* arc600_rtie */
    case 205:  /* simple_return */
    case 183:  /* rtie */
    case 172:  /* blockage */
      return 70 /* 0x46 */;

    case 213:  /* dbnz */
    case 211:  /* loop_end */
    case 209:  /* *bbit */
    case 208:  /* cbranchsi4_scratch */
    case 164:  /* casesi_dispatch */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 43 /* 0x2b */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 732:  /* *p *cmpdf_ord */
    case 731:  /* *p *cmpdf_uneq */
    case 730:  /* *p *cmpdf_ge */
    case 729:  /* *p *cmpdf_gt */
    case 728:  /* *p *cmpdf_eq */
    case 727:  /* *p *cmpsf_ord */
    case 726:  /* *p *cmpsf_uneq */
    case 725:  /* *p *cmpsf_ge */
    case 724:  /* *p *cmpsf_gt */
    case 723:  /* *p *cmpsf_eq */
    case 721:  /* *p *sibcall_value_insn */
    case 720:  /* *p *sibcall_insn */
    case 718:  /* *p *call_value_i */
    case 717:  /* *p *call_i */
    case 302:  /* *pop_multi_fp_blink_ret */
    case 301:  /* *pop_multi_fp_ret */
    case 300:  /* *pop_multi_fp_blink */
    case 299:  /* *pop_multi_fp */
    case 298:  /* *push_multi_fp_blink */
    case 297:  /* *push_multi_fp */
    case 228:  /* *millicode_sibthunk_ld */
    case 227:  /* *millicode_thunk_ld */
    case 226:  /* *millicode_thunk_st */
    case 223:  /* *cmpdf_ord */
    case 222:  /* *cmpdf_uneq */
    case 221:  /* *cmpdf_ge */
    case 220:  /* *cmpdf_gt */
    case 219:  /* *cmpdf_eq */
    case 218:  /* *cmpsf_ord */
    case 217:  /* *cmpsf_uneq */
    case 216:  /* *cmpsf_ge */
    case 215:  /* *cmpsf_gt */
    case 214:  /* *cmpsf_eq */
    case 204:  /* *sibcall_value_insn */
    case 203:  /* *sibcall_insn */
    case 168:  /* *call_value_i */
    case 167:  /* *call_i */
    case 166:  /* casesi_jump */
    case 163:  /* indirect_jump */
    case 162:  /* jump_i */
    case 161:  /* *rev_branch_insn */
    case 160:  /* *branch_insn */
      extract_constrain_insn_cached (insn);
      if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))))
        {
	  return 42 /* 0x2a */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case 693:  /* *p umac64_600 */
    case 689:  /* *p mac64_600 */
    case 688:  /* *p mul64_600 */
    case 682:  /* *p mac_600 */
    case 92:  /* umac64_600 */
    case 91:  /* umul64_600 */
    case 85:  /* mac64_600 */
    case 84:  /* mul64_600 */
    case 74:  /* mac_600 */
    case 73:  /* umul_600 */
      if ((
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600)))
        {
	  return 5;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      extract_constrain_insn_cached (insn);
      if (((
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 0;
        }
      else if (((
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (GET_MODE (operands[0]) == DImode))
        {
	  return 1;
        }
      else if (((
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD) && (! (GET_MODE (operands[0]) == DImode)))
        {
	  return 2;
        }
      else if (((
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (
#line 48 "../../gcc-14.1.1-20240508/gcc/config/arc/arc600.md"
(arc_multcost < COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 3;
        }
      else if (((
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (
#line 54 "../../gcc-14.1.1-20240508/gcc/config/arc/arc600.md"
(arc_multcost >= COSTS_N_INSNS (7))) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 4;
        }
      else if (((
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && ((cached_type = get_attr_type (insn)) == TYPE_MULMAC_600))
        {
	  return 5;
        }
      else if (((cached_tune_arc700 = get_attr_tune_arc700 (insn)) == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_BINARY)) && (GET_MODE (operands[0]) == DImode))
        {
	  return 6;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LR))
        {
	  return 7;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SR))
        {
	  return 8;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && (((cached_type = get_attr_type (insn)) == TYPE_UNARY) || (cached_type == TYPE_MOVE) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_ADD) || (cached_type == TYPE_SUB) || (cached_type == TYPE_BXOR)))
        {
	  return 9;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CMOVE))
        {
	  return 10 /* 0xa */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH))
        {
	  return 11 /* 0xb */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_TWO_CYCLE_CORE))
        {
	  return 12 /* 0xc */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_DIVAW))
        {
	  return 13 /* 0xd */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_SHIFT))
        {
	  return 14 /* 0xe */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 15 /* 0xf */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_COMPARE))
        {
	  return 16 /* 0x10 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 17 /* 0x11 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI) && (GET_MODE (operands[0]) == DImode))
        {
	  return 18 /* 0x12 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_UMULTI))
        {
	  return 19 /* 0x13 */;
        }
      else if ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 21 /* 0x15 */;
        }
      else if ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD)))) && ((cached_type = get_attr_type (insn)) == TYPE_MULTI))
        {
	  return 22 /* 0x16 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 23 /* 0x17 */;
        }
      else if ((cached_tune_arc700 == TUNE_ARC700_TRUE) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 24 /* 0x18 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 25 /* 0x19 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 26 /* 0x1a */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 39 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option > 0)) && (
#line 40 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 2)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 27 /* 0x1b */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 46 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option > 2)) && (
#line 47 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option <= 5)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 28 /* 0x1c */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && ((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM))
        {
	  return 29 /* 0x1d */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 59 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option == 2)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 30 /* 0x1e */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 65 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option == 3)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 31 /* 0x1f */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 71 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option == 4)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 32 /* 0x20 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 78 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option == 5)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 33 /* 0x21 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 53 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(arc_mpy_option == 6)) && (((cached_type = get_attr_type (insn)) == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 34 /* 0x22 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_EM)) && (
#line 91 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 35 /* 0x23 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 36 /* 0x24 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 37 /* 0x25 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 38 /* 0x26 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC) || (cached_type == TYPE_ADD) || (cached_type == TYPE_SUB) || (cached_type == TYPE_BXOR)))
        {
	  return 39 /* 0x27 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (
#line 91 "../../gcc-14.1.1-20240508/gcc/config/arc/arcEM.md"
(TARGET_DIVREM)) && (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 40 /* 0x28 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD))) && (! (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 41 /* 0x29 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CALL) || (cached_type == TYPE_CALL_NO_DELAY_SLOT) || (cached_type == TYPE_UNCOND_BRANCH) || (cached_type == TYPE_JUMP) || (cached_type == TYPE_BRANCH) || (cached_type == TYPE_SFUNC)))
        {
	  return 42 /* 0x2a */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_BRCC) || (cached_type == TYPE_BRCC_NO_DELAY_SLOT) || (cached_type == TYPE_LOOP_END)))
        {
	  return 43 /* 0x2b */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 44 /* 0x2c */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 45 /* 0x2d */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A)))) && ((cached_type = get_attr_type (insn)) == TYPE_STORE))
        {
	  return 46 /* 0x2e */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 47 /* 0x2f */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW))))) && (((cached_type = get_attr_type (insn)) == TYPE_CC_ARITH) || (cached_type == TYPE_TWO_CYCLE_CORE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_LR) || (cached_type == TYPE_SR)))
        {
	  return 48 /* 0x30 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC) || (cached_type == TYPE_ADD) || (cached_type == TYPE_SUB) || (cached_type == TYPE_BXOR)))
        {
	  return 49 /* 0x31 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_UNARY) || (cached_type == TYPE_BINARY) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_MISC)))
        {
	  return 50 /* 0x32 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_DIV_REM))
        {
	  return 51 /* 0x33 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && (((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 52 /* 0x34 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)))) && (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))) && (((cached_type = get_attr_type (insn)) == TYPE_MUL16_EM) || (cached_type == TYPE_MULTI) || (cached_type == TYPE_UMULTI)))
        {
	  return 53 /* 0x35 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU))
        {
	  return 54 /* 0x36 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_FUSE))
        {
	  return 55 /* 0x37 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_SDIV))
        {
	  return 56 /* 0x38 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_DDIV))
        {
	  return 57 /* 0x39 */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/arcHS.md"
(TARGET_HS)) && ((((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && ((
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X)) || (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))))) || (((! (
#line 608 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC600))) && (! (
#line 610 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC7XX))) && (! (
#line 612 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_STD))) && (! (
#line 614 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARC700_4_2_XMAC))) && (! (
#line 616 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X))) && (! (
#line 617 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4X_REL31A))) && ((
#line 619 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD)) || (
#line 620 "../../gcc-14.1.1-20240508/gcc/config/arc/arc.md"
(arc_tune == ARC_TUNE_ARCHS4XD_SLOW)))))) && ((cached_type = get_attr_type (insn)) == TYPE_FPU_CVT))
        {
	  return 58 /* 0x3a */;
        }
      else if ((
#line 27 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_SPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 59 /* 0x3b */;
        }
      else if ((
#line 32 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_SPFP_FAST_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_SPFP))
        {
	  return 60 /* 0x3c */;
        }
      else if ((
#line 37 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT))
        {
	  return 61 /* 0x3d */;
        }
      else if ((
#line 37 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_DPFP_COMPACT_SET)) && ((cached_type = get_attr_type (insn)) == TYPE_DPFP_ADDSUB))
        {
	  return 62 /* 0x3e */;
        }
      else if ((
#line 47 "../../gcc-14.1.1-20240508/gcc/config/arc/fpx.md"
(TARGET_DPFP_FAST_SET)) && (((cached_type = get_attr_type (insn)) == TYPE_DPFP_MULT) || (cached_type == TYPE_DPFP_ADDSUB)))
        {
	  return 63 /* 0x3f */;
        }
      else if (((cached_type = get_attr_type (insn)) == TYPE_SIMD_DMA) || (cached_type == TYPE_SIMD_VSTORE) || (cached_type == TYPE_SIMD_VCONTROL))
        {
	  return 64 /* 0x40 */;
        }
      else if ((cached_type == TYPE_SIMD_VCOMPARE) || (cached_type == TYPE_SIMD_VLOGIC) || (cached_type == TYPE_SIMD_VMOVE_ELSE_ZERO) || (cached_type == TYPE_SIMD_VARITH_1CYCLE))
        {
	  return 65 /* 0x41 */;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN) || (cached_type == TYPE_SIMD_VPERMUTE) || (cached_type == TYPE_SIMD_VPACK) || (cached_type == TYPE_SIMD_VARITH_2CYCLE))
        {
	  return 66 /* 0x42 */;
        }
      else if ((cached_type == TYPE_SIMD_VALIGN_WITH_ACC) || (cached_type == TYPE_SIMD_VPACK_WITH_ACC) || (cached_type == TYPE_SIMD_VLOGIC_WITH_ACC) || (cached_type == TYPE_SIMD_VLOAD128) || (cached_type == TYPE_SIMD_VMOVE_WITH_ACC) || (cached_type == TYPE_SIMD_VSPECIAL_3CYCLE) || (cached_type == TYPE_SIMD_VARITH_WITH_ACC))
        {
	  return 67 /* 0x43 */;
        }
      else if ((cached_type == TYPE_SIMD_VLOAD) || (cached_type == TYPE_SIMD_VMOVE) || (cached_type == TYPE_SIMD_VSPECIAL_4CYCLE))
        {
	  return 68 /* 0x44 */;
        }
      else
        {
	  return 70 /* 0x46 */;
        }

    }
}

