/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"
#include "dfp.h"
#include "output.h"
#include "recog.h"
#include "df.h"
#include "resource.h"
#include "reload.h"
#include "diagnostic-core.h"
#include "regs.h"
#include "tm-constrs.h"
#include "ggc.h"
#include "target.h"

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:159 */
rtx
gen_cmpxchg_rel_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1)),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (3,
		copy_rtx (operand1),
		operand2,
		operand3),
	17))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:173 */
rtx
gen_cmpxchg_acq_di (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (3,
		copy_rtx (operand1),
		operand2,
		operand3),
	16))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:185 */
rtx
gen_cmpxchg_rel_di (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (3,
		copy_rtx (operand1),
		operand2,
		operand3),
	17))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:226 */
rtx
gen_xchg_acq_qi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:226 */
rtx
gen_xchg_acq_hi (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:226 */
rtx
gen_xchg_acq_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:226 */
rtx
gen_xchg_acq_di (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:312 */
rtx
gen_fetchadd_acq_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		copy_rtx (operand1),
		operand2),
	18))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:312 */
rtx
gen_fetchadd_acq_di (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (2,
		copy_rtx (operand1),
		operand2),
	18))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:323 */
rtx
gen_fetchadd_rel_si (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		copy_rtx (operand1),
		operand2),
	19))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/sync.md:323 */
rtx
gen_fetchadd_rel_di (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	operand1),
		gen_rtx_SET (copy_rtx (operand1),
	gen_rtx_UNSPEC (DImode,
	gen_rtvec (2,
		copy_rtx (operand1),
		operand2),
	19))));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:38 */
rtx
gen_addrf3_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_PLUS (RFmode,
	operand2,
	operand3),
	operand4)),
		gen_rtx_USE (VOIDmode,
	operand5),
		gen_rtx_USE (VOIDmode,
	operand6)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:53 */
rtx
gen_subrf3_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_MINUS (RFmode,
	operand2,
	operand3),
	operand4)),
		gen_rtx_USE (VOIDmode,
	operand5),
		gen_rtx_USE (VOIDmode,
	operand6)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:68 */
rtx
gen_mulrf3_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_MULT (RFmode,
	operand2,
	operand3),
	operand4)),
		gen_rtx_USE (VOIDmode,
	operand5),
		gen_rtx_USE (VOIDmode,
	operand6)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:85 */
rtx
gen_nmulrf3_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_NEG (RFmode,
	gen_rtx_MULT (RFmode,
	operand2,
	operand3)),
	operand4)),
		gen_rtx_USE (VOIDmode,
	operand5),
		gen_rtx_USE (VOIDmode,
	operand6)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:102 */
rtx
gen_m1addrf4_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED,
	rtx operand7 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_PLUS (RFmode,
	gen_rtx_MULT (RFmode,
	operand2,
	operand3),
	operand4),
	operand5)),
		gen_rtx_USE (VOIDmode,
	operand6),
		gen_rtx_USE (VOIDmode,
	operand7)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:119 */
rtx
gen_m1subrf4_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED,
	rtx operand7 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_MINUS (RFmode,
	gen_rtx_MULT (RFmode,
	operand2,
	operand3),
	operand4),
	operand5)),
		gen_rtx_USE (VOIDmode,
	operand6),
		gen_rtx_USE (VOIDmode,
	operand7)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:138 */
rtx
gen_m2addrf4_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED,
	rtx operand7 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_PLUS (RFmode,
	operand2,
	gen_rtx_MULT (RFmode,
	operand3,
	operand4)),
	operand5)),
		gen_rtx_USE (VOIDmode,
	operand6),
		gen_rtx_USE (VOIDmode,
	operand7)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:155 */
rtx
gen_m2subrf4_cond (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED,
	rtx operand5 ATTRIBUTE_UNUSED,
	rtx operand6 ATTRIBUTE_UNUSED,
	rtx operand7 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_IF_THEN_ELSE (RFmode,
	gen_rtx_NE (RFmode,
	operand1,
	const0_rtx),
	gen_rtx_MINUS (RFmode,
	operand2,
	gen_rtx_MULT (RFmode,
	operand3,
	operand4)),
	operand5)),
		gen_rtx_USE (VOIDmode,
	operand6),
		gen_rtx_USE (VOIDmode,
	operand7)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:180 */
rtx
gen_extendsfrf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_EXTEND (RFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:180 */
rtx
gen_extenddfrf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_EXTEND (RFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:180 */
rtx
gen_extendxfrf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_EXTEND (RFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:203 */
rtx
gen_truncrfsf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_TRUNCATE (SFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:203 */
rtx
gen_truncrfdf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_TRUNCATE (DFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:203 */
rtx
gen_truncrfxf2 (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_FLOAT_TRUNCATE (XFmode,
	operand1));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:227 */
rtx
gen_fix_truncrfdi2_alts (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_FIX (DImode,
	operand1)),
		gen_rtx_USE (VOIDmode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:235 */
rtx
gen_fixuns_truncrfdi2_alts (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (2,
		gen_rtx_SET (operand0,
	gen_rtx_UNSIGNED_FIX (DImode,
	operand1)),
		gen_rtx_USE (VOIDmode,
	operand2)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:243 */
rtx
gen_setf_exp_rf (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED)
{
  return gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (RFmode,
	gen_rtvec (1,
		operand1),
	26));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:253 */
rtx
gen_recip_approx_rf (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED,
	rtx operand4 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (RFmode,
	gen_rtvec (2,
		operand1,
		operand2),
	40)),
		gen_rtx_SET (operand3,
	gen_rtx_UNSPEC (CCImode,
	gen_rtvec (2,
		copy_rtx (operand1),
		copy_rtx (operand2)),
	11)),
		gen_rtx_USE (VOIDmode,
	operand4)));
}

/* ../../gcc-14.1.1-20240508/gcc/config/ia64/div.md:919 */
rtx
gen_sqrt_approx_rf (rtx operand0 ATTRIBUTE_UNUSED,
	rtx operand1 ATTRIBUTE_UNUSED,
	rtx operand2 ATTRIBUTE_UNUSED,
	rtx operand3 ATTRIBUTE_UNUSED)
{
  return gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (3,
		gen_rtx_SET (operand0,
	gen_rtx_UNSPEC (RFmode,
	gen_rtvec (1,
		operand1),
	41)),
		gen_rtx_SET (operand2,
	gen_rtx_UNSPEC (CCImode,
	gen_rtvec (1,
		copy_rtx (operand1)),
	27)),
		gen_rtx_USE (VOIDmode,
	operand3)));
}

