/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 2177:
    case 2176:
      for (i = XVECLEN (pat, 0) - 1; i >= 0; i--)
          ro[i] = *(ro_loc[i] = &XVECEXP (pat, 0, i));
      break;

    case 2137:  /* lasx_xvpermi_w_f_1 */
    case 2136:  /* lasx_xvpermi_w_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 2));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 3));
      ro[7] = *(ro_loc[7] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 4));
      ro[8] = *(ro_loc[8] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 5));
      ro[9] = *(ro_loc[9] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 6));
      ro[10] = *(ro_loc[10] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 7));
      break;

    case 1800:  /* lasx_xvrepl128vei_d_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 2));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 3);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 1);
      recog_data.dup_num[1] = 2;
      break;

    case 1799:  /* lasx_xvrepl128vei_w_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 4));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 7);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 6);
      recog_data.dup_num[1] = 3;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 5);
      recog_data.dup_num[2] = 3;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 3);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 2);
      recog_data.dup_num[4] = 2;
      recog_data.dup_loc[5] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 1);
      recog_data.dup_num[5] = 2;
      break;

    case 1798:  /* lasx_xvrepl128vei_h_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 8));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 15);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 14);
      recog_data.dup_num[1] = 3;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 13);
      recog_data.dup_num[2] = 3;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 12);
      recog_data.dup_num[3] = 3;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 11);
      recog_data.dup_num[4] = 3;
      recog_data.dup_loc[5] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 10);
      recog_data.dup_num[5] = 3;
      recog_data.dup_loc[6] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 9);
      recog_data.dup_num[6] = 3;
      recog_data.dup_loc[7] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 7);
      recog_data.dup_num[7] = 2;
      recog_data.dup_loc[8] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 6);
      recog_data.dup_num[8] = 2;
      recog_data.dup_loc[9] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 5);
      recog_data.dup_num[9] = 2;
      recog_data.dup_loc[10] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 4);
      recog_data.dup_num[10] = 2;
      recog_data.dup_loc[11] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 3);
      recog_data.dup_num[11] = 2;
      recog_data.dup_loc[12] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 2);
      recog_data.dup_num[12] = 2;
      recog_data.dup_loc[13] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 1);
      recog_data.dup_num[13] = 2;
      break;

    case 1797:  /* lasx_xvrepl128vei_b_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 16));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 31);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 30);
      recog_data.dup_num[1] = 3;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 29);
      recog_data.dup_num[2] = 3;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 28);
      recog_data.dup_num[3] = 3;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 27);
      recog_data.dup_num[4] = 3;
      recog_data.dup_loc[5] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 26);
      recog_data.dup_num[5] = 3;
      recog_data.dup_loc[6] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 25);
      recog_data.dup_num[6] = 3;
      recog_data.dup_loc[7] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 24);
      recog_data.dup_num[7] = 3;
      recog_data.dup_loc[8] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 23);
      recog_data.dup_num[8] = 3;
      recog_data.dup_loc[9] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 22);
      recog_data.dup_num[9] = 3;
      recog_data.dup_loc[10] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 21);
      recog_data.dup_num[10] = 3;
      recog_data.dup_loc[11] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 20);
      recog_data.dup_num[11] = 3;
      recog_data.dup_loc[12] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 19);
      recog_data.dup_num[12] = 3;
      recog_data.dup_loc[13] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 18);
      recog_data.dup_num[13] = 3;
      recog_data.dup_loc[14] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 17);
      recog_data.dup_num[14] = 3;
      recog_data.dup_loc[15] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 15);
      recog_data.dup_num[15] = 2;
      recog_data.dup_loc[16] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 14);
      recog_data.dup_num[16] = 2;
      recog_data.dup_loc[17] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 13);
      recog_data.dup_num[17] = 2;
      recog_data.dup_loc[18] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 12);
      recog_data.dup_num[18] = 2;
      recog_data.dup_loc[19] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 11);
      recog_data.dup_num[19] = 2;
      recog_data.dup_loc[20] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 10);
      recog_data.dup_num[20] = 2;
      recog_data.dup_loc[21] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 9);
      recog_data.dup_num[21] = 2;
      recog_data.dup_loc[22] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 8);
      recog_data.dup_num[22] = 2;
      recog_data.dup_loc[23] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 7);
      recog_data.dup_num[23] = 2;
      recog_data.dup_loc[24] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 6);
      recog_data.dup_num[24] = 2;
      recog_data.dup_loc[25] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 5);
      recog_data.dup_num[25] = 2;
      recog_data.dup_loc[26] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 4);
      recog_data.dup_num[26] = 2;
      recog_data.dup_loc[27] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 3);
      recog_data.dup_num[27] = 2;
      recog_data.dup_loc[28] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 2);
      recog_data.dup_num[28] = 2;
      recog_data.dup_loc[29] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 1);
      recog_data.dup_num[29] = 2;
      break;

    case 1760:  /* lasx_xvshuf4i_w_f_1 */
    case 1759:  /* lasx_xvshuf4i_w_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 5));
      ro[8] = *(ro_loc[8] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 6));
      ro[9] = *(ro_loc[9] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 7));
      break;

    case 1445:  /* lasx_xvpermi_d_v4df_1 */
    case 1444:  /* lasx_xvpermi_d_v4di_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 3));
      break;

    case 2052:  /* lasx_xvmaddwod_d_wu_w */
    case 2051:  /* lasx_xvmaddwod_w_hu_h */
    case 2050:  /* lasx_xvmaddwod_h_bu_b */
    case 2048:  /* lasx_xvmaddwev_d_wu_w */
    case 2047:  /* lasx_xvmaddwev_w_hu_h */
    case 2046:  /* lasx_xvmaddwev_h_bu_b */
    case 2042:  /* lasx_xvmaddwod_d_wu */
    case 2041:  /* lasx_xvmaddwod_d_w */
    case 2040:  /* lasx_xvmaddwod_w_hu */
    case 2039:  /* lasx_xvmaddwod_w_h */
    case 2038:  /* lasx_xvmaddwod_h_bu */
    case 2037:  /* lasx_xvmaddwod_h_b */
    case 2035:  /* lasx_xvmaddwev_d_wu */
    case 2034:  /* lasx_xvmaddwev_d_w */
    case 2033:  /* lasx_xvmaddwev_w_hu */
    case 2032:  /* lasx_xvmaddwev_w_h */
    case 2031:  /* lasx_xvmaddwev_h_bu */
    case 2030:  /* lasx_xvmaddwev_h_b */
    case 1356:  /* lsx_vmaddwod_h_bu_b */
    case 1355:  /* lsx_vmaddwod_w_hu_h */
    case 1354:  /* lsx_vmaddwod_d_wu_w */
    case 1353:  /* lsx_vmaddwev_h_bu_b */
    case 1352:  /* lsx_vmaddwev_w_hu_h */
    case 1351:  /* lsx_vmaddwev_d_wu_w */
    case 1350:  /* lsx_vmaddwod_h_bu */
    case 1349:  /* lsx_vmaddwod_h_b */
    case 1348:  /* lsx_vmaddwod_w_hu */
    case 1347:  /* lsx_vmaddwod_w_h */
    case 1346:  /* lsx_vmaddwod_d_wu */
    case 1345:  /* lsx_vmaddwod_d_w */
    case 1344:  /* lsx_vmaddwev_h_bu */
    case 1343:  /* lsx_vmaddwev_h_b */
    case 1342:  /* lsx_vmaddwev_w_hu */
    case 1341:  /* lsx_vmaddwev_w_h */
    case 1340:  /* lsx_vmaddwev_d_wu */
    case 1339:  /* lsx_vmaddwev_d_w */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0), 0));
      break;

    case 1270:  /* lsx_vseteqz_v */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 2170:  /* lasx_xvstx */
    case 1268:  /* lsx_vstx */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      break;

    case 2166:  /* xvornv32qi3 */
    case 2165:  /* xvornv16hi3 */
    case 2164:  /* xvornv8si3 */
    case 2163:  /* xvornv4di3 */
    case 1264:  /* vornv16qi3 */
    case 1263:  /* vornv8hi3 */
    case 1262:  /* vornv4si3 */
    case 1261:  /* vornv2di3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 2147:  /* lasx_xvstelm_w_f_insn_0 */
    case 2146:  /* lasx_xvstelm_w_insn_0 */
    case 2145:  /* lasx_xvstelm_d_f_insn_0 */
    case 2144:  /* lasx_xvstelm_d_insn_0 */
    case 1254:  /* lsx_vstelm_b_insn_0 */
    case 1253:  /* lsx_vstelm_h_insn_0 */
    case 1252:  /* lsx_vstelm_w_insn_0 */
    case 1251:  /* lsx_vstelm_d_insn_0 */
    case 1250:  /* lsx_vstelm_w_f_insn_0 */
    case 1249:  /* lsx_vstelm_d_f_insn_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 2143:  /* lasx_xvstelm_b_insn */
    case 2142:  /* lasx_xvstelm_h_insn */
    case 2141:  /* lasx_xvstelm_w_insn */
    case 2140:  /* lasx_xvstelm_d_insn */
    case 2139:  /* lasx_xvstelm_w_f_insn */
    case 2138:  /* lasx_xvstelm_d_f_insn */
    case 1248:  /* lsx_vstelm_b_insn */
    case 1247:  /* lsx_vstelm_h_insn */
    case 1246:  /* lsx_vstelm_w_insn */
    case 1245:  /* lsx_vstelm_d_insn */
    case 1244:  /* lsx_vstelm_w_f_insn */
    case 1243:  /* lsx_vstelm_d_f_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 1963:  /* lasx_xvldrepl_b_insn */
    case 1962:  /* lasx_xvldrepl_h_insn */
    case 1961:  /* lasx_xvldrepl_w_insn */
    case 1960:  /* lasx_xvldrepl_d_insn */
    case 1959:  /* lasx_xvldrepl_w_f_insn */
    case 1958:  /* lasx_xvldrepl_d_f_insn */
    case 1236:  /* lsx_vldrepl_b_insn */
    case 1235:  /* lsx_vldrepl_h_insn */
    case 1234:  /* lsx_vldrepl_w_insn */
    case 1233:  /* lsx_vldrepl_d_insn */
    case 1232:  /* lsx_vldrepl_w_f_insn */
    case 1231:  /* lsx_vldrepl_d_f_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 1842:  /* lasx_xbnz_v_b */
    case 1841:  /* lasx_xbz_v_b */
    case 1840:  /* lasx_xbnz_v_h */
    case 1839:  /* lasx_xbz_v_h */
    case 1838:  /* lasx_xbnz_v_w */
    case 1837:  /* lasx_xbz_v_w */
    case 1836:  /* lasx_xbnz_v_d */
    case 1835:  /* lasx_xbz_v_d */
    case 1834:  /* lasx_xbnz_v_w_f */
    case 1833:  /* lasx_xbz_v_w_f */
    case 1832:  /* lasx_xbnz_v_d_f */
    case 1831:  /* lasx_xbz_v_d_f */
    case 1830:  /* lasx_xbnz_b */
    case 1829:  /* lasx_xbz_b */
    case 1828:  /* lasx_xbnz_h */
    case 1827:  /* lasx_xbz_h */
    case 1826:  /* lasx_xbnz_w */
    case 1825:  /* lasx_xbz_w */
    case 1824:  /* lasx_xbnz_d */
    case 1823:  /* lasx_xbz_d */
    case 1822:  /* lasx_xbnz_w_f */
    case 1821:  /* lasx_xbz_w_f */
    case 1820:  /* lasx_xbnz_d_f */
    case 1819:  /* lasx_xbz_d_f */
    case 1112:  /* lsx_bnz_v_b */
    case 1111:  /* lsx_bz_v_b */
    case 1110:  /* lsx_bnz_v_h */
    case 1109:  /* lsx_bz_v_h */
    case 1108:  /* lsx_bnz_v_w */
    case 1107:  /* lsx_bz_v_w */
    case 1106:  /* lsx_bnz_v_d */
    case 1105:  /* lsx_bz_v_d */
    case 1104:  /* lsx_bnz_v_w_f */
    case 1103:  /* lsx_bz_v_w_f */
    case 1102:  /* lsx_bnz_v_d_f */
    case 1101:  /* lsx_bz_v_d_f */
    case 1100:  /* lsx_bnz_b */
    case 1099:  /* lsx_bz_b */
    case 1098:  /* lsx_bnz_h */
    case 1097:  /* lsx_bz_h */
    case 1096:  /* lsx_bnz_w */
    case 1095:  /* lsx_bz_w */
    case 1094:  /* lsx_bnz_d */
    case 1093:  /* lsx_bz_d */
    case 1092:  /* lsx_bnz_w_f */
    case 1091:  /* lsx_bz_w_f */
    case 1090:  /* lsx_bnz_d_f */
    case 1089:  /* lsx_bz_d_f */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 2029:  /* lasx_xvmulwod_d_wu_w */
    case 2028:  /* lasx_xvaddwod_d_wu_w */
    case 2027:  /* lasx_xvmulwod_w_hu_h */
    case 2026:  /* lasx_xvaddwod_w_hu_h */
    case 2025:  /* lasx_xvmulwod_h_bu_b */
    case 2024:  /* lasx_xvaddwod_h_bu_b */
    case 2023:  /* lasx_xvmulwev_d_wu_w */
    case 2022:  /* lasx_xvaddwev_d_wu_w */
    case 2021:  /* lasx_xvmulwev_w_hu_h */
    case 2020:  /* lasx_xvaddwev_w_hu_h */
    case 2019:  /* lasx_xvmulwev_h_bu_b */
    case 2018:  /* lasx_xvaddwev_h_bu_b */
    case 2008:  /* lasx_xvmulwod_d_wu */
    case 2007:  /* lasx_xvmulwod_d_w */
    case 2006:  /* lasx_xvsubwod_d_wu */
    case 2005:  /* lasx_xvsubwod_d_w */
    case 2004:  /* lasx_xvaddwod_d_wu */
    case 2003:  /* lasx_xvaddwod_d_w */
    case 2002:  /* lasx_xvmulwod_w_hu */
    case 2001:  /* lasx_xvmulwod_w_h */
    case 2000:  /* lasx_xvsubwod_w_hu */
    case 1999:  /* lasx_xvsubwod_w_h */
    case 1998:  /* lasx_xvaddwod_w_hu */
    case 1997:  /* lasx_xvaddwod_w_h */
    case 1996:  /* lasx_xvmulwod_h_bu */
    case 1995:  /* lasx_xvmulwod_h_b */
    case 1994:  /* lasx_xvsubwod_h_bu */
    case 1993:  /* lasx_xvsubwod_h_b */
    case 1992:  /* lasx_xvaddwod_h_bu */
    case 1991:  /* lasx_xvaddwod_h_b */
    case 1987:  /* lasx_xvmulwev_d_wu */
    case 1986:  /* lasx_xvmulwev_d_w */
    case 1985:  /* lasx_xvsubwev_d_wu */
    case 1984:  /* lasx_xvsubwev_d_w */
    case 1983:  /* lasx_xvaddwev_d_wu */
    case 1982:  /* lasx_xvaddwev_d_w */
    case 1981:  /* lasx_xvmulwev_w_hu */
    case 1980:  /* lasx_xvmulwev_w_h */
    case 1979:  /* lasx_xvsubwev_w_hu */
    case 1978:  /* lasx_xvsubwev_w_h */
    case 1977:  /* lasx_xvaddwev_w_hu */
    case 1976:  /* lasx_xvaddwev_w_h */
    case 1975:  /* lasx_xvmulwev_h_bu */
    case 1974:  /* lasx_xvmulwev_h_b */
    case 1973:  /* lasx_xvsubwev_h_bu */
    case 1972:  /* lasx_xvsubwev_h_b */
    case 1971:  /* lasx_xvaddwev_h_bu */
    case 1970:  /* lasx_xvaddwev_h_b */
    case 1686:  /* lasx_xvhsubw_du_wu */
    case 1685:  /* lasx_xvhsubw_d_w */
    case 1684:  /* lasx_xvhaddw_du_wu */
    case 1683:  /* lasx_xvhaddw_d_w */
    case 1682:  /* lasx_xvhsubw_wu_hu */
    case 1681:  /* lasx_xvhsubw_w_h */
    case 1680:  /* lasx_xvhaddw_wu_hu */
    case 1679:  /* lasx_xvhaddw_w_h */
    case 1678:  /* lasx_xvhsubw_hu_bu */
    case 1677:  /* lasx_xvhsubw_h_b */
    case 1676:  /* lasx_xvhaddw_hu_bu */
    case 1675:  /* lasx_xvhaddw_h_b */
    case 1318:  /* lsx_vmulwod_h_bu_b */
    case 1317:  /* lsx_vaddwod_h_bu_b */
    case 1316:  /* lsx_vmulwod_w_hu_h */
    case 1315:  /* lsx_vaddwod_w_hu_h */
    case 1314:  /* lsx_vmulwod_d_wu_w */
    case 1313:  /* lsx_vaddwod_d_wu_w */
    case 1312:  /* lsx_vmulwev_h_bu_b */
    case 1311:  /* lsx_vaddwev_h_bu_b */
    case 1310:  /* lsx_vmulwev_w_hu_h */
    case 1309:  /* lsx_vaddwev_w_hu_h */
    case 1308:  /* lsx_vmulwev_d_wu_w */
    case 1307:  /* lsx_vaddwev_d_wu_w */
    case 1306:  /* lsx_vmulwod_h_bu */
    case 1305:  /* lsx_vmulwod_h_b */
    case 1304:  /* lsx_vsubwod_h_bu */
    case 1303:  /* lsx_vsubwod_h_b */
    case 1302:  /* lsx_vaddwod_h_bu */
    case 1301:  /* lsx_vaddwod_h_b */
    case 1300:  /* lsx_vmulwod_w_hu */
    case 1299:  /* lsx_vmulwod_w_h */
    case 1298:  /* lsx_vsubwod_w_hu */
    case 1297:  /* lsx_vsubwod_w_h */
    case 1296:  /* lsx_vaddwod_w_hu */
    case 1295:  /* lsx_vaddwod_w_h */
    case 1294:  /* lsx_vmulwod_d_wu */
    case 1293:  /* lsx_vmulwod_d_w */
    case 1292:  /* lsx_vsubwod_d_wu */
    case 1291:  /* lsx_vsubwod_d_w */
    case 1290:  /* lsx_vaddwod_d_wu */
    case 1289:  /* lsx_vaddwod_d_w */
    case 1288:  /* lsx_vmulwev_h_bu */
    case 1287:  /* lsx_vmulwev_h_b */
    case 1286:  /* lsx_vsubwev_h_bu */
    case 1285:  /* lsx_vsubwev_h_b */
    case 1284:  /* lsx_vaddwev_h_bu */
    case 1283:  /* lsx_vaddwev_h_b */
    case 1282:  /* lsx_vmulwev_w_hu */
    case 1281:  /* lsx_vmulwev_w_h */
    case 1280:  /* lsx_vsubwev_w_hu */
    case 1279:  /* lsx_vsubwev_w_h */
    case 1278:  /* lsx_vaddwev_w_hu */
    case 1277:  /* lsx_vaddwev_w_h */
    case 1276:  /* lsx_vmulwev_d_wu */
    case 1275:  /* lsx_vmulwev_d_w */
    case 1274:  /* lsx_vsubwev_d_wu */
    case 1273:  /* lsx_vsubwev_d_w */
    case 1272:  /* lsx_vaddwev_d_wu */
    case 1271:  /* lsx_vaddwev_d_w */
    case 961:  /* lsx_vhsubw_du_wu */
    case 960:  /* lsx_vhsubw_d_w */
    case 959:  /* lsx_vhaddw_du_wu */
    case 958:  /* lsx_vhaddw_d_w */
    case 957:  /* lsx_vhsubw_wu_hu */
    case 956:  /* lsx_vhsubw_w_h */
    case 955:  /* lsx_vhaddw_wu_hu */
    case 954:  /* lsx_vhaddw_w_h */
    case 953:  /* lsx_vhsubw_hu_bu */
    case 952:  /* lsx_vhsubw_h_b */
    case 951:  /* lsx_vhaddw_hu_bu */
    case 950:  /* lsx_vhaddw_h_b */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 1612:  /* lasx_xvbitseli_b */
    case 887:  /* lsx_vbitseli_b */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1611:  /* lasx_xvbitsel_b */
    case 1610:  /* lasx_xvbitsel_h */
    case 1609:  /* lasx_xvbitsel_w */
    case 1608:  /* lasx_xvbitsel_d */
    case 1607:  /* lasx_xvbitsel_w_f */
    case 1606:  /* lasx_xvbitsel_d_f */
    case 886:  /* lsx_vbitsel_b */
    case 885:  /* lsx_vbitsel_h */
    case 884:  /* lsx_vbitsel_w */
    case 883:  /* lsx_vbitsel_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0);
      recog_data.dup_num[0] = 3;
      break;

    case 1489:  /* lasx_xvmsub_b */
    case 1488:  /* lasx_xvmsub_h */
    case 1487:  /* lasx_xvmsub_w */
    case 1486:  /* lasx_xvmsub_d */
    case 766:  /* lsx_vmsub_b */
    case 765:  /* lsx_vmsub_h */
    case 764:  /* lsx_vmsub_w */
    case 763:  /* lsx_vmsub_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 1485:  /* lasx_xvmadd_b */
    case 1484:  /* lasx_xvmadd_h */
    case 1483:  /* lasx_xvmadd_w */
    case 1482:  /* lasx_xvmadd_d */
    case 762:  /* lsx_vmadd_b */
    case 761:  /* lsx_vmadd_h */
    case 760:  /* lsx_vmadd_w */
    case 759:  /* lsx_vmadd_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 2159:  /* lasx_xvpickve_w_f_scalar */
    case 2158:  /* lasx_xvpickve_d_f_scalar */
    case 735:  /* lsx_vpickve2gr_d_f */
    case 734:  /* lsx_vpickve2gr_d */
    case 733:  /* lsx_vpickve2gr_du */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 2074:  /* lasx_xvpickve2gr_wu */
    case 2073:  /* lasx_xvpickve2gr_w */
    case 1459:  /* lasx_xvpickve2gr_du */
    case 1458:  /* lasx_xvpickve2gr_d */
    case 1075:  /* lsx_vreplvei_b */
    case 1074:  /* lsx_vreplvei_h */
    case 1073:  /* lsx_vreplvei_w */
    case 1072:  /* lsx_vreplvei_d */
    case 1071:  /* lsx_vreplvei_w_f */
    case 1070:  /* lsx_vreplvei_d_f */
    case 1063:  /* lsx_vreplve_b */
    case 1062:  /* lsx_vreplve_h */
    case 1061:  /* lsx_vreplve_w */
    case 1060:  /* lsx_vreplve_d */
    case 1059:  /* lsx_vreplve_w_f */
    case 1058:  /* lsx_vreplve_d_f */
    case 732:  /* lsx_vpickve2gr_w_fu */
    case 731:  /* lsx_vpickve2gr_w_f */
    case 730:  /* lsx_vpickve2gr_wu */
    case 729:  /* lsx_vpickve2gr_w */
    case 728:  /* lsx_vpickve2gr_bu */
    case 727:  /* lsx_vpickve2gr_b */
    case 726:  /* lsx_vpickve2gr_hu */
    case 725:  /* lsx_vpickve2gr_h */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0, 0));
      break;

    case 722:  /* lsx_vextrins_b_internal */
    case 721:  /* lsx_vextrins_h_internal */
    case 720:  /* lsx_vextrins_w_internal */
    case 719:  /* lsx_vextrins_d_internal */
    case 718:  /* lsx_vextrins_w_f_internal */
    case 717:  /* lsx_vextrins_d_f_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 559:  /* umulv32qi3_highpart */
    case 558:  /* smulv32qi3_highpart */
    case 557:  /* umulv16hi3_highpart */
    case 556:  /* smulv16hi3_highpart */
    case 555:  /* umulv8si3_highpart */
    case 554:  /* smulv8si3_highpart */
    case 553:  /* umulv4di3_highpart */
    case 552:  /* smulv4di3_highpart */
    case 551:  /* umulv16qi3_highpart */
    case 550:  /* smulv16qi3_highpart */
    case 549:  /* umulv8hi3_highpart */
    case 548:  /* smulv8hi3_highpart */
    case 547:  /* umulv4si3_highpart */
    case 546:  /* smulv4si3_highpart */
    case 545:  /* umulv2di3_highpart */
    case 544:  /* smulv2di3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 539:  /* lasx_xvftintrne_w_s */
    case 538:  /* lasx_xvftintrm_w_s */
    case 537:  /* lasx_xvftint_w_s */
    case 536:  /* lasx_xvftintrz_w_s */
    case 535:  /* lasx_xvftintrp_w_s */
    case 534:  /* lasx_xvftintrne_l_d */
    case 533:  /* lasx_xvftintrm_l_d */
    case 532:  /* lasx_xvftint_l_d */
    case 531:  /* lasx_xvftintrz_l_d */
    case 530:  /* lasx_xvftintrp_l_d */
    case 529:  /* lsx_vftintrne_w_s */
    case 528:  /* lsx_vftintrm_w_s */
    case 527:  /* lsx_vftint_w_s */
    case 526:  /* lsx_vftintrz_w_s */
    case 525:  /* lsx_vftintrp_w_s */
    case 524:  /* lsx_vftintrne_l_d */
    case 523:  /* lsx_vftintrm_l_d */
    case 522:  /* lsx_vftint_l_d */
    case 521:  /* lsx_vftintrz_l_d */
    case 520:  /* lsx_vftintrp_l_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      break;

    case 495:  /* atomic_cas_value_nand_7_di */
    case 494:  /* atomic_cas_value_nand_7_si */
    case 493:  /* atomic_cas_value_or_7_di */
    case 492:  /* atomic_cas_value_or_7_si */
    case 491:  /* atomic_cas_value_xor_7_di */
    case 490:  /* atomic_cas_value_xor_7_si */
    case 489:  /* atomic_cas_value_and_7_di */
    case 488:  /* atomic_cas_value_and_7_si */
    case 487:  /* atomic_cas_value_sub_7_di */
    case 486:  /* atomic_cas_value_sub_7_si */
    case 485:  /* atomic_cas_value_add_7_di */
    case 484:  /* atomic_cas_value_add_7_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 497:  /* atomic_cas_value_exchange_7_di */
    case 496:  /* atomic_cas_value_exchange_7_si */
    case 483:  /* atomic_cas_value_cmp_and_7_di */
    case 482:  /* atomic_cas_value_cmp_and_7_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 481:  /* atomic_cas_value_strongdi_amcas */
    case 480:  /* atomic_cas_value_strongsi_amcas */
    case 479:  /* atomic_cas_value_stronghi_amcas */
    case 478:  /* atomic_cas_value_strongqi_amcas */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 477:  /* atomic_cas_value_strongdi */
    case 476:  /* atomic_cas_value_strongsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 475:  /* atomic_exchangehi_short */
    case 474:  /* atomic_exchangeqi_short */
    case 473:  /* atomic_exchangedi */
    case 472:  /* atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 499:  /* atomic_fetch_addhi_short */
    case 498:  /* atomic_fetch_addqi_short */
    case 471:  /* atomic_fetch_anddi */
    case 470:  /* atomic_fetch_xordi */
    case 469:  /* atomic_fetch_ordi */
    case 468:  /* atomic_fetch_adddi */
    case 467:  /* atomic_fetch_andsi */
    case 466:  /* atomic_fetch_xorsi */
    case 465:  /* atomic_fetch_orsi */
    case 464:  /* atomic_fetch_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 463:  /* atomic_addhi */
    case 462:  /* atomic_addqi */
    case 461:  /* atomic_anddi */
    case 460:  /* atomic_xordi */
    case 459:  /* atomic_ordi */
    case 458:  /* atomic_adddi */
    case 457:  /* atomic_andsi */
    case 456:  /* atomic_xorsi */
    case 455:  /* atomic_orsi */
    case 454:  /* atomic_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 445:  /* mem_thread_fence_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 422:  /* loongarch_crcc_w_d_w_extended */
    case 421:  /* loongarch_crc_w_d_w_extended */
    case 420:  /* loongarch_crcc_w_w_w_extended */
    case 419:  /* loongarch_crc_w_w_w_extended */
    case 418:  /* loongarch_crcc_w_h_w_extended */
    case 417:  /* loongarch_crc_w_h_w_extended */
    case 416:  /* loongarch_crcc_w_b_w_extended */
    case 415:  /* loongarch_crc_w_b_w_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 406:  /* *join2_loadhi */
    case 405:  /* *join2_loadhi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0));
      break;

    case 404:  /* *join2_load_storedf */
    case 403:  /* *join2_load_storesf */
    case 402:  /* *join2_load_storesi */
    case 401:  /* *join2_load_storehi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 400:  /* stack_tiedi */
    case 399:  /* stack_tiesi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 389:  /* bytepick_w_3_extend */
    case 388:  /* bytepick_w_2_extend */
    case 387:  /* bytepick_w_1_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0), 0));
      break;

    case 378:  /* prefetch */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 374:  /* call_value_internal_1di */
    case 373:  /* call_value_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 372:  /* call_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 371:  /* call_internal_1di */
    case 370:  /* call_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 369:  /* call_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 377:  /* call_value_multiple_internal_1di */
    case 376:  /* call_value_multiple_internal_1si */
    case 368:  /* sibcall_value_multiple_internal_1di */
    case 367:  /* sibcall_value_multiple_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0, 0);
      recog_data.dup_num[1] = 1;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[2] = 3;
      break;

    case 375:  /* call_value_multiple_internal */
    case 366:  /* sibcall_value_multiple_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 365:  /* sibcall_value_internal_1di */
    case 364:  /* sibcall_value_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 362:  /* sibcall_internal_1di */
    case 361:  /* sibcall_internal_1si */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 360:  /* sibcall_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 359:  /* eh_set_ra_di */
    case 358:  /* eh_set_ra_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 355:  /* simple_return_internal */
    case 354:  /* return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 2151:  /* lasx_xvinsve0_w_f */
    case 2150:  /* lasx_xvinsve0_w */
    case 2149:  /* lasx_xvinsve0_d_f */
    case 2148:  /* lasx_xvinsve0_d */
    case 2135:  /* lasx_xvpermi_w_f */
    case 2134:  /* lasx_xvpermi_w */
    case 2133:  /* lasx_xvssrarni_bu_h */
    case 2132:  /* lasx_xvssrarni_hu_w */
    case 2131:  /* lasx_xvssrarni_wu_d */
    case 2130:  /* lasx_xvssrarni_du_q */
    case 2129:  /* lasx_xvssrarni_b_h */
    case 2128:  /* lasx_xvssrarni_h_w */
    case 2127:  /* lasx_xvssrarni_w_d */
    case 2126:  /* lasx_xvssrarni_d_q */
    case 2125:  /* lasx_xvssrani_bu_h */
    case 2124:  /* lasx_xvssrani_hu_w */
    case 2123:  /* lasx_xvssrani_wu_d */
    case 2122:  /* lasx_xvssrani_du_q */
    case 2121:  /* lasx_xvssrani_b_h */
    case 2120:  /* lasx_xvssrani_h_w */
    case 2119:  /* lasx_xvssrani_w_d */
    case 2118:  /* lasx_xvssrani_d_q */
    case 2117:  /* lasx_xvsrarni_b_h */
    case 2116:  /* lasx_xvsrarni_h_w */
    case 2115:  /* lasx_xvsrarni_w_d */
    case 2114:  /* lasx_xvsrarni_d_q */
    case 2113:  /* lasx_xvsrani_b_h */
    case 2112:  /* lasx_xvsrani_h_w */
    case 2111:  /* lasx_xvsrani_w_d */
    case 2110:  /* lasx_xvsrani_d_q */
    case 2109:  /* lasx_xvssrlrni_bu_h */
    case 2108:  /* lasx_xvssrlrni_hu_w */
    case 2107:  /* lasx_xvssrlrni_wu_d */
    case 2106:  /* lasx_xvssrlrni_du_q */
    case 2105:  /* lasx_xvssrlrni_b_h */
    case 2104:  /* lasx_xvssrlrni_h_w */
    case 2103:  /* lasx_xvssrlrni_w_d */
    case 2102:  /* lasx_xvssrlrni_d_q */
    case 2101:  /* lasx_xvssrlni_bu_h */
    case 2100:  /* lasx_xvssrlni_hu_w */
    case 2099:  /* lasx_xvssrlni_wu_d */
    case 2098:  /* lasx_xvssrlni_du_q */
    case 2097:  /* lasx_xvssrlni_b_h */
    case 2096:  /* lasx_xvssrlni_h_w */
    case 2095:  /* lasx_xvssrlni_w_d */
    case 2094:  /* lasx_xvssrlni_d_q */
    case 2093:  /* lasx_xvsrlrni_b_h */
    case 2092:  /* lasx_xvsrlrni_h_w */
    case 2091:  /* lasx_xvsrlrni_w_d */
    case 2090:  /* lasx_xvsrlrni_d_q */
    case 2089:  /* lasx_xvsrlni_b_h */
    case 2088:  /* lasx_xvsrlni_h_w */
    case 2087:  /* lasx_xvsrlni_w_d */
    case 2086:  /* lasx_xvsrlni_d_q */
    case 2053:  /* lasx_xvmaddwod_q_du_d */
    case 2049:  /* lasx_xvmaddwev_q_du_d */
    case 2045:  /* lasx_xvmaddwod_q_du */
    case 2044:  /* lasx_xvmaddwev_q_du */
    case 2043:  /* lasx_xvmaddwod_q_d */
    case 2036:  /* lasx_xvmaddwev_q_d */
    case 1921:  /* lasx_xvextrins_b */
    case 1920:  /* lasx_xvextrins_h */
    case 1919:  /* lasx_xvextrins_w */
    case 1918:  /* lasx_xvextrins_d */
    case 1909:  /* lasx_xvshuf4i_d */
    case 1908:  /* lasx_xvfrstp_b */
    case 1907:  /* lasx_xvfrstp_h */
    case 1906:  /* lasx_xvfrstpi_b */
    case 1905:  /* lasx_xvfrstpi_h */
    case 1790:  /* lasx_xvshuf_b */
    case 1789:  /* lasx_xvshuf_h */
    case 1788:  /* lasx_xvshuf_w */
    case 1787:  /* lasx_xvshuf_d */
    case 1786:  /* lasx_xvshuf_w_f */
    case 1785:  /* lasx_xvshuf_d_f */
    case 1461:  /* lasx_xvinsgr2vr_v16qi_internal */
    case 1460:  /* lasx_xvinsgr2vr_v8hi_internal */
    case 1457:  /* lasx_vecinit_merge_v32qi */
    case 1456:  /* lasx_vecinit_merge_v16hi */
    case 1455:  /* lasx_vecinit_merge_v8si */
    case 1454:  /* lasx_vecinit_merge_v4di */
    case 1453:  /* lasx_vecinit_merge_v8sf */
    case 1452:  /* lasx_vecinit_merge_v4df */
    case 1451:  /* lasx_xvpermi_q_v32qi */
    case 1450:  /* lasx_xvpermi_q_v16hi */
    case 1449:  /* lasx_xvpermi_q_v8si */
    case 1448:  /* lasx_xvpermi_q_v4di */
    case 1447:  /* lasx_xvpermi_q_v8sf */
    case 1446:  /* lasx_xvpermi_q_v4df */
    case 1424:  /* lsx_vpermi_w */
    case 1423:  /* lsx_vssrarni_bu_h */
    case 1422:  /* lsx_vssrarni_hu_w */
    case 1421:  /* lsx_vssrarni_wu_d */
    case 1420:  /* lsx_vssrarni_du_q */
    case 1419:  /* lsx_vssrarni_b_h */
    case 1418:  /* lsx_vssrarni_h_w */
    case 1417:  /* lsx_vssrarni_w_d */
    case 1416:  /* lsx_vssrarni_d_q */
    case 1415:  /* lsx_vssrani_bu_h */
    case 1414:  /* lsx_vssrani_hu_w */
    case 1413:  /* lsx_vssrani_wu_d */
    case 1412:  /* lsx_vssrani_du_q */
    case 1411:  /* lsx_vssrani_b_h */
    case 1410:  /* lsx_vssrani_h_w */
    case 1409:  /* lsx_vssrani_w_d */
    case 1408:  /* lsx_vssrani_d_q */
    case 1407:  /* lsx_vsrarni_b_h */
    case 1406:  /* lsx_vsrarni_h_w */
    case 1405:  /* lsx_vsrarni_w_d */
    case 1404:  /* lsx_vsrarni_d_q */
    case 1403:  /* lsx_vsrani_b_h */
    case 1402:  /* lsx_vsrani_h_w */
    case 1401:  /* lsx_vsrani_w_d */
    case 1400:  /* lsx_vsrani_d_q */
    case 1399:  /* lsx_vssrlrni_bu_h */
    case 1398:  /* lsx_vssrlrni_hu_w */
    case 1397:  /* lsx_vssrlrni_wu_d */
    case 1396:  /* lsx_vssrlrni_du_q */
    case 1395:  /* lsx_vssrlrni_b_h */
    case 1394:  /* lsx_vssrlrni_h_w */
    case 1393:  /* lsx_vssrlrni_w_d */
    case 1392:  /* lsx_vssrlrni_d_q */
    case 1391:  /* lsx_vssrlni_bu_h */
    case 1390:  /* lsx_vssrlni_hu_w */
    case 1389:  /* lsx_vssrlni_wu_d */
    case 1388:  /* lsx_vssrlni_du_q */
    case 1387:  /* lsx_vssrlni_b_h */
    case 1386:  /* lsx_vssrlni_h_w */
    case 1385:  /* lsx_vssrlni_w_d */
    case 1384:  /* lsx_vssrlni_d_q */
    case 1383:  /* lsx_vsrlrni_b_h */
    case 1382:  /* lsx_vsrlrni_h_w */
    case 1381:  /* lsx_vsrlrni_w_d */
    case 1380:  /* lsx_vsrlrni_d_q */
    case 1379:  /* lsx_vsrlni_b_h */
    case 1378:  /* lsx_vsrlni_h_w */
    case 1377:  /* lsx_vsrlni_w_d */
    case 1376:  /* lsx_vsrlni_d_q */
    case 1362:  /* lsx_vmaddwod_q_du_d */
    case 1361:  /* lsx_vmaddwev_q_du_d */
    case 1360:  /* lsx_vmaddwod_q_du */
    case 1359:  /* lsx_vmaddwev_q_du */
    case 1358:  /* lsx_vmaddwod_q_d */
    case 1357:  /* lsx_vmaddwev_q_d */
    case 1266:  /* lsx_vshuf_b */
    case 1194:  /* lsx_vextrins_b */
    case 1193:  /* lsx_vextrins_h */
    case 1192:  /* lsx_vextrins_w */
    case 1191:  /* lsx_vextrins_d */
    case 1180:  /* lsx_vshuf4i_d */
    case 1179:  /* lsx_vfrstp_b */
    case 1178:  /* lsx_vfrstp_h */
    case 1177:  /* lsx_vfrstpi_b */
    case 1176:  /* lsx_vfrstpi_h */
    case 740:  /* lsx_vshuf_h */
    case 739:  /* lsx_vshuf_w */
    case 738:  /* lsx_vshuf_d */
    case 737:  /* lsx_vshuf_w_f */
    case 736:  /* lsx_vshuf_d_f */
    case 351:  /* probe_stack_rangedi */
    case 350:  /* probe_stack_rangesi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 348:  /* tablejumpdi */
    case 347:  /* tablejumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 346:  /* indirect_jumpdi */
    case 345:  /* indirect_jumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 344:  /* *jump_pic */
    case 343:  /* *jump_absolute */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 290:  /* *branch_equalitydi_inverted */
    case 289:  /* *branch_equalitysi_inverted */
    case 286:  /* *branch_orderdi_inverted */
    case 285:  /* *branch_ordersi_inverted */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 288:  /* branch_equalitydi */
    case 287:  /* branch_equalitysi */
    case 284:  /* *branch_orderdi */
    case 283:  /* *branch_ordersi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 282:  /* *branch_fp_inverted_FCCmode */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 281:  /* *branch_fp_FCCmode */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 274:  /* alslsi3_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 271:  /* bstrpick_alsl_paired */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 255:  /* loongarch_lddir_d */
    case 254:  /* loongarch_lddir_w */
    case 253:  /* loongarch_cacop_d */
    case 252:  /* loongarch_cacop_w */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 2));
      break;

    case 257:  /* loongarch_ldpte_d */
    case 256:  /* loongarch_ldpte_w */
    case 251:  /* loongarch_iocsrwr_d */
    case 250:  /* loongarch_iocsrwr_w */
    case 249:  /* loongarch_iocsrwr_h */
    case 248:  /* loongarch_iocsrwr_b */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 1));
      break;

    case 243:  /* loongarch_csrxchg_d */
    case 242:  /* loongarch_csrxchg_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      break;

    case 241:  /* loongarch_csrwr_d */
    case 240:  /* loongarch_csrwr_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      break;

    case 247:  /* loongarch_iocsrrd_d */
    case 246:  /* loongarch_iocsrrd_w */
    case 245:  /* loongarch_iocsrrd_h */
    case 244:  /* loongarch_iocsrrd_b */
    case 239:  /* loongarch_csrrd_d */
    case 238:  /* loongarch_csrrd_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 381:  /* loongarch_movgr2fcsr */
    case 237:  /* loongarch_asrtgt_d */
    case 236:  /* loongarch_asrtle_d */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 235:  /* loongarch_break */
    case 234:  /* loongarch_syscall */
    case 232:  /* loongarch_dbar */
    case 231:  /* loongarch_ibar */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      break;

    case 222:  /* got_load_tls_desc_off64 */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 10), 0));
      break;

    case 221:  /* got_load_tls_descdi */
    case 220:  /* got_load_tls_descsi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 186:  /* ld_from_gotdi */
    case 185:  /* ld_from_gotsi */
    case 184:  /* tls_lowdi */
    case 183:  /* tls_lowsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 1));
      break;

    case 273:  /* alsldi3 */
    case 272:  /* alslsi3 */
    case 270:  /* zero_extend_ashift */
    case 180:  /* lu52i_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 179:  /* lu32i_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 158:  /* la_pcrel64_two_parts */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 2;
      break;

    case 157:  /* movdi_symbolic_off64 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 1469:  /* movv32qi_lasx */
    case 1468:  /* movv16hi_lasx */
    case 1467:  /* movv8si_lasx */
    case 1466:  /* movv4di_lasx */
    case 1465:  /* movv8sf_lasx */
    case 1464:  /* movv4df_lasx */
    case 746:  /* movv16qi_lsx */
    case 745:  /* movv8hi_lsx */
    case 744:  /* movv4si_lsx */
    case 743:  /* movv2di_lsx */
    case 742:  /* movv4sf_lsx */
    case 741:  /* movv2df_lsx */
    case 444:  /* simple_storedf */
    case 443:  /* simple_storesf */
    case 442:  /* simple_storedi */
    case 441:  /* simple_storesi */
    case 440:  /* simple_storehi */
    case 439:  /* simple_storeqi */
    case 426:  /* simple_loaddf */
    case 425:  /* simple_loadsf */
    case 424:  /* simple_loaddi */
    case 423:  /* simple_loadsi */
    case 166:  /* movfcc_internal */
    case 165:  /* *movdf_softfloat */
    case 164:  /* *movdf_hardfloat */
    case 163:  /* *movsf_softfloat */
    case 162:  /* *movsf_hardfloat */
    case 161:  /* *movqi_internal */
    case 160:  /* *movhi_internal */
    case 159:  /* *movsi_internal */
    case 156:  /* *movdi_64bit */
    case 155:  /* *movdi_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 154:  /* *insvdi */
    case 153:  /* *insvsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 1860:  /* xvandnv32qi3 */
    case 1859:  /* xvandnv16hi3 */
    case 1858:  /* xvandnv8si3 */
    case 1857:  /* xvandnv4di3 */
    case 1856:  /* xvandnv8sf3 */
    case 1855:  /* xvandnv4df3 */
    case 1120:  /* vandnv16qi3 */
    case 1119:  /* vandnv8hi3 */
    case 1118:  /* vandnv4si3 */
    case 1117:  /* vandnv2di3 */
    case 1116:  /* vandnv4sf3 */
    case 1115:  /* vandnv2df3 */
    case 363:  /* sibcall_value_internal */
    case 123:  /* *iornsi_internal */
    case 122:  /* *andnsi_internal */
    case 121:  /* iorndi */
    case 120:  /* andndi */
    case 119:  /* iornsi */
    case 118:  /* andnsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 1114:  /* vec_concatv4sf */
    case 113:  /* *bstrins_di_for_ior_mask */
    case 112:  /* *bstrins_si_for_ior_mask */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 2082:  /* lasx_xvexth_du_wu */
    case 2081:  /* lasx_xvexth_d_w */
    case 2080:  /* lasx_xvexth_wu_hu */
    case 2079:  /* lasx_xvexth_w_h */
    case 2078:  /* lasx_xvexth_hu_bu */
    case 2077:  /* lasx_xvexth_h_b */
    case 1969:  /* lasx_xvldrepl_b_insn_0 */
    case 1968:  /* lasx_xvldrepl_h_insn_0 */
    case 1967:  /* lasx_xvldrepl_w_insn_0 */
    case 1966:  /* lasx_xvldrepl_d_insn_0 */
    case 1965:  /* lasx_xvldrepl_w_f_insn_0 */
    case 1964:  /* lasx_xvldrepl_d_f_insn_0 */
    case 1854:  /* lasx_vext2xv_du_bu */
    case 1853:  /* lasx_vext2xv_d_b */
    case 1852:  /* lasx_vext2xv_du_hu */
    case 1851:  /* lasx_vext2xv_d_h */
    case 1850:  /* lasx_vext2xv_wu_bu */
    case 1849:  /* lasx_vext2xv_w_b */
    case 1848:  /* lasx_vext2xv_du_wu */
    case 1847:  /* lasx_vext2xv_d_w */
    case 1846:  /* lasx_vext2xv_wu_hu */
    case 1845:  /* lasx_vext2xv_w_h */
    case 1844:  /* lasx_vext2xv_hu_bu */
    case 1843:  /* lasx_vext2xv_h_b */
    case 1818:  /* lasx_xvfcvtl_d_insn */
    case 1817:  /* lasx_xvfcvtl_d_s */
    case 1815:  /* lasx_xvfcvth_d_insn */
    case 1814:  /* lasx_xvfcvth_d_s */
    case 1796:  /* lasx_xvreplve0_b */
    case 1795:  /* lasx_xvreplve0_h */
    case 1794:  /* lasx_xvreplve0_w */
    case 1793:  /* lasx_xvreplve0_d */
    case 1792:  /* lasx_xvreplve0_w_f */
    case 1791:  /* lasx_xvreplve0_d_f */
    case 1726:  /* lasx_xvclo_b */
    case 1725:  /* lasx_xvclo_h */
    case 1724:  /* lasx_xvclo_w */
    case 1723:  /* lasx_xvclo_d */
    case 1372:  /* lsx_vexth_du_wu */
    case 1371:  /* lsx_vexth_d_w */
    case 1370:  /* lsx_vexth_wu_hu */
    case 1369:  /* lsx_vexth_w_h */
    case 1368:  /* lsx_vexth_hu_bu */
    case 1367:  /* lsx_vexth_h_b */
    case 1242:  /* lsx_vldrepl_b_insn_0 */
    case 1241:  /* lsx_vldrepl_h_insn_0 */
    case 1240:  /* lsx_vldrepl_w_insn_0 */
    case 1239:  /* lsx_vldrepl_d_insn_0 */
    case 1238:  /* lsx_vldrepl_w_f_insn_0 */
    case 1237:  /* lsx_vldrepl_d_f_insn_0 */
    case 1088:  /* lsx_vfcvtl_d_s */
    case 1086:  /* lsx_vfcvth_d_s */
    case 1001:  /* lsx_vclo_b */
    case 1000:  /* lsx_vclo_h */
    case 999:  /* lsx_vclo_w */
    case 998:  /* lsx_vclo_d */
    case 168:  /* fcc_to_di */
    case 167:  /* fcc_to_si */
    case 135:  /* *zero_extendhi_truncqi */
    case 134:  /* *zero_extenddi_trunchi */
    case 133:  /* *zero_extendsi_trunchi */
    case 132:  /* *zero_extenddi_truncqi */
    case 131:  /* *zero_extendsi_truncqi */
    case 93:  /* *negsi2_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 1662:  /* lasx_xvfmina_s */
    case 1661:  /* lasx_xvfmina_d */
    case 1658:  /* lasx_xvfmaxa_s */
    case 1657:  /* lasx_xvfmaxa_d */
    case 937:  /* lsx_vfmina_s */
    case 936:  /* lsx_vfmina_d */
    case 933:  /* lsx_vfmaxa_s */
    case 932:  /* lsx_vfmaxa_d */
    case 90:  /* sminadf3 */
    case 89:  /* sminasf3 */
    case 88:  /* smaxadf3 */
    case 87:  /* smaxasf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[1] = 2;
      break;

    case 86:  /* fmindf3 */
    case 85:  /* fminsf3 */
    case 84:  /* fmaxdf3 */
    case 83:  /* fmaxsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      break;

    case 2169:  /* lasx_xvldx */
    case 2162:  /* lasx_xvssrlrn_b_h */
    case 2161:  /* lasx_xvssrlrn_h_w */
    case 2160:  /* lasx_xvssrlrn_w_d */
    case 2157:  /* lasx_xvpickve_w_f */
    case 2156:  /* lasx_xvpickve_w */
    case 2155:  /* lasx_xvpickve_d_f */
    case 2154:  /* lasx_xvpickve_d */
    case 2072:  /* lasx_xvmulwod_q_du_d */
    case 2071:  /* lasx_xvmulwev_q_du_d */
    case 2070:  /* lasx_xvaddwod_q_du_d */
    case 2069:  /* lasx_xvaddwev_q_du_d */
    case 2068:  /* lasx_xvreplve_b */
    case 2067:  /* lasx_xvreplve_h */
    case 2066:  /* lasx_xvreplve_w */
    case 2065:  /* lasx_xvreplve_d */
    case 2064:  /* lasx_xvreplve_w_f */
    case 2063:  /* lasx_xvreplve_d_f */
    case 2062:  /* lasx_xvssrln_b_h */
    case 2061:  /* lasx_xvssrln_h_w */
    case 2060:  /* lasx_xvssrln_w_d */
    case 2059:  /* lasx_xvsub_q */
    case 2058:  /* lasx_xvadd_q */
    case 2057:  /* lasx_xvhsubw_qu_du */
    case 2056:  /* lasx_xvhaddw_qu_du */
    case 2055:  /* lasx_xvhsubw_q_d */
    case 2054:  /* lasx_xvhaddw_q_d */
    case 2017:  /* lasx_xvmulwod_q_du */
    case 2016:  /* lasx_xvsubwod_q_du */
    case 2015:  /* lasx_xvaddwod_q_du */
    case 2014:  /* lasx_xvmulwev_q_du */
    case 2013:  /* lasx_xvsubwev_q_du */
    case 2012:  /* lasx_xvaddwev_q_du */
    case 2011:  /* lasx_xvmulwod_q_d */
    case 2010:  /* lasx_xvsubwod_q_d */
    case 2009:  /* lasx_xvaddwod_q_d */
    case 1990:  /* lasx_xvmulwev_q_d */
    case 1989:  /* lasx_xvsubwev_q_d */
    case 1988:  /* lasx_xvaddwev_q_d */
    case 1945:  /* lasx_xvftintrne_w_d */
    case 1944:  /* lasx_xvftintrm_w_d */
    case 1943:  /* lasx_xvftintrp_w_d */
    case 1942:  /* lasx_xvftintrz_w_d */
    case 1941:  /* lasx_xvffint_s_l */
    case 1940:  /* lasx_xvftint_w_d */
    case 1929:  /* lasx_xvsigncov_b */
    case 1928:  /* lasx_xvsigncov_h */
    case 1927:  /* lasx_xvsigncov_w */
    case 1926:  /* lasx_xvsigncov_d */
    case 1917:  /* lasx_xvbsll_b */
    case 1916:  /* lasx_xvbsll_h */
    case 1915:  /* lasx_xvbsll_w */
    case 1914:  /* lasx_xvbsll_d */
    case 1913:  /* lasx_xvbsrl_b */
    case 1912:  /* lasx_xvbsrl_h */
    case 1911:  /* lasx_xvbsrl_w */
    case 1910:  /* lasx_xvbsrl_d */
    case 1904:  /* lasx_xvssrlrn_u_bu_h */
    case 1903:  /* lasx_xvssrlrn_u_hu_w */
    case 1902:  /* lasx_xvssrlrn_u_wu_d */
    case 1901:  /* lasx_xvsrlrn_b_h */
    case 1900:  /* lasx_xvsrlrn_h_w */
    case 1899:  /* lasx_xvsrlrn_w_d */
    case 1898:  /* lasx_xvssrln_u_bu_h */
    case 1897:  /* lasx_xvssrln_u_hu_w */
    case 1896:  /* lasx_xvssrln_u_wu_d */
    case 1895:  /* lasx_xvsrln_b_h */
    case 1894:  /* lasx_xvsrln_h_w */
    case 1893:  /* lasx_xvsrln_w_d */
    case 1892:  /* lasx_xvssrarn_u_bu_h */
    case 1891:  /* lasx_xvssrarn_u_hu_w */
    case 1890:  /* lasx_xvssrarn_u_wu_d */
    case 1889:  /* lasx_xvssrarn_s_b_h */
    case 1888:  /* lasx_xvssrarn_s_h_w */
    case 1887:  /* lasx_xvssrarn_s_w_d */
    case 1886:  /* lasx_xvsrarn_b_h */
    case 1885:  /* lasx_xvsrarn_h_w */
    case 1884:  /* lasx_xvsrarn_w_d */
    case 1883:  /* lasx_xvssran_u_bu_h */
    case 1882:  /* lasx_xvssran_u_hu_w */
    case 1881:  /* lasx_xvssran_u_wu_d */
    case 1880:  /* lasx_xvssran_s_b_h */
    case 1879:  /* lasx_xvssran_s_h_w */
    case 1878:  /* lasx_xvssran_s_w_d */
    case 1877:  /* lasx_xvsran_b_h */
    case 1876:  /* lasx_xvsran_h_w */
    case 1875:  /* lasx_xvsran_w_d */
    case 1874:  /* lasx_xvsllwil_u_hu_bu */
    case 1873:  /* lasx_xvsllwil_u_wu_hu */
    case 1872:  /* lasx_xvsllwil_u_du_wu */
    case 1871:  /* lasx_xvsllwil_s_h_b */
    case 1870:  /* lasx_xvsllwil_s_w_h */
    case 1869:  /* lasx_xvsllwil_s_d_w */
    case 1811:  /* lasx_xvfcvt_s_d */
    case 1810:  /* lasx_xvfcvt_h_s */
    case 1806:  /* lasx_xvrepl128vei_b */
    case 1805:  /* lasx_xvrepl128vei_h */
    case 1804:  /* lasx_xvrepl128vei_w */
    case 1803:  /* lasx_xvrepl128vei_d */
    case 1802:  /* lasx_xvrepl128vei_w_f */
    case 1801:  /* lasx_xvrepl128vei_d_f */
    case 1776:  /* lasx_xvsrlri_b */
    case 1775:  /* lasx_xvsrlri_h */
    case 1774:  /* lasx_xvsrlri_w */
    case 1773:  /* lasx_xvsrlri_d */
    case 1772:  /* lasx_xvsrlr_b */
    case 1771:  /* lasx_xvsrlr_h */
    case 1770:  /* lasx_xvsrlr_w */
    case 1769:  /* lasx_xvsrlr_d */
    case 1768:  /* lasx_xvsrari_b */
    case 1767:  /* lasx_xvsrari_h */
    case 1766:  /* lasx_xvsrari_w */
    case 1765:  /* lasx_xvsrari_d */
    case 1764:  /* lasx_xvsrar_b */
    case 1763:  /* lasx_xvsrar_h */
    case 1762:  /* lasx_xvsrar_w */
    case 1761:  /* lasx_xvsrar_d */
    case 1758:  /* lasx_xvshuf4i_w_f */
    case 1757:  /* lasx_xvshuf4i_b */
    case 1756:  /* lasx_xvshuf4i_h */
    case 1755:  /* lasx_xvshuf4i_w */
    case 1754:  /* lasx_xvsat_u_bu */
    case 1753:  /* lasx_xvsat_u_hu */
    case 1752:  /* lasx_xvsat_u_wu */
    case 1751:  /* lasx_xvsat_u_du */
    case 1750:  /* lasx_xvsat_s_b */
    case 1749:  /* lasx_xvsat_s_h */
    case 1748:  /* lasx_xvsat_s_w */
    case 1747:  /* lasx_xvsat_s_d */
    case 1654:  /* lasx_xvilvl_w_f_internal */
    case 1653:  /* lasx_xvilvl_d_f_internal */
    case 1620:  /* lasx_xvbitseti_b */
    case 1619:  /* lasx_xvbitseti_h */
    case 1618:  /* lasx_xvbitseti_w */
    case 1617:  /* lasx_xvbitseti_d */
    case 1616:  /* lasx_xvbitset_b */
    case 1615:  /* lasx_xvbitset_h */
    case 1614:  /* lasx_xvbitset_w */
    case 1613:  /* lasx_xvbitset_d */
    case 1605:  /* lasx_xvbitrevi_b */
    case 1604:  /* lasx_xvbitrevi_h */
    case 1603:  /* lasx_xvbitrevi_w */
    case 1602:  /* lasx_xvbitrevi_d */
    case 1601:  /* lasx_xvbitrev_b */
    case 1600:  /* lasx_xvbitrev_h */
    case 1599:  /* lasx_xvbitrev_w */
    case 1598:  /* lasx_xvbitrev_d */
    case 1597:  /* lasx_xvbitclri_b */
    case 1596:  /* lasx_xvbitclri_h */
    case 1595:  /* lasx_xvbitclri_w */
    case 1594:  /* lasx_xvbitclri_d */
    case 1593:  /* lasx_xvbitclr_b */
    case 1592:  /* lasx_xvbitclr_h */
    case 1591:  /* lasx_xvbitclr_w */
    case 1590:  /* lasx_xvbitclr_d */
    case 1589:  /* lasx_xvavgr_u_bu */
    case 1588:  /* lasx_xvavgr_u_hu */
    case 1587:  /* lasx_xvavgr_u_wu */
    case 1586:  /* lasx_xvavgr_u_du */
    case 1585:  /* lasx_xvavgr_s_b */
    case 1584:  /* lasx_xvavgr_s_h */
    case 1583:  /* lasx_xvavgr_s_w */
    case 1582:  /* lasx_xvavgr_s_d */
    case 1581:  /* lasx_xvavg_u_bu */
    case 1580:  /* lasx_xvavg_u_hu */
    case 1579:  /* lasx_xvavg_u_wu */
    case 1578:  /* lasx_xvavg_u_du */
    case 1577:  /* lasx_xvavg_s_b */
    case 1576:  /* lasx_xvavg_s_h */
    case 1575:  /* lasx_xvavg_s_w */
    case 1574:  /* lasx_xvavg_s_d */
    case 1573:  /* lasx_xvabsd_u_bu */
    case 1572:  /* lasx_xvabsd_u_hu */
    case 1571:  /* lasx_xvabsd_u_wu */
    case 1570:  /* lasx_xvabsd_u_du */
    case 1569:  /* lasx_xvabsd_s_b */
    case 1568:  /* lasx_xvabsd_s_h */
    case 1567:  /* lasx_xvabsd_s_w */
    case 1566:  /* lasx_xvabsd_s_d */
    case 1443:  /* lasx_xvpermi_d_v32qi */
    case 1442:  /* lasx_xvpermi_d_v16hi */
    case 1441:  /* lasx_xvpermi_d_v8si */
    case 1440:  /* lasx_xvpermi_d_v4di */
    case 1439:  /* lasx_xvpermi_d_v8sf */
    case 1438:  /* lasx_xvpermi_d_v4df */
    case 1437:  /* lasx_xvperm_w_f */
    case 1436:  /* lasx_xvperm_w */
    case 1364:  /* lsx_vsub_q */
    case 1363:  /* lsx_vadd_q */
    case 1338:  /* lsx_vhsubw_qu_du */
    case 1337:  /* lsx_vhsubw_q_d */
    case 1336:  /* lsx_vhaddw_qu_du */
    case 1335:  /* lsx_vhaddw_q_d */
    case 1334:  /* lsx_vmulwod_q_du */
    case 1333:  /* lsx_vmulwod_q_d */
    case 1332:  /* lsx_vmulwev_q_du */
    case 1331:  /* lsx_vmulwev_q_d */
    case 1330:  /* lsx_vmulwod_q_du_d */
    case 1329:  /* lsx_vmulwev_q_du_d */
    case 1328:  /* lsx_vaddwod_q_du_d */
    case 1327:  /* lsx_vaddwev_q_du_d */
    case 1326:  /* lsx_vsubwod_q_du */
    case 1325:  /* lsx_vsubwod_q_d */
    case 1324:  /* lsx_vsubwev_q_du */
    case 1323:  /* lsx_vsubwev_q_d */
    case 1322:  /* lsx_vaddwod_q_du */
    case 1321:  /* lsx_vaddwod_q_d */
    case 1320:  /* lsx_vaddwev_q_du */
    case 1319:  /* lsx_vaddwev_q_d */
    case 1267:  /* lsx_vldx */
    case 1260:  /* lsx_vssrlrn_b_h */
    case 1259:  /* lsx_vssrlrn_h_w */
    case 1258:  /* lsx_vssrlrn_w_d */
    case 1257:  /* lsx_vssrln_b_h */
    case 1256:  /* lsx_vssrln_h_w */
    case 1255:  /* lsx_vssrln_w_d */
    case 1218:  /* lsx_vftintrne_w_d */
    case 1217:  /* lsx_vftintrm_w_d */
    case 1216:  /* lsx_vftintrp_w_d */
    case 1215:  /* lsx_vftintrz_w_d */
    case 1214:  /* lsx_vffint_s_l */
    case 1213:  /* lsx_vftint_w_d */
    case 1202:  /* lsx_vsigncov_b */
    case 1201:  /* lsx_vsigncov_h */
    case 1200:  /* lsx_vsigncov_w */
    case 1199:  /* lsx_vsigncov_d */
    case 1190:  /* lsx_vbsll_b */
    case 1189:  /* lsx_vbsll_h */
    case 1188:  /* lsx_vbsll_w */
    case 1187:  /* lsx_vbsll_d */
    case 1186:  /* lsx_vbsrl_b */
    case 1185:  /* lsx_vbsrl_h */
    case 1184:  /* lsx_vbsrl_w */
    case 1183:  /* lsx_vbsrl_d */
    case 1182:  /* lsx_vbsrl_w_f */
    case 1181:  /* lsx_vbsrl_d_f */
    case 1175:  /* lsx_vssrlrn_u_bu_h */
    case 1174:  /* lsx_vssrlrn_u_hu_w */
    case 1173:  /* lsx_vssrlrn_u_wu_d */
    case 1172:  /* lsx_vsrlrn_b_h */
    case 1171:  /* lsx_vsrlrn_h_w */
    case 1170:  /* lsx_vsrlrn_w_d */
    case 1169:  /* lsx_vssrln_u_bu_h */
    case 1168:  /* lsx_vssrln_u_hu_w */
    case 1167:  /* lsx_vssrln_u_wu_d */
    case 1166:  /* lsx_vsrln_b_h */
    case 1165:  /* lsx_vsrln_h_w */
    case 1164:  /* lsx_vsrln_w_d */
    case 1163:  /* lsx_vssrarn_u_bu_h */
    case 1162:  /* lsx_vssrarn_u_hu_w */
    case 1161:  /* lsx_vssrarn_u_wu_d */
    case 1160:  /* lsx_vssrarn_s_b_h */
    case 1159:  /* lsx_vssrarn_s_h_w */
    case 1158:  /* lsx_vssrarn_s_w_d */
    case 1157:  /* lsx_vsrarn_b_h */
    case 1156:  /* lsx_vsrarn_h_w */
    case 1155:  /* lsx_vsrarn_w_d */
    case 1154:  /* lsx_vsrains_u_b */
    case 1153:  /* lsx_vsrains_u_h */
    case 1152:  /* lsx_vsrains_u_w */
    case 1151:  /* lsx_vsrains_s_b */
    case 1150:  /* lsx_vsrains_s_h */
    case 1149:  /* lsx_vsrains_s_w */
    case 1148:  /* lsx_vsrain_b */
    case 1147:  /* lsx_vsrain_h */
    case 1146:  /* lsx_vsrain_w */
    case 1145:  /* lsx_vssran_u_bu_h */
    case 1144:  /* lsx_vssran_u_hu_w */
    case 1143:  /* lsx_vssran_u_wu_d */
    case 1142:  /* lsx_vssran_s_b_h */
    case 1141:  /* lsx_vssran_s_h_w */
    case 1140:  /* lsx_vssran_s_w_d */
    case 1139:  /* lsx_vsran_b_h */
    case 1138:  /* lsx_vsran_h_w */
    case 1137:  /* lsx_vsran_w_d */
    case 1136:  /* lsx_vsllwil_u_hu_bu */
    case 1135:  /* lsx_vsllwil_u_wu_hu */
    case 1134:  /* lsx_vsllwil_u_du_wu */
    case 1133:  /* lsx_vsllwil_s_h_b */
    case 1132:  /* lsx_vsllwil_s_w_h */
    case 1131:  /* lsx_vsllwil_s_d_w */
    case 1083:  /* lsx_vfcvt_s_d */
    case 1082:  /* lsx_vfcvt_h_s */
    case 1069:  /* lsx_vreplvei_mirror_b */
    case 1068:  /* lsx_vreplvei_mirror_h */
    case 1067:  /* lsx_vreplvei_mirror_w */
    case 1066:  /* lsx_vreplvei_mirror_d */
    case 1065:  /* lsx_vreplvei_mirror_w_f */
    case 1064:  /* lsx_vreplvei_mirror_d_f */
    case 1049:  /* lsx_vsrlri_b */
    case 1048:  /* lsx_vsrlri_h */
    case 1047:  /* lsx_vsrlri_w */
    case 1046:  /* lsx_vsrlri_d */
    case 1045:  /* lsx_vsrlr_b */
    case 1044:  /* lsx_vsrlr_h */
    case 1043:  /* lsx_vsrlr_w */
    case 1042:  /* lsx_vsrlr_d */
    case 1041:  /* lsx_vsrari_b */
    case 1040:  /* lsx_vsrari_h */
    case 1039:  /* lsx_vsrari_w */
    case 1038:  /* lsx_vsrari_d */
    case 1037:  /* lsx_vsrar_b */
    case 1036:  /* lsx_vsrar_h */
    case 1035:  /* lsx_vsrar_w */
    case 1034:  /* lsx_vsrar_d */
    case 1029:  /* lsx_vsat_u_bu */
    case 1028:  /* lsx_vsat_u_hu */
    case 1027:  /* lsx_vsat_u_wu */
    case 1026:  /* lsx_vsat_u_du */
    case 1025:  /* lsx_vsat_s_b */
    case 1024:  /* lsx_vsat_s_h */
    case 1023:  /* lsx_vsat_s_w */
    case 1022:  /* lsx_vsat_s_d */
    case 929:  /* lsx_vilvl_w_f_internal */
    case 928:  /* lsx_vilvl_d_f_internal */
    case 895:  /* lsx_vbitseti_b */
    case 894:  /* lsx_vbitseti_h */
    case 893:  /* lsx_vbitseti_w */
    case 892:  /* lsx_vbitseti_d */
    case 891:  /* lsx_vbitset_b */
    case 890:  /* lsx_vbitset_h */
    case 889:  /* lsx_vbitset_w */
    case 888:  /* lsx_vbitset_d */
    case 882:  /* lsx_vbitrevi_b */
    case 881:  /* lsx_vbitrevi_h */
    case 880:  /* lsx_vbitrevi_w */
    case 879:  /* lsx_vbitrevi_d */
    case 878:  /* lsx_vbitrev_b */
    case 877:  /* lsx_vbitrev_h */
    case 876:  /* lsx_vbitrev_w */
    case 875:  /* lsx_vbitrev_d */
    case 874:  /* lsx_vbitclri_b */
    case 873:  /* lsx_vbitclri_h */
    case 872:  /* lsx_vbitclri_w */
    case 871:  /* lsx_vbitclri_d */
    case 870:  /* lsx_vbitclr_b */
    case 869:  /* lsx_vbitclr_h */
    case 868:  /* lsx_vbitclr_w */
    case 867:  /* lsx_vbitclr_d */
    case 866:  /* lsx_vavgr_u_bu */
    case 865:  /* lsx_vavgr_u_hu */
    case 864:  /* lsx_vavgr_u_wu */
    case 863:  /* lsx_vavgr_u_du */
    case 862:  /* lsx_vavgr_s_b */
    case 861:  /* lsx_vavgr_s_h */
    case 860:  /* lsx_vavgr_s_w */
    case 859:  /* lsx_vavgr_s_d */
    case 858:  /* lsx_vavg_u_bu */
    case 857:  /* lsx_vavg_u_hu */
    case 856:  /* lsx_vavg_u_wu */
    case 855:  /* lsx_vavg_u_du */
    case 854:  /* lsx_vavg_s_b */
    case 853:  /* lsx_vavg_s_h */
    case 852:  /* lsx_vavg_s_w */
    case 851:  /* lsx_vavg_s_d */
    case 850:  /* lsx_vabsd_u_bu */
    case 849:  /* lsx_vabsd_u_hu */
    case 848:  /* lsx_vabsd_u_wu */
    case 847:  /* lsx_vabsd_u_du */
    case 846:  /* lsx_vabsd_s_b */
    case 845:  /* lsx_vabsd_s_h */
    case 844:  /* lsx_vabsd_s_w */
    case 843:  /* lsx_vabsd_s_d */
    case 703:  /* fminv8sf3 */
    case 702:  /* fmaxv8sf3 */
    case 701:  /* fminv4df3 */
    case 700:  /* fmaxv4df3 */
    case 699:  /* fminv4sf3 */
    case 698:  /* fmaxv4sf3 */
    case 697:  /* fminv2df3 */
    case 696:  /* fmaxv2df3 */
    case 695:  /* lasx_xvfcmp_sune_s */
    case 694:  /* lasx_xvfcmp_sor_s */
    case 693:  /* lasx_xvfcmp_cne_s */
    case 692:  /* lasx_xvfcmp_sueq_s */
    case 691:  /* lasx_xvfcmp_sun_s */
    case 690:  /* lasx_xvfcmp_seq_s */
    case 689:  /* lasx_xvfcmp_saf_s */
    case 688:  /* lasx_xvfcmp_caf_s */
    case 687:  /* lasx_xvfcmp_sune_d */
    case 686:  /* lasx_xvfcmp_sor_d */
    case 685:  /* lasx_xvfcmp_cne_d */
    case 684:  /* lasx_xvfcmp_sueq_d */
    case 683:  /* lasx_xvfcmp_sun_d */
    case 682:  /* lasx_xvfcmp_seq_d */
    case 681:  /* lasx_xvfcmp_saf_d */
    case 680:  /* lasx_xvfcmp_caf_d */
    case 679:  /* lsx_vfcmp_sune_s */
    case 678:  /* lsx_vfcmp_sor_s */
    case 677:  /* lsx_vfcmp_cne_s */
    case 676:  /* lsx_vfcmp_sueq_s */
    case 675:  /* lsx_vfcmp_sun_s */
    case 674:  /* lsx_vfcmp_seq_s */
    case 673:  /* lsx_vfcmp_saf_s */
    case 672:  /* lsx_vfcmp_caf_s */
    case 671:  /* lsx_vfcmp_sune_d */
    case 670:  /* lsx_vfcmp_sor_d */
    case 669:  /* lsx_vfcmp_cne_d */
    case 668:  /* lsx_vfcmp_sueq_d */
    case 667:  /* lsx_vfcmp_sun_d */
    case 666:  /* lsx_vfcmp_seq_d */
    case 665:  /* lsx_vfcmp_saf_d */
    case 664:  /* lsx_vfcmp_caf_d */
    case 453:  /* atomic_storedi */
    case 452:  /* atomic_storesi */
    case 451:  /* atomic_storehi */
    case 450:  /* atomic_storeqi */
    case 449:  /* atomic_loaddi */
    case 448:  /* atomic_loadsi */
    case 447:  /* atomic_loadhi */
    case 446:  /* atomic_loadqi */
    case 414:  /* loongarch_crcc_w_d_w */
    case 413:  /* loongarch_crc_w_d_w */
    case 412:  /* loongarch_crcc_w_w_w */
    case 411:  /* loongarch_crc_w_w_w */
    case 410:  /* loongarch_crcc_w_h_w */
    case 409:  /* loongarch_crc_w_h_w */
    case 408:  /* loongarch_crcc_w_b_w */
    case 407:  /* loongarch_crc_w_b_w */
    case 227:  /* movgr2frhtf */
    case 226:  /* movgr2frhdi */
    case 225:  /* movgr2frhdf */
    case 219:  /* store_wordtf */
    case 218:  /* store_worddi */
    case 217:  /* store_worddf */
    case 216:  /* load_hightf */
    case 215:  /* load_highdi */
    case 214:  /* load_highdf */
    case 196:  /* lui_h_hi12 */
    case 195:  /* lui_h_lo20 */
    case 194:  /* ori_l_lo12di */
    case 193:  /* ori_l_lo12si */
    case 72:  /* ldexpdf3 */
    case 71:  /* ldexpsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 1931:  /* absv8sf2 */
    case 1930:  /* absv4df2 */
    case 1868:  /* negv32qi2 */
    case 1867:  /* negv16hi2 */
    case 1866:  /* negv8si2 */
    case 1865:  /* negv4di2 */
    case 1864:  /* absv32qi2 */
    case 1863:  /* absv16hi2 */
    case 1862:  /* absv8si2 */
    case 1861:  /* absv4di2 */
    case 1808:  /* lasx_xvreplve0_w_f_scalar */
    case 1807:  /* lasx_xvreplve0_d_f_scalar */
    case 1746:  /* popcountv32qi2 */
    case 1745:  /* popcountv16hi2 */
    case 1744:  /* popcountv8si2 */
    case 1743:  /* popcountv4di2 */
    case 1730:  /* clzv32qi2 */
    case 1729:  /* clzv16hi2 */
    case 1728:  /* clzv8si2 */
    case 1727:  /* clzv4di2 */
    case 1674:  /* fixuns_truncv8sfv8si2 */
    case 1673:  /* fixuns_truncv4dfv4di2 */
    case 1650:  /* lasx_xvreplgr2vr_b */
    case 1649:  /* lasx_xvreplgr2vr_h */
    case 1648:  /* lasx_xvreplgr2vr_w */
    case 1647:  /* lasx_xvreplgr2vr_d */
    case 1646:  /* floatunsv8siv8sf2 */
    case 1645:  /* floatunsv4div4df2 */
    case 1644:  /* floatv8siv8sf2 */
    case 1643:  /* floatv4div4df2 */
    case 1553:  /* *sqrtv8sf2 */
    case 1552:  /* *sqrtv4df2 */
    case 1527:  /* one_cmplv32qi2 */
    case 1526:  /* one_cmplv16hi2 */
    case 1525:  /* one_cmplv8si2 */
    case 1524:  /* one_cmplv4di2 */
    case 1463:  /* vec_extractv8sf_0 */
    case 1462:  /* vec_extractv4df_0 */
    case 1204:  /* absv4sf2 */
    case 1203:  /* absv2df2 */
    case 1128:  /* vnegv16qi2 */
    case 1127:  /* vnegv8hi2 */
    case 1126:  /* vnegv4si2 */
    case 1125:  /* vnegv2di2 */
    case 1124:  /* absv16qi2 */
    case 1123:  /* absv8hi2 */
    case 1122:  /* absv4si2 */
    case 1121:  /* absv2di2 */
    case 1081:  /* lsx_vreplvei_b_scalar */
    case 1080:  /* lsx_vreplvei_h_scalar */
    case 1079:  /* lsx_vreplvei_w_scalar */
    case 1078:  /* lsx_vreplvei_d_scalar */
    case 1077:  /* lsx_vreplvei_w_f_scalar */
    case 1076:  /* lsx_vreplvei_d_f_scalar */
    case 1021:  /* popcountv16qi2 */
    case 1020:  /* popcountv8hi2 */
    case 1019:  /* popcountv4si2 */
    case 1018:  /* popcountv2di2 */
    case 1005:  /* clzv16qi2 */
    case 1004:  /* clzv8hi2 */
    case 1003:  /* clzv4si2 */
    case 1002:  /* clzv2di2 */
    case 949:  /* fixuns_truncv4sfv4si2 */
    case 948:  /* fixuns_truncv2dfv2di2 */
    case 925:  /* lsx_vreplgr2vr_b */
    case 924:  /* lsx_vreplgr2vr_h */
    case 923:  /* lsx_vreplgr2vr_w */
    case 922:  /* lsx_vreplgr2vr_d */
    case 921:  /* floatunsv4siv4sf2 */
    case 920:  /* floatunsv2div2df2 */
    case 919:  /* floatv4siv4sf2 */
    case 918:  /* floatv2div2df2 */
    case 830:  /* *sqrtv4sf2 */
    case 829:  /* *sqrtv2df2 */
    case 804:  /* one_cmplv16qi2 */
    case 803:  /* one_cmplv8hi2 */
    case 802:  /* one_cmplv4si2 */
    case 801:  /* one_cmplv2di2 */
    case 712:  /* lsx_vec_extract_w_f */
    case 711:  /* lsx_vec_extract_d_f */
    case 707:  /* negv8sf2 */
    case 706:  /* negv4df2 */
    case 705:  /* negv4sf2 */
    case 704:  /* negv2df2 */
    case 543:  /* fix_truncv8sfv8si2 */
    case 542:  /* fix_truncv4dfv4di2 */
    case 541:  /* fix_truncv4sfv4si2 */
    case 540:  /* fix_truncv2dfv2di2 */
    case 438:  /* simple_load_uextsidi */
    case 437:  /* simple_load_sextsidi */
    case 436:  /* simple_load_uexthidi */
    case 435:  /* simple_load_sexthidi */
    case 434:  /* simple_load_uextqidi */
    case 433:  /* simple_load_sextqidi */
    case 432:  /* simple_load_uextsisi */
    case 431:  /* simple_load_sextsisi */
    case 430:  /* simple_load_uexthisi */
    case 429:  /* simple_load_sexthisi */
    case 428:  /* simple_load_uextqisi */
    case 427:  /* simple_load_sextqisi */
    case 296:  /* *sne_zero_didi */
    case 295:  /* *sne_zero_disi */
    case 294:  /* *sne_zero_sisi */
    case 293:  /* *seq_zero_didi */
    case 292:  /* *seq_zero_disi */
    case 291:  /* *seq_zero_sisi */
    case 277:  /* bswapdi2 */
    case 276:  /* bswapsi2 */
    case 275:  /* bswaphi2 */
    case 150:  /* floatdisf2 */
    case 149:  /* floatsisf2 */
    case 148:  /* floatdidf2 */
    case 147:  /* floatsidf2 */
    case 146:  /* fix_truncdfdi2 */
    case 145:  /* fix_truncdfsi2 */
    case 144:  /* fix_truncsfdi2 */
    case 143:  /* fix_truncsfsi2 */
    case 142:  /* extendsfdf2 */
    case 141:  /* extendqihi2 */
    case 140:  /* extendhidi2 */
    case 139:  /* extendhisi2 */
    case 138:  /* extendqidi2 */
    case 137:  /* extendqisi2 */
    case 136:  /* extendsidi2 */
    case 130:  /* zero_extendqihi2 */
    case 129:  /* zero_extendhidi2 */
    case 128:  /* zero_extendhisi2 */
    case 127:  /* zero_extendqidi2 */
    case 126:  /* zero_extendqisi2 */
    case 125:  /* *zero_extendsidi2_internal */
    case 124:  /* truncdfsf2 */
    case 107:  /* *one_cmplsi2_internal */
    case 106:  /* one_cmpldi2 */
    case 105:  /* one_cmplsi2 */
    case 95:  /* negdf2 */
    case 94:  /* negsf2 */
    case 92:  /* negdi2 */
    case 91:  /* negsi2 */
    case 78:  /* ctzdi2 */
    case 77:  /* ctzsi2 */
    case 76:  /* clzdi2 */
    case 75:  /* clzsi2 */
    case 68:  /* absdf2 */
    case 67:  /* abssf2 */
    case 62:  /* *sqrtdf2 */
    case 61:  /* *sqrtsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 1937:  /* xvfnmsubv8sf4_nmsub4 */
    case 1936:  /* xvfnmsubv4df4_nmsub4 */
    case 1210:  /* vfnmsubv4sf4_nmsub4 */
    case 1209:  /* vfnmsubv2df4_nmsub4 */
    case 60:  /* *fnmadf4 */
    case 59:  /* *fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 1939:  /* xvfnmaddv8sf4_nmadd4 */
    case 1938:  /* xvfnmaddv4df4_nmadd4 */
    case 1212:  /* vfnmaddv4sf4_nmadd4 */
    case 1211:  /* vfnmaddv2df4_nmadd4 */
    case 58:  /* *fnmsdf4 */
    case 57:  /* *fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 56:  /* *fmsdf4 */
    case 55:  /* *fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 54:  /* *fmadf4 */
    case 53:  /* *fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 52:  /* fnmsdf4 */
    case 51:  /* fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 2153:  /* lasx_xvinsve0_w_f_scalar */
    case 2152:  /* lasx_xvinsve0_d_f_scalar */
    case 1551:  /* fnmav8sf4 */
    case 1550:  /* fnmav4df4 */
    case 1429:  /* lasx_xvinsgr2vr_w */
    case 1428:  /* lasx_xvinsgr2vr_d */
    case 828:  /* fnmav4sf4 */
    case 827:  /* fnmav2df4 */
    case 724:  /* lsx_vextrins_w_f_scalar */
    case 723:  /* lsx_vextrins_d_f_scalar */
    case 716:  /* lsx_vinsgr2vr_b */
    case 715:  /* lsx_vinsgr2vr_h */
    case 714:  /* lsx_vinsgr2vr_w */
    case 713:  /* lsx_vinsgr2vr_d */
    case 178:  /* *seldf */
    case 177:  /* *selsf */
    case 176:  /* *selnedi_using_di */
    case 175:  /* *seleqdi_using_di */
    case 174:  /* *selnesi_using_di */
    case 173:  /* *seleqsi_using_di */
    case 172:  /* *selnedi_using_si */
    case 171:  /* *seleqdi_using_si */
    case 170:  /* *selnesi_using_si */
    case 169:  /* *seleqsi_using_si */
    case 50:  /* fnmadf4 */
    case 49:  /* fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 1935:  /* fmsv8sf4 */
    case 1934:  /* fmsv4df4 */
    case 1208:  /* fmsv4sf4 */
    case 1207:  /* fmsv2df4 */
    case 48:  /* fmsdf4 */
    case 47:  /* fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 1933:  /* xvfmaddv8sf4 */
    case 1932:  /* xvfmaddv4df4 */
    case 1549:  /* fmav8sf4 */
    case 1548:  /* fmav4df4 */
    case 1206:  /* vfmaddv4sf4 */
    case 1205:  /* vfmaddv2df4 */
    case 826:  /* fmav4sf4 */
    case 825:  /* fmav2df4 */
    case 152:  /* *extzvdi */
    case 151:  /* *extzvsi */
    case 46:  /* fmadf4 */
    case 45:  /* fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 44:  /* umoddi3_fake */
    case 43:  /* moddi3_fake */
    case 42:  /* udivdi3_fake */
    case 41:  /* divdi3_fake */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0), 1));
      break;

    case 2168:  /* lasx_xvldi */
    case 2167:  /* lasx_xvextl_qu_du */
    case 2085:  /* lasx_xvextl_q_d */
    case 2084:  /* lasx_xvexth_qu_du */
    case 2083:  /* lasx_xvexth_q_d */
    case 2076:  /* lasx_xvmsknz_b */
    case 2075:  /* lasx_xvmskgez_b */
    case 1957:  /* lasx_xvftintrnel_l_s */
    case 1956:  /* lasx_xvftintrneh_l_s */
    case 1955:  /* lasx_xvftintrml_l_s */
    case 1954:  /* lasx_xvftintrmh_l_s */
    case 1953:  /* lasx_xvftintrpl_l_s */
    case 1952:  /* lasx_xvftintrph_l_s */
    case 1951:  /* lasx_xvftintrzl_l_s */
    case 1950:  /* lasx_xvftintrzh_l_s */
    case 1949:  /* lasx_xvffintl_d_w */
    case 1948:  /* lasx_xvffinth_d_w */
    case 1947:  /* lasx_xvftintl_l_s */
    case 1946:  /* lasx_xvftinth_l_s */
    case 1925:  /* lasx_xvmskltz_b */
    case 1924:  /* lasx_xvmskltz_h */
    case 1923:  /* lasx_xvmskltz_w */
    case 1922:  /* lasx_xvmskltz_d */
    case 1816:  /* lasx_xvfcvtl_s_h */
    case 1813:  /* lasx_xvfcvth_s_h */
    case 1809:  /* lasx_xvreplve0_q */
    case 1672:  /* lasx_xvftint_u_wu_s */
    case 1671:  /* lasx_xvftint_u_lu_d */
    case 1670:  /* lasx_xvfrsqrte_s */
    case 1669:  /* lasx_xvfrsqrte_d */
    case 1668:  /* *rsqrtv8sf2 */
    case 1667:  /* *rsqrtv4df2 */
    case 1666:  /* lasx_xvfrecipe_s */
    case 1665:  /* lasx_xvfrecipe_d */
    case 1652:  /* logbv8sf2 */
    case 1651:  /* logbv4df2 */
    case 1642:  /* lasx_xvfclass_s */
    case 1641:  /* lasx_xvfclass_d */
    case 1375:  /* lsx_vextl_q_d */
    case 1374:  /* lsx_vexth_qu_du */
    case 1373:  /* lsx_vexth_q_d */
    case 1366:  /* lsx_vmsknz_b */
    case 1365:  /* lsx_vmskgez_b */
    case 1269:  /* lsx_vextl_qu_du */
    case 1265:  /* lsx_vldi */
    case 1230:  /* lsx_vftintrnel_l_s */
    case 1229:  /* lsx_vftintrneh_l_s */
    case 1228:  /* lsx_vftintrml_l_s */
    case 1227:  /* lsx_vftintrmh_l_s */
    case 1226:  /* lsx_vftintrpl_l_s */
    case 1225:  /* lsx_vftintrph_l_s */
    case 1224:  /* lsx_vftintrzl_l_s */
    case 1223:  /* lsx_vftintrzh_l_s */
    case 1222:  /* lsx_vffintl_d_w */
    case 1221:  /* lsx_vffinth_d_w */
    case 1220:  /* lsx_vftintl_l_s */
    case 1219:  /* lsx_vftinth_l_s */
    case 1198:  /* lsx_vmskltz_b */
    case 1197:  /* lsx_vmskltz_h */
    case 1196:  /* lsx_vmskltz_w */
    case 1195:  /* lsx_vmskltz_d */
    case 1130:  /* lsx_vextw_u_d */
    case 1129:  /* lsx_vextw_s_d */
    case 1087:  /* lsx_vfcvtl_s_h */
    case 1085:  /* lsx_vfcvth_s_h */
    case 947:  /* lsx_vftint_u_wu_s */
    case 946:  /* lsx_vftint_u_lu_d */
    case 945:  /* lsx_vfrsqrte_s */
    case 944:  /* lsx_vfrsqrte_d */
    case 943:  /* *rsqrtv4sf2 */
    case 942:  /* *rsqrtv2df2 */
    case 941:  /* lsx_vfrecipe_s */
    case 940:  /* lsx_vfrecipe_d */
    case 927:  /* logbv4sf2 */
    case 926:  /* logbv2df2 */
    case 917:  /* lsx_vfclass_s */
    case 916:  /* lsx_vfclass_d */
    case 519:  /* lasx_xvfrintrne_s */
    case 518:  /* lasx_xvfrintrm_s */
    case 517:  /* lasx_xvfrint_s */
    case 516:  /* lasx_xvfrintrz_s */
    case 515:  /* lasx_xvfrintrp_s */
    case 514:  /* lasx_xvfrintrne_d */
    case 513:  /* lasx_xvfrintrm_d */
    case 512:  /* lasx_xvfrint_d */
    case 511:  /* lasx_xvfrintrz_d */
    case 510:  /* lasx_xvfrintrp_d */
    case 509:  /* lsx_vfrintrne_s */
    case 508:  /* lsx_vfrintrm_s */
    case 507:  /* lsx_vfrint_s */
    case 506:  /* lsx_vfrintrz_s */
    case 505:  /* lsx_vfrintrp_s */
    case 504:  /* lsx_vfrintrne_d */
    case 503:  /* lsx_vfrintrm_d */
    case 502:  /* lsx_vfrint_d */
    case 501:  /* lsx_vfrintrz_d */
    case 500:  /* lsx_vfrintrp_d */
    case 398:  /* bitrev_8b */
    case 397:  /* bitrev_4b */
    case 383:  /* fclass_d */
    case 382:  /* fclass_s */
    case 380:  /* loongarch_movfcsr2gr */
    case 280:  /* revh_d */
    case 279:  /* revb_4h */
    case 278:  /* revb_2h */
    case 233:  /* loongarch_cpucfg */
    case 230:  /* movfrh2grtf */
    case 229:  /* movfrh2grdi */
    case 228:  /* movfrh2grdf */
    case 224:  /* load_tlsdi */
    case 223:  /* load_tlssi */
    case 213:  /* load_lowtf */
    case 212:  /* load_lowdi */
    case 211:  /* load_lowdf */
    case 210:  /* lceildfdi2 */
    case 209:  /* lfloordfdi2 */
    case 208:  /* lrintdfdi2 */
    case 207:  /* lceildfsi2 */
    case 206:  /* lfloordfsi2 */
    case 205:  /* lrintdfsi2 */
    case 204:  /* lceilsfdi2 */
    case 203:  /* lfloorsfdi2 */
    case 202:  /* lrintsfdi2 */
    case 201:  /* lceilsfsi2 */
    case 200:  /* lfloorsfsi2 */
    case 199:  /* lrintsfsi2 */
    case 198:  /* rintdf2 */
    case 197:  /* rintsf2 */
    case 192:  /* pcalau12i_grdi */
    case 191:  /* pcalau12i_grsi */
    case 190:  /* pcalau12idi */
    case 189:  /* pcalau12isi */
    case 188:  /* lui_l_hi20di */
    case 187:  /* lui_l_hi20si */
    case 74:  /* logb_non_negativedf2 */
    case 73:  /* logb_non_negativesf2 */
    case 66:  /* loongarch_frsqrte_d */
    case 65:  /* loongarch_frsqrte_s */
    case 64:  /* *rsqrtdf2 */
    case 63:  /* *rsqrtsf2 */
    case 28:  /* loongarch_frecipe_d */
    case 27:  /* loongarch_frecipe_s */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 1812:  /* vec_pack_trunc_v4df */
    case 1734:  /* lasx_xvnor_b */
    case 1733:  /* lasx_xvnor_h */
    case 1732:  /* lasx_xvnor_w */
    case 1731:  /* lasx_xvnor_d */
    case 1557:  /* lasx_xvadda_b */
    case 1556:  /* lasx_xvadda_h */
    case 1555:  /* lasx_xvadda_w */
    case 1554:  /* lasx_xvadda_d */
    case 1427:  /* vec_pack_trunc_v16hi */
    case 1426:  /* vec_pack_trunc_v8si */
    case 1425:  /* vec_pack_trunc_v4di */
    case 1084:  /* vec_pack_trunc_v2df */
    case 1009:  /* lsx_nor_b */
    case 1008:  /* lsx_nor_h */
    case 1007:  /* lsx_nor_w */
    case 1006:  /* lsx_nor_d */
    case 834:  /* lsx_vadda_b */
    case 833:  /* lsx_vadda_h */
    case 832:  /* lsx_vadda_w */
    case 831:  /* lsx_vadda_d */
    case 710:  /* vec_pack_trunc_v8hi */
    case 709:  /* vec_pack_trunc_v4si */
    case 708:  /* vec_pack_trunc_v2di */
    case 396:  /* bytepick_d_7 */
    case 395:  /* bytepick_d_6 */
    case 394:  /* bytepick_d_5 */
    case 393:  /* bytepick_d_4 */
    case 392:  /* bytepick_d_3 */
    case 391:  /* bytepick_d_2 */
    case 390:  /* bytepick_d_1 */
    case 386:  /* bytepick_w_3 */
    case 385:  /* bytepick_w_2 */
    case 384:  /* bytepick_w_1 */
    case 117:  /* *norsi3_internal */
    case 116:  /* nordi3 */
    case 115:  /* norsi3 */
    case 20:  /* umulsidi3_64bit */
    case 19:  /* mulsidi3_64bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 22:  /* umulsi3_highpart */
    case 21:  /* smulsi3_highpart */
    case 18:  /* umuldi3_highpart */
    case 17:  /* smuldi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 1742:  /* lasx_xvpickod_w_f */
    case 1741:  /* lasx_xvpickod_w */
    case 1740:  /* lasx_xvpickod_h */
    case 1739:  /* lasx_xvpickod_b */
    case 1738:  /* lasx_xvpickev_w_f */
    case 1737:  /* lasx_xvpickev_w */
    case 1736:  /* lasx_xvpickev_h */
    case 1735:  /* lasx_xvpickev_b */
    case 1706:  /* lasx_xvilvl_d_f */
    case 1705:  /* lasx_xvilvl_d */
    case 1704:  /* lasx_xvilvl_w_f */
    case 1703:  /* lasx_xvilvl_w */
    case 1702:  /* lasx_xvilvl_h */
    case 1701:  /* lasx_xvilvl_b */
    case 1700:  /* lasx_xvpackod_w_f */
    case 1699:  /* lasx_xvpackod_w */
    case 1698:  /* lasx_xvpackod_h */
    case 1697:  /* lasx_xvpackod_b */
    case 1696:  /* lasx_xvilvh_d_f */
    case 1695:  /* lasx_xvilvh_d */
    case 1694:  /* lasx_xvilvh_w_f */
    case 1693:  /* lasx_xvilvh_w */
    case 1692:  /* lasx_xvilvh_h */
    case 1691:  /* lasx_xvilvh_b */
    case 1690:  /* lasx_xvpackev_w_f */
    case 1689:  /* lasx_xvpackev_w */
    case 1688:  /* lasx_xvpackev_h */
    case 1687:  /* lasx_xvpackev_b */
    case 1017:  /* lsx_vpickod_w_f */
    case 1016:  /* lsx_vpickod_w */
    case 1015:  /* lsx_vpickod_h */
    case 1014:  /* lsx_vpickod_b */
    case 1013:  /* lsx_vpickev_w_f */
    case 1012:  /* lsx_vpickev_w */
    case 1011:  /* lsx_vpickev_h */
    case 1010:  /* lsx_vpickev_b */
    case 981:  /* lsx_vilvl_d_f */
    case 980:  /* lsx_vilvl_d */
    case 979:  /* lsx_vilvl_w_f */
    case 978:  /* lsx_vilvl_w */
    case 977:  /* lsx_vilvl_h */
    case 976:  /* lsx_vilvl_b */
    case 975:  /* lsx_vpackod_w_f */
    case 974:  /* lsx_vpackod_w */
    case 973:  /* lsx_vpackod_h */
    case 972:  /* lsx_vpackod_b */
    case 971:  /* lsx_vilvh_d_f */
    case 970:  /* lsx_vilvh_d */
    case 969:  /* lsx_vilvh_w_f */
    case 968:  /* lsx_vilvh_w */
    case 967:  /* lsx_vilvh_h */
    case 966:  /* lsx_vilvh_b */
    case 965:  /* lsx_vpackev_w_f */
    case 964:  /* lsx_vpackev_w */
    case 963:  /* lsx_vpackev_h */
    case 962:  /* lsx_vpackev_b */
    case 663:  /* lasx_xvfcmp_cge_s */
    case 662:  /* lasx_xvfcmp_cgt_s */
    case 661:  /* lasx_xvfcmp_suge_s */
    case 660:  /* lasx_xvfcmp_sugt_s */
    case 659:  /* lasx_xvfcmp_cge_d */
    case 658:  /* lasx_xvfcmp_cgt_d */
    case 657:  /* lasx_xvfcmp_suge_d */
    case 656:  /* lasx_xvfcmp_sugt_d */
    case 655:  /* lsx_vfcmp_cge_s */
    case 654:  /* lsx_vfcmp_cgt_s */
    case 653:  /* lsx_vfcmp_suge_s */
    case 652:  /* lsx_vfcmp_sugt_s */
    case 651:  /* lsx_vfcmp_cge_d */
    case 650:  /* lsx_vfcmp_cgt_d */
    case 649:  /* lsx_vfcmp_suge_d */
    case 648:  /* lsx_vfcmp_sugt_d */
    case 647:  /* lasx_xvfcmp_cle_s */
    case 646:  /* lasx_xvfcmp_clt_s */
    case 645:  /* lasx_xvfcmp_sule_s */
    case 644:  /* lasx_xvfcmp_sult_s */
    case 643:  /* lasx_xvfcmp_cle_d */
    case 642:  /* lasx_xvfcmp_clt_d */
    case 641:  /* lasx_xvfcmp_sule_d */
    case 640:  /* lasx_xvfcmp_sult_d */
    case 639:  /* lsx_vfcmp_cle_s */
    case 638:  /* lsx_vfcmp_clt_s */
    case 637:  /* lsx_vfcmp_sule_s */
    case 636:  /* lsx_vfcmp_sult_s */
    case 635:  /* lsx_vfcmp_cle_d */
    case 634:  /* lsx_vfcmp_clt_d */
    case 633:  /* lsx_vfcmp_sule_d */
    case 632:  /* lsx_vfcmp_sult_d */
    case 269:  /* rotrsi3_extend */
    case 266:  /* *lshrsi3_extend */
    case 265:  /* *ashrsi3_extend */
    case 264:  /* *ashlsi3_extend */
    case 40:  /* umodsi3_extended */
    case 39:  /* modsi3_extended */
    case 38:  /* udivsi3_extended */
    case 37:  /* divsi3_extended */
    case 16:  /* *mulsi3_extended */
    case 11:  /* *subsi3_extended */
    case 6:  /* addsi3_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 1784:  /* lasx_xvssub_u_bu */
    case 1783:  /* lasx_xvssub_u_hu */
    case 1782:  /* lasx_xvssub_u_wu */
    case 1781:  /* lasx_xvssub_u_du */
    case 1780:  /* lasx_xvssub_s_b */
    case 1779:  /* lasx_xvssub_s_h */
    case 1778:  /* lasx_xvssub_s_w */
    case 1777:  /* lasx_xvssub_s_d */
    case 1722:  /* uminv32qi3 */
    case 1721:  /* uminv16hi3 */
    case 1720:  /* uminv8si3 */
    case 1719:  /* uminv4di3 */
    case 1718:  /* sminv32qi3 */
    case 1717:  /* sminv16hi3 */
    case 1716:  /* sminv8si3 */
    case 1715:  /* sminv4di3 */
    case 1714:  /* umaxv32qi3 */
    case 1713:  /* umaxv16hi3 */
    case 1712:  /* umaxv8si3 */
    case 1711:  /* umaxv4di3 */
    case 1710:  /* smaxv32qi3 */
    case 1709:  /* smaxv16hi3 */
    case 1708:  /* smaxv8si3 */
    case 1707:  /* smaxv4di3 */
    case 1664:  /* recipv8sf3 */
    case 1663:  /* recipv4df3 */
    case 1660:  /* sminv8sf3 */
    case 1659:  /* sminv4df3 */
    case 1656:  /* smaxv8sf3 */
    case 1655:  /* smaxv4df3 */
    case 1640:  /* lasx_xvslt_bu */
    case 1639:  /* lasx_xvslt_b */
    case 1638:  /* lasx_xvsle_bu */
    case 1637:  /* lasx_xvsle_b */
    case 1636:  /* lasx_xvseq_b */
    case 1635:  /* lasx_xvslt_hu */
    case 1634:  /* lasx_xvslt_h */
    case 1633:  /* lasx_xvsle_hu */
    case 1632:  /* lasx_xvsle_h */
    case 1631:  /* lasx_xvseq_h */
    case 1630:  /* lasx_xvslt_wu */
    case 1629:  /* lasx_xvslt_w */
    case 1628:  /* lasx_xvsle_wu */
    case 1627:  /* lasx_xvsle_w */
    case 1626:  /* lasx_xvseq_w */
    case 1625:  /* lasx_xvslt_du */
    case 1624:  /* lasx_xvslt_d */
    case 1623:  /* lasx_xvsle_du */
    case 1622:  /* lasx_xvsle_d */
    case 1621:  /* lasx_xvseq_d */
    case 1565:  /* usaddv32qi3 */
    case 1564:  /* usaddv16hi3 */
    case 1563:  /* usaddv8si3 */
    case 1562:  /* usaddv4di3 */
    case 1561:  /* ssaddv32qi3 */
    case 1560:  /* ssaddv16hi3 */
    case 1559:  /* ssaddv8si3 */
    case 1558:  /* ssaddv4di3 */
    case 1547:  /* *divv8sf3 */
    case 1546:  /* *divv4df3 */
    case 1545:  /* mulv8sf3 */
    case 1544:  /* mulv4df3 */
    case 1543:  /* subv8sf3 */
    case 1542:  /* subv4df3 */
    case 1541:  /* addv8sf3 */
    case 1540:  /* addv4df3 */
    case 1539:  /* vashlv32qi3 */
    case 1538:  /* vashlv16hi3 */
    case 1537:  /* vashlv8si3 */
    case 1536:  /* vashlv4di3 */
    case 1535:  /* vashrv32qi3 */
    case 1534:  /* vashrv16hi3 */
    case 1533:  /* vashrv8si3 */
    case 1532:  /* vashrv4di3 */
    case 1531:  /* vlshrv32qi3 */
    case 1530:  /* vlshrv16hi3 */
    case 1529:  /* vlshrv8si3 */
    case 1528:  /* vlshrv4di3 */
    case 1523:  /* andv32qi3 */
    case 1522:  /* andv16hi3 */
    case 1521:  /* andv8si3 */
    case 1520:  /* andv4di3 */
    case 1519:  /* andv8sf3 */
    case 1518:  /* andv4df3 */
    case 1517:  /* iorv32qi3 */
    case 1516:  /* iorv16hi3 */
    case 1515:  /* iorv8si3 */
    case 1514:  /* iorv4di3 */
    case 1513:  /* iorv8sf3 */
    case 1512:  /* iorv4df3 */
    case 1511:  /* xorv32qi3 */
    case 1510:  /* xorv16hi3 */
    case 1509:  /* xorv8si3 */
    case 1508:  /* xorv4di3 */
    case 1507:  /* xorv8sf3 */
    case 1506:  /* xorv4df3 */
    case 1505:  /* umodv32qi3 */
    case 1504:  /* umodv16hi3 */
    case 1503:  /* umodv8si3 */
    case 1502:  /* umodv4di3 */
    case 1501:  /* modv32qi3 */
    case 1500:  /* modv16hi3 */
    case 1499:  /* modv8si3 */
    case 1498:  /* modv4di3 */
    case 1497:  /* udivv32qi3 */
    case 1496:  /* udivv16hi3 */
    case 1495:  /* udivv8si3 */
    case 1494:  /* udivv4di3 */
    case 1493:  /* divv32qi3 */
    case 1492:  /* divv16hi3 */
    case 1491:  /* divv8si3 */
    case 1490:  /* divv4di3 */
    case 1481:  /* mulv32qi3 */
    case 1480:  /* mulv16hi3 */
    case 1479:  /* mulv8si3 */
    case 1478:  /* mulv4di3 */
    case 1477:  /* subv32qi3 */
    case 1476:  /* subv16hi3 */
    case 1475:  /* subv8si3 */
    case 1474:  /* subv4di3 */
    case 1473:  /* addv32qi3 */
    case 1472:  /* addv16hi3 */
    case 1471:  /* addv8si3 */
    case 1470:  /* addv4di3 */
    case 1435:  /* vec_concatv32qi */
    case 1434:  /* vec_concatv16hi */
    case 1433:  /* vec_concatv8si */
    case 1432:  /* vec_concatv4di */
    case 1431:  /* vec_concatv8sf */
    case 1430:  /* vec_concatv4df */
    case 1113:  /* vec_concatv2df */
    case 1057:  /* lsx_vssub_u_bu */
    case 1056:  /* lsx_vssub_u_hu */
    case 1055:  /* lsx_vssub_u_wu */
    case 1054:  /* lsx_vssub_u_du */
    case 1053:  /* lsx_vssub_s_b */
    case 1052:  /* lsx_vssub_s_h */
    case 1051:  /* lsx_vssub_s_w */
    case 1050:  /* lsx_vssub_s_d */
    case 1033:  /* lsx_vshuf4i_w_f */
    case 1032:  /* lsx_vshuf4i_b */
    case 1031:  /* lsx_vshuf4i_h */
    case 1030:  /* lsx_vshuf4i_w */
    case 997:  /* uminv16qi3 */
    case 996:  /* uminv8hi3 */
    case 995:  /* uminv4si3 */
    case 994:  /* uminv2di3 */
    case 993:  /* sminv16qi3 */
    case 992:  /* sminv8hi3 */
    case 991:  /* sminv4si3 */
    case 990:  /* sminv2di3 */
    case 989:  /* umaxv16qi3 */
    case 988:  /* umaxv8hi3 */
    case 987:  /* umaxv4si3 */
    case 986:  /* umaxv2di3 */
    case 985:  /* smaxv16qi3 */
    case 984:  /* smaxv8hi3 */
    case 983:  /* smaxv4si3 */
    case 982:  /* smaxv2di3 */
    case 939:  /* recipv4sf3 */
    case 938:  /* recipv2df3 */
    case 935:  /* sminv4sf3 */
    case 934:  /* sminv2df3 */
    case 931:  /* smaxv4sf3 */
    case 930:  /* smaxv2df3 */
    case 915:  /* lsx_vslt_bu */
    case 914:  /* lsx_vslt_b */
    case 913:  /* lsx_vsle_bu */
    case 912:  /* lsx_vsle_b */
    case 911:  /* lsx_vseq_b */
    case 910:  /* lsx_vslt_hu */
    case 909:  /* lsx_vslt_h */
    case 908:  /* lsx_vsle_hu */
    case 907:  /* lsx_vsle_h */
    case 906:  /* lsx_vseq_h */
    case 905:  /* lsx_vslt_wu */
    case 904:  /* lsx_vslt_w */
    case 903:  /* lsx_vsle_wu */
    case 902:  /* lsx_vsle_w */
    case 901:  /* lsx_vseq_w */
    case 900:  /* lsx_vslt_du */
    case 899:  /* lsx_vslt_d */
    case 898:  /* lsx_vsle_du */
    case 897:  /* lsx_vsle_d */
    case 896:  /* lsx_vseq_d */
    case 842:  /* usaddv16qi3 */
    case 841:  /* usaddv8hi3 */
    case 840:  /* usaddv4si3 */
    case 839:  /* usaddv2di3 */
    case 838:  /* ssaddv16qi3 */
    case 837:  /* ssaddv8hi3 */
    case 836:  /* ssaddv4si3 */
    case 835:  /* ssaddv2di3 */
    case 824:  /* *divv4sf3 */
    case 823:  /* *divv2df3 */
    case 822:  /* mulv4sf3 */
    case 821:  /* mulv2df3 */
    case 820:  /* subv4sf3 */
    case 819:  /* subv2df3 */
    case 818:  /* addv4sf3 */
    case 817:  /* addv2df3 */
    case 816:  /* vashlv16qi3 */
    case 815:  /* vashlv8hi3 */
    case 814:  /* vashlv4si3 */
    case 813:  /* vashlv2di3 */
    case 812:  /* vashrv16qi3 */
    case 811:  /* vashrv8hi3 */
    case 810:  /* vashrv4si3 */
    case 809:  /* vashrv2di3 */
    case 808:  /* vlshrv16qi3 */
    case 807:  /* vlshrv8hi3 */
    case 806:  /* vlshrv4si3 */
    case 805:  /* vlshrv2di3 */
    case 800:  /* andv16qi3 */
    case 799:  /* andv8hi3 */
    case 798:  /* andv4si3 */
    case 797:  /* andv2di3 */
    case 796:  /* andv4sf3 */
    case 795:  /* andv2df3 */
    case 794:  /* iorv16qi3 */
    case 793:  /* iorv8hi3 */
    case 792:  /* iorv4si3 */
    case 791:  /* iorv2di3 */
    case 790:  /* iorv4sf3 */
    case 789:  /* iorv2df3 */
    case 788:  /* xorv16qi3 */
    case 787:  /* xorv8hi3 */
    case 786:  /* xorv4si3 */
    case 785:  /* xorv2di3 */
    case 784:  /* xorv4sf3 */
    case 783:  /* xorv2df3 */
    case 782:  /* umodv16qi3 */
    case 781:  /* umodv8hi3 */
    case 780:  /* umodv4si3 */
    case 779:  /* umodv2di3 */
    case 778:  /* modv16qi3 */
    case 777:  /* modv8hi3 */
    case 776:  /* modv4si3 */
    case 775:  /* modv2di3 */
    case 774:  /* udivv16qi3 */
    case 773:  /* udivv8hi3 */
    case 772:  /* udivv4si3 */
    case 771:  /* udivv2di3 */
    case 770:  /* divv16qi3 */
    case 769:  /* divv8hi3 */
    case 768:  /* divv4si3 */
    case 767:  /* divv2di3 */
    case 758:  /* mulv16qi3 */
    case 757:  /* mulv8hi3 */
    case 756:  /* mulv4si3 */
    case 755:  /* mulv2di3 */
    case 754:  /* subv16qi3 */
    case 753:  /* subv8hi3 */
    case 752:  /* subv4si3 */
    case 751:  /* subv2di3 */
    case 750:  /* addv16qi3 */
    case 749:  /* addv8hi3 */
    case 748:  /* addv4si3 */
    case 747:  /* addv2di3 */
    case 631:  /* lasx_xvfcmp_cugt_s */
    case 630:  /* lasx_xvfcmp_cuge_s */
    case 629:  /* lasx_xvfcmp_sgt_s */
    case 628:  /* lasx_xvfcmp_sge_s */
    case 627:  /* lasx_xvfcmp_cugt_d */
    case 626:  /* lasx_xvfcmp_cuge_d */
    case 625:  /* lasx_xvfcmp_sgt_d */
    case 624:  /* lasx_xvfcmp_sge_d */
    case 623:  /* lsx_vfcmp_cugt_s */
    case 622:  /* lsx_vfcmp_cuge_s */
    case 621:  /* lsx_vfcmp_sgt_s */
    case 620:  /* lsx_vfcmp_sge_s */
    case 619:  /* lsx_vfcmp_cugt_d */
    case 618:  /* lsx_vfcmp_cuge_d */
    case 617:  /* lsx_vfcmp_sgt_d */
    case 616:  /* lsx_vfcmp_sge_d */
    case 615:  /* lasx_xvfcmp_cune_s */
    case 614:  /* lasx_xvfcmp_sne_s */
    case 613:  /* lasx_xvfcmp_cor_s */
    case 612:  /* lasx_xvfcmp_sle_s */
    case 611:  /* lasx_xvfcmp_slt_s */
    case 610:  /* lasx_xvfcmp_ceq_s */
    case 609:  /* lasx_xvfcmp_cule_s */
    case 608:  /* lasx_xvfcmp_cult_s */
    case 607:  /* lasx_xvfcmp_cueq_s */
    case 606:  /* lasx_xvfcmp_cun_s */
    case 605:  /* lasx_xvfcmp_cune_d */
    case 604:  /* lasx_xvfcmp_sne_d */
    case 603:  /* lasx_xvfcmp_cor_d */
    case 602:  /* lasx_xvfcmp_sle_d */
    case 601:  /* lasx_xvfcmp_slt_d */
    case 600:  /* lasx_xvfcmp_ceq_d */
    case 599:  /* lasx_xvfcmp_cule_d */
    case 598:  /* lasx_xvfcmp_cult_d */
    case 597:  /* lasx_xvfcmp_cueq_d */
    case 596:  /* lasx_xvfcmp_cun_d */
    case 595:  /* lsx_vfcmp_cune_s */
    case 594:  /* lsx_vfcmp_sne_s */
    case 593:  /* lsx_vfcmp_cor_s */
    case 592:  /* lsx_vfcmp_sle_s */
    case 591:  /* lsx_vfcmp_slt_s */
    case 590:  /* lsx_vfcmp_ceq_s */
    case 589:  /* lsx_vfcmp_cule_s */
    case 588:  /* lsx_vfcmp_cult_s */
    case 587:  /* lsx_vfcmp_cueq_s */
    case 586:  /* lsx_vfcmp_cun_s */
    case 585:  /* lsx_vfcmp_cune_d */
    case 584:  /* lsx_vfcmp_sne_d */
    case 583:  /* lsx_vfcmp_cor_d */
    case 582:  /* lsx_vfcmp_sle_d */
    case 581:  /* lsx_vfcmp_slt_d */
    case 580:  /* lsx_vfcmp_ceq_d */
    case 579:  /* lsx_vfcmp_cule_d */
    case 578:  /* lsx_vfcmp_cult_d */
    case 577:  /* lsx_vfcmp_cueq_d */
    case 576:  /* lsx_vfcmp_cun_d */
    case 575:  /* rotrv32qi3 */
    case 574:  /* rotrv16hi3 */
    case 573:  /* rotrv8si3 */
    case 572:  /* rotrv4di3 */
    case 571:  /* rotrv16qi3 */
    case 570:  /* rotrv8hi3 */
    case 569:  /* rotrv4si3 */
    case 568:  /* rotrv2di3 */
    case 567:  /* vrotrv32qi3 */
    case 566:  /* vrotrv16hi3 */
    case 565:  /* vrotrv8si3 */
    case 564:  /* vrotrv4di3 */
    case 563:  /* vrotrv16qi3 */
    case 562:  /* vrotrv8hi3 */
    case 561:  /* vrotrv4si3 */
    case 560:  /* vrotrv2di3 */
    case 342:  /* sungt_df_using_FCCmode */
    case 341:  /* sunge_df_using_FCCmode */
    case 340:  /* sgt_df_using_FCCmode */
    case 339:  /* sge_df_using_FCCmode */
    case 338:  /* sne_df_using_FCCmode */
    case 337:  /* sltgt_df_using_FCCmode */
    case 336:  /* sordered_df_using_FCCmode */
    case 335:  /* sle_df_using_FCCmode */
    case 334:  /* slt_df_using_FCCmode */
    case 333:  /* seq_df_using_FCCmode */
    case 332:  /* sunle_df_using_FCCmode */
    case 331:  /* sunlt_df_using_FCCmode */
    case 330:  /* suneq_df_using_FCCmode */
    case 329:  /* sunordered_df_using_FCCmode */
    case 328:  /* sungt_sf_using_FCCmode */
    case 327:  /* sunge_sf_using_FCCmode */
    case 326:  /* sgt_sf_using_FCCmode */
    case 325:  /* sge_sf_using_FCCmode */
    case 324:  /* sne_sf_using_FCCmode */
    case 323:  /* sltgt_sf_using_FCCmode */
    case 322:  /* sordered_sf_using_FCCmode */
    case 321:  /* sle_sf_using_FCCmode */
    case 320:  /* slt_sf_using_FCCmode */
    case 319:  /* seq_sf_using_FCCmode */
    case 318:  /* sunle_sf_using_FCCmode */
    case 317:  /* sunlt_sf_using_FCCmode */
    case 316:  /* suneq_sf_using_FCCmode */
    case 315:  /* sunordered_sf_using_FCCmode */
    case 314:  /* *sleu_didi */
    case 313:  /* *sle_didi */
    case 312:  /* *sleu_disi */
    case 311:  /* *sle_disi */
    case 310:  /* *sleu_sisi */
    case 309:  /* *sle_sisi */
    case 308:  /* *sltu_didi */
    case 307:  /* *slt_didi */
    case 306:  /* *sltu_disi */
    case 305:  /* *slt_disi */
    case 304:  /* *sltu_sisi */
    case 303:  /* *slt_sisi */
    case 302:  /* *sgtu_didi */
    case 301:  /* *sgt_didi */
    case 300:  /* *sgtu_disi */
    case 299:  /* *sgt_disi */
    case 298:  /* *sgtu_sisi */
    case 297:  /* *sgt_sisi */
    case 268:  /* rotrdi3 */
    case 267:  /* rotrsi3 */
    case 263:  /* lshrdi3 */
    case 262:  /* ashrdi3 */
    case 261:  /* ashldi3 */
    case 260:  /* lshrsi3 */
    case 259:  /* ashrsi3 */
    case 258:  /* ashlsi3 */
    case 182:  /* *lowdi */
    case 181:  /* *lowsi */
    case 114:  /* *iorhi3 */
    case 111:  /* *bstrins_di_for_mask */
    case 110:  /* *bstrins_si_for_mask */
    case 109:  /* anddi3_extended */
    case 108:  /* andsi3_extended */
    case 104:  /* *xorsi3_internal */
    case 103:  /* *iorsi3_internal */
    case 102:  /* *andsi3_internal */
    case 101:  /* xordi3 */
    case 100:  /* iordi3 */
    case 99:  /* anddi3 */
    case 98:  /* xorsi3 */
    case 97:  /* iorsi3 */
    case 96:  /* andsi3 */
    case 82:  /* smindf3 */
    case 81:  /* sminsf3 */
    case 80:  /* smaxdf3 */
    case 79:  /* smaxsf3 */
    case 70:  /* copysigndf3 */
    case 69:  /* copysignsf3 */
    case 36:  /* *umodsi3 */
    case 35:  /* *modsi3 */
    case 34:  /* *udivsi3 */
    case 33:  /* *divsi3 */
    case 32:  /* *umoddi3 */
    case 31:  /* *moddi3 */
    case 30:  /* *udivdi3 */
    case 29:  /* *divdi3 */
    case 26:  /* *recipdf3 */
    case 25:  /* *recipsf3 */
    case 24:  /* *divdf3 */
    case 23:  /* *divsf3 */
    case 15:  /* muldi3 */
    case 14:  /* mulsi3 */
    case 13:  /* muldf3 */
    case 12:  /* mulsf3 */
    case 10:  /* subdi3 */
    case 9:  /* subsi3 */
    case 8:  /* subdf3 */
    case 7:  /* subsf3 */
    case 5:  /* adddi3 */
    case 4:  /* *addsi3 */
    case 3:  /* adddf3 */
    case 2:  /* addsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 379:  /* nop */
    case 357:  /* eh_return_internal */
    case 356:  /* loongarch_ertn */
    case 353:  /* *simple_return */
    case 352:  /* *return */
    case 349:  /* blockage */
    case 1:  /* trap */
      break;

    }
}
