/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_10 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_11 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_12 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_13 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_14 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_15 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_16 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_17 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_18 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_19 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_20 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_21 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_22 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_23 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_24 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_25 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_26 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_27 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_28 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_29 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_30 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_31 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_32 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_33 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_34 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_35 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_36 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_37 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_38 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_39 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_40 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_41 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_42 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_43 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_44 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_3 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_CCmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SFmode))
    return -1;
  return 0;
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != UNSPEC
      || XVECLEN (x12, 0) != 1
      || XINT (x12, 1) != 11)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  return 0;
}

static int
pattern6 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

static int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 4
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

static int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern8 (x1, E_SImode); /* [-1, 0] */

    case E_SFmode:
      if (pattern8 (x1, E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[1] = x8;
  return 0;
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  if (!logical_shift_operator (operands[4], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (XWINT (x3, 0) != 0L)
    return -1;
  operands[3] = x1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

static int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

static int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern18 (x1, E_SImode); /* [-1, 0] */

    case E_SFmode:
      if (pattern18 (x1, E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != NEG
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != ASHIFT
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  operands[7] = x1;
  operands[5] = x2;
  x11 = XEXP (x4, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  operands[6] = x6;
  x13 = XEXP (x6, 0);
  operands[3] = x13;
  x14 = XEXP (x9, 0);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  x15 = XEXP (x8, 1);
  if (!rtx_equal_p (x15, operands[4]))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !add_operand (operands[2], E_SImode))
            return -1;
          return 1; /* addsi3 */

        case E_SFmode:
          if (pattern8 (x2, E_SFmode) != 0
              || !
#line 244 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 3; /* addsf3 */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 403 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MAC16))
        return -1;
      return 12; /* muladdhisi */

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern9 (x2))
            {
            case 0:
              return 4; /* subsi3 */

            case 1:
              if (!
#line 314 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 6; /* subsf3 */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SIGN_EXTEND
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND
              || GET_MODE (x6) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_HImode)
              || !
#line 416 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MAC16))
            return -1;
          return 13; /* mulsubhisi */

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_int_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 267 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(xtensa_simm8 (-INTVAL (operands[1]))
   || xtensa_simm8x256 (-INTVAL (operands[1]))))
        return -1;
      return 5; /* *subsi3_from_const */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!addsub_operator (x2, E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      operands[4] = x2;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!addsubx_operand (operands[3], E_SImode)
          || !
#line 180 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX))
        return -1;
      return 2; /* *addsubx */

    case AND:
      x5 = XEXP (x3, 0);
      if (!logical_shift_operator (x5, E_SImode))
        return -1;
      operands[6] = x5;
      operands[5] = x2;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      if (!const_int_operand (operands[4], E_SImode)
          || !
#line 1135 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX
   && IN_RANGE (exact_log2 (INTVAL (operands[4])), 1, 3)))
        return -1;
      return 51; /* *extzvsi-1bit_addsubx */

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (pattern19 (x2))
    {
    case 0:
      return 94; /* movsicc_internal0 */

    case 1:
      return 96; /* movsfcc_internal0 */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case LT:
      operands[3] = x3;
      if (branch_operator (operands[3], E_VOIDmode)
          && pattern10 (x1) == 0
          && branch_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          return 79; /* *btrue */
        }
      operands[4] = x3;
      if (branch_operator (operands[4], E_VOIDmode))
        {
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!boolean_operator (x3, E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          switch (XWINT (x7, 0))
            {
            case -2147483648L:
              x4 = XEXP (x2, 1);
              if (GET_CODE (x4) != LABEL_REF)
                return -1;
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) != PC)
                return -1;
              x9 = XEXP (x1, 0);
              if (GET_CODE (x9) != PC)
                return -1;
              operands[2] = x3;
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!
#line 1971 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ABS))
                return -1;
              return 80; /* *btrue_INT_MIN */

            case 0L:
              if (!register_operand (x6, E_CCmode))
                return -1;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case REG:
                case SUBREG:
                  operands[2] = x4;
                  x9 = XEXP (x1, 0);
                  operands[0] = x9;
                  operands[4] = x3;
                  operands[1] = x6;
                  switch (pattern19 (x2))
                    {
                    case 0:
                      if (!
#line 2497 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                        return -1;
                      return 95; /* movsicc_internal1 */

                    case 1:
                      if (!
#line 2528 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                        return -1;
                      return 97; /* movsfcc_internal1 */

                    default:
                      return -1;
                    }

                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  x9 = XEXP (x1, 0);
                  if (GET_CODE (x9) != PC)
                    return -1;
                  operands[2] = x3;
                  operands[0] = x6;
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (!
#line 3046 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                    return -1;
                  return 127; /* *booltrue */

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != LABEL_REF)
                    return -1;
                  x9 = XEXP (x1, 0);
                  if (GET_CODE (x9) != PC)
                    return -1;
                  operands[2] = x3;
                  operands[0] = x6;
                  x10 = XEXP (x8, 0);
                  operands[1] = x10;
                  if (!
#line 3064 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                    return -1;
                  return 128; /* *boolfalse */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x11 = XEXP (x6, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x1, 0);
          if (GET_CODE (x9) != PC)
            return -1;
          operands[3] = x3;
          x12 = XEXP (x6, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x6, 2);
          operands[1] = x13;
          if (!arith_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          return 82; /* *bittrue */

        case AND:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x1, 0);
          if (GET_CODE (x9) != PC)
            return -1;
          x11 = XEXP (x6, 1);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[0] = x12;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              switch (GET_CODE (operands[1]))
                {
                case REG:
                case SUBREG:
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 1);
                  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  operands[3] = x3;
                  x5 = XEXP (x4, 0);
                  operands[2] = x5;
                  return 83; /* *masktrue */

                case CONST_INT:
                  operands[4] = x3;
                  x7 = XEXP (x3, 1);
                  operands[2] = x7;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x5 = XEXP (x4, 0);
                  operands[3] = x5;
                  if (const_int_operand (operands[1], E_SImode))
                    {
                      if (
#line 2178 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[1]) + 1), 17, 31)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) << (32 - floor_log2 (INTVAL (operands[1]) + 1)))))
                        return 86; /* *masktrue_const_pow2_minus_one */
                      if (
#line 2218 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[1])), 1, 30)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) >> floor_log2 (-INTVAL (operands[1])))))
                        return 87; /* *masktrue_const_negative_pow2 */
                    }
                  if (!shifted_mask_operand (operands[1], E_SImode)
                      || !
#line 2253 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(/* (INTVAL (operands[2]) & ((1 << ctz_hwi (INTVAL (operands[1]))) - 1)) == 0  // can be omitted
   && */ xtensa_b4const_or_zero ((uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])))))
                    return -1;
                  return 88; /* *masktrue_const_shifted_mask */

                default:
                  return -1;
                }

            case NOT:
              if (GET_MODE (x12) != E_SImode)
                return -1;
              x7 = XEXP (x3, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[3] = x3;
              x14 = XEXP (x12, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              switch (GET_CODE (operands[1]))
                {
                case REG:
                case SUBREG:
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  return 84; /* *masktrue_bitcmpl */

                case CONST_INT:
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 2094 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[1])) < 0))
                    return -1;
                  return 85; /* *masktrue_const_bitcmpl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[3] = x3;
      if (!ubranch_operator (operands[3], E_VOIDmode)
          || pattern10 (x1) != 0
          || !ubranch_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      return 81; /* *ubtrue */

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
    case MINUS:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      if (GET_MODE (x3) == E_SImode
          && register_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_SImode))
                    return 41; /* iorsi3 */
                }
              break;

            case AND:
              if (GET_MODE (x4) == E_SImode)
                {
                  x5 = XEXP (x3, 1);
                  if (GET_CODE (x5) == AND
                      && GET_MODE (x5) == E_SImode
                      && pattern17 (x3) == 0
                      && 
#line 903 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && INTVAL (operands[3]) + INTVAL (operands[4]) == -1
   && (exact_log2 (INTVAL (operands[3]) + 1) > 16
       || exact_log2 (INTVAL (operands[4]) + 1) > 16)))
                    return 43; /* *splice_bits */
                }
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_SImode)
      || !xtensa_bit_join_operator (x3, E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  if (!logical_shift_operator (x4, E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (!logical_shift_operator (x5, E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  if (!register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != NEG
          || GET_MODE (x9) != E_SImode)
        return -1;
      operands[6] = x3;
      operands[4] = x4;
      operands[5] = x5;
      operands[2] = x7;
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[3])
          || !
#line 1764 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[4], operands[5]) != UNKNOWN))
        return -1;
      return 72; /* *shlrd_reg */

    case NEG:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      operands[6] = x3;
      operands[4] = x4;
      x11 = XEXP (x8, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      operands[5] = x5;
      operands[2] = x7;
      x9 = XEXP (x5, 1);
      if (!rtx_equal_p (x9, operands[3])
          || !
#line 1787 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[5], operands[4]) != UNKNOWN))
        return -1;
      return 73; /* *shlrd_reg */

    case CONST_INT:
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      operands[7] = x3;
      operands[5] = x4;
      operands[6] = x5;
      operands[2] = x7;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode)
          || !
#line 1814 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[5], operands[6]) != UNKNOWN
   && IN_RANGE (INTVAL (operands[3]), 1, 31)
   && IN_RANGE (INTVAL (operands[4]), 1, 31)
   && INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
        return -1;
      return 74; /* *shlrd_const */

    case ASHIFT:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x12 = XEXP (x8, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != NEG
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != ASHIFT
          || GET_MODE (x10) != E_SImode)
        return -1;
      x13 = XEXP (x10, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      operands[6] = x3;
      operands[4] = x4;
      x11 = XEXP (x8, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      operands[5] = x5;
      operands[3] = x7;
      x14 = XEXP (x10, 0);
      if (!rtx_equal_p (x14, operands[2])
          || !
#line 1842 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[4], operands[5]) != UNKNOWN))
        return -1;
      return 75; /* *shlrd_per_byte */

    case AND:
      if (GET_MODE (x8) != E_SImode
          || pattern20 (x3) != 0
          || !
#line 1869 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[5], operands[6]) != UNKNOWN
   && (INTVAL (operands[4]) & 0x1f) == 3 << 3))
        return -1;
      return 76; /* *shlrd_per_byte_omit_AND */

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (nonimmed_operand (operands[0], E_DImode)
              && move_operand (operands[1], E_DImode)
              && 
#line 1246 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)))
            return 56; /* movdi_internal */
          break;

        case E_SImode:
          if (nonimmed_operand (operands[0], E_SImode)
              && move_operand (operands[1], E_SImode)
              && 
#line 1289 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (SImode, operands)))
            return 57; /* movsi_internal */
          break;

        case E_HImode:
          if (nonimmed_operand (operands[0], E_HImode)
              && move_operand (operands[1], E_HImode)
              && 
#line 1353 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (HImode, operands)))
            return 58; /* movhi_internal */
          break;

        case E_QImode:
          if (nonimmed_operand (operands[0], E_QImode)
              && move_operand (operands[1], E_QImode)
              && 
#line 1383 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (QImode, operands)))
            return 59; /* movqi_internal */
          break;

        case E_SFmode:
          if (nonimmed_operand (operands[0], E_SFmode)
              && move_operand (operands[1], E_SFmode)
              && 
#line 1455 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(((register_operand (operands[0], SFmode)
     || register_operand (operands[1], SFmode))
    && !(FP_REG_P (xt_true_regnum (operands[0]))
	 && (constantpool_mem_p (operands[1]) || CONSTANT_P (operands[1]))))))
            return 60; /* movsf_internal */
          break;

        case E_DFmode:
          if (nonimmed_operand (operands[0], E_DFmode)
              && move_operand (operands[1], E_DFmode)
              && 
#line 1581 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode)))
            return 65; /* movdf_internal */
          break;

        default:
          break;
        }
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (register_operand (operands[0], E_SImode))
        return 106; /* indirect_jump_internal */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LABEL_REF
      || GET_CODE (x2) != PC)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  return 105; /* jump */
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) == EQ)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_CCmode)
              && GET_MODE (x3) == E_CCmode
              && register_operand (operands[1], E_SFmode)
              && 
#line 2544 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return 98; /* seq_sf */
          break;

        case CONST_INT:
          if (XWINT (x5, 0) == 0L
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode
              && register_operand (operands[1], E_SImode)
              && 
#line 3234 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_NSA))
            return 134; /* eq_zero_NSA */
          break;

        default:
          break;
        }
    }
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || !boolean_operator (x3, E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x3;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 135; /* eqne_zero */

        case -2147483648L:
          if (!
#line 3318 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ABS))
            return -1;
          return 137; /* *eqne_INT_MIN */

        default:
          return -1;
        }

    case AND:
      if (pattern14 (x3) != 0
          || !
#line 3290 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)
   || IN_RANGE (exact_log2 (-INTVAL (operands[2])), 1, 30)))
        return -1;
      return 136; /* *eqne_zero_masked_bits */

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_SImode)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (register_operand (operands[1], E_SImode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (arith_operand (operands[2], E_SImode))
            {
              switch (GET_CODE (x3))
                {
                case ASHIFT:
                  return 66; /* ashlsi3_internal */

                case ASHIFTRT:
                  return 67; /* ashrsi3 */

                case LSHIFTRT:
                  return 68; /* lshrsi3 */

                default:
                  break;
                }
            }
        }
    }
  if (!xtensa_shift_per_byte_operator (x3, E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case ASHIFT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      operands[3] = x3;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 1695 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize))
        return -1;
      return 69; /* *shift_per_byte */

    case AND:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != ASHIFT
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      operands[4] = x3;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x5, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 1716 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3))
        return -1;
      return 70; /* *shift_per_byte_omit_AND_0 */

    case NEG:
      x7 = XEXP (x5, 0);
      if (pattern15 (x7) != 0)
        return -1;
      operands[4] = x3;
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x7, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 1737 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3))
        return -1;
      return 71; /* *shift_per_byte_omit_AND_1 */

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (mask_operand (operands[2], E_SImode))
        return 36; /* andsi3 */
      if (const_int_operand (operands[2], E_SImode))
        {
          if (
#line 779 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)))
            return 38; /* *andsi3_const_pow2_minus_one */
          if (
#line 803 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[2])), 12, 31)))
            return 39; /* *andsi3_const_negative_pow2 */
        }
      if (!shifted_mask_operand (operands[2], E_SImode)
          || !
#line 823 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(! xtensa_simm12b (INTVAL (operands[2]))))
        return -1;
      return 40; /* *andsi3_const_shifted_mask */

    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 37; /* *andsi3_bitcmpl */

    case ASHIFT:
    case LSHIFTRT:
      if (pattern13 (x2) != 0
          || !
#line 1092 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[3])) > 0))
        return -1;
      return 50; /* *extzvsi-1bit_ashlsi3 */

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 132; /* *round_up_to_even */

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SFmode))
    return -1;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!fpmem_offset_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x5, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XEXP (x4, 0);
      if (!rtx_equal_p (x12, operands[1])
          || !
#line 1484 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && !TARGET_HARD_FLOAT_POSTINC))
        return -1;
      return 61; /* *lsiu */

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[2] = x11;
      if (!fpmem_offset_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x12 = XEXP (x4, 0);
      if (!rtx_equal_p (x12, operands[1])
          || !
#line 1516 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && TARGET_HARD_FLOAT_POSTINC))
        return -1;
      return 63; /* *lsip */

    default:
      return -1;
    }
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (!register_operand (x6, E_SFmode))
        return -1;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[1] = x9;
          if (!fpmem_offset_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x6;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x4, 0);
          if (!rtx_equal_p (x12, operands[0])
              || !
#line 1500 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && !TARGET_HARD_FLOAT_POSTINC))
            return -1;
          return 62; /* *ssiu */

        case REG:
        case SUBREG:
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          operands[1] = x6;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!fpmem_offset_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          x12 = XEXP (x4, 0);
          if (!rtx_equal_p (x12, operands[0])
              || !
#line 1532 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && TARGET_HARD_FLOAT_POSTINC))
            return -1;
          return 64; /* *ssip */

        default:
          return -1;
        }

    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x12 = XEXP (x4, 0);
      if (GET_CODE (x12) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      return 107; /* tablejump_internal */

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case TRUNCATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != LSHIFTRT
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 366 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32_HIGH))
            return -1;
          return 7; /* mulsi3_highpart */

        case ZERO_EXTEND:
          if (GET_CODE (x8) != ZERO_EXTEND)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 366 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32_HIGH))
            return -1;
          return 8; /* umulsi3_highpart */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 376 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32))
                return -1;
              return 9; /* mulsi3 */

            case 1:
              if (!
#line 426 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 14; /* mulsf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern6 (x2, SIGN_EXTEND) != 0
              || !
#line 388 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MUL16 || TARGET_MAC16))
            return -1;
          return 10; /* mulhisi3 */

        case ZERO_EXTEND:
          if (pattern6 (x2, ZERO_EXTEND) != 0
              || !
#line 388 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MUL16 || TARGET_MAC16))
            return -1;
          return 11; /* umulhisi3 */

        default:
          return -1;
        }

    case FMA:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x11 = XEXP (x2, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_SFmode))
        return -1;
      x12 = XEXP (x2, 2);
      operands[3] = x12;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 437 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 15; /* fmasf4 */

        case NEG:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 449 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 16; /* fnmasf4 */

        default:
          return -1;
        }

    case DIV:
      if (pattern0 (x1) != 0
          || !
#line 462 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 17; /* divsi3 */

    case UDIV:
      if (pattern0 (x1) != 0
          || !
#line 472 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 18; /* udivsi3 */

    case MOD:
      if (pattern0 (x1) != 0
          || !
#line 485 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 19; /* modsi3 */

    case UMOD:
      if (pattern0 (x1) != 0
          || !
#line 495 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 20; /* umodsi3 */

    case ABS:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 507 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ABS))
            return -1;
          return 21; /* abssi2 */

        case 1:
          if (!
#line 516 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 22; /* abssf2 */

        default:
          return -1;
        }

    case SMIN:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x2, 1);
          operands[2] = x11;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 529 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
            return -1;
          return 23; /* sminsi3 */

        case SMAX:
          if (pattern12 (x2) != 0
              || !
#line 561 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX && TARGET_CLAMPS
   && xtensa_match_CLAMPS_imms_p (operands[2], operands[3])))
            return -1;
          return 28; /* *xtensa_clamps */

        default:
          return -1;
        }

    case UMIN:
      if (pattern0 (x1) != 0
          || !
#line 529 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
        return -1;
      return 24; /* uminsi3 */

    case SMAX:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x2, 1);
          operands[2] = x11;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 529 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
            return -1;
          return 25; /* smaxsi3 */

        case SMIN:
          if (pattern12 (x2) != 0
              || !
#line 543 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX && TARGET_CLAMPS
   && xtensa_match_CLAMPS_imms_p (operands[3], operands[2])))
            return -1;
          return 27; /* *xtensa_clamps */

        default:
          return -1;
        }

    case UMAX:
      if (pattern0 (x1) != 0
          || !
#line 529 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
        return -1;
      return 26; /* umaxsi3 */

    case CLRSB:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 579 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_NSA))
        return -1;
      return 29; /* clrsbsi2 */

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 588 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_NSA))
        return -1;
      return 30; /* clzsi2 */

    case BSWAP:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 1;
          return 31; /* bswaphi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 657 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize > 1 && !optimize_size))
            return -1;
          *pnum_clobbers = 1;
          return 32; /* bswapsi2_internal */

        default:
          return -1;
        }

    case NEG:
      switch (pattern1 (x1))
        {
        case 0:
          return 33; /* negsi2 */

        case 1:
          if (!
#line 734 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 35; /* negsf2 */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 34; /* one_cmplsi2 */

    case AND:
      return recog_10 (x1, insn, pnum_clobbers);

    case XOR:
      if (pattern0 (x1) != 0)
        return -1;
      return 42; /* xorsi3_internal */

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmed_operand (operands[1], E_HImode))
            return -1;
          return 44; /* zero_extendhisi2 */

        case E_QImode:
          if (!nonimmed_operand (operands[1], E_QImode))
            return -1;
          return 45; /* zero_extendqisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!sext_operand (operands[1], E_HImode))
            return -1;
          return 46; /* extendhisi2_internal */

        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !
#line 1009 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_SEXT))
            return -1;
          return 47; /* extendqisi2_internal */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x2, 1);
      operands[2] = x11;
      if (!sext_fldsz_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x2, 2);
      operands[3] = x12;
      if (!lsbitnum_operand (operands[3], E_SImode)
          || !
#line 1043 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_SEXT))
        return -1;
      return 48; /* extvsi_internal */

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x2, 1);
      operands[2] = x11;
      if (!extui_fldsz_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x2, 2);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      return 49; /* extzvsi_internal */

    case FIX:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1176 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 52; /* fix_truncsfsi2 */

    case UNSIGNED_FIX:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1185 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 53; /* fixuns_truncsfsi2 */

    case FLOAT:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1194 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 54; /* floatsisf2 */

    case UNSIGNED_FLOAT:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1203 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 55; /* floatunssisf2 */

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      return recog_7 (x1, insn, pnum_clobbers);

    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      return recog_9 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case IOR:
      return recog_6 (x1, insn, pnum_clobbers);

    case ROTATE:
      if (pattern2 (x1) != 0)
        return -1;
      return 77; /* rotlsi3 */

    case ROTATERT:
      if (pattern2 (x1) != 0)
        return -1;
      return 78; /* rotrsi3 */

    case IF_THEN_ELSE:
      return recog_5 (x1, insn, pnum_clobbers);

    case LT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x11 = XEXP (x2, 1);
      operands[2] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern8 (x2, E_SImode) != 0
              || !
#line 2419 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_SALT))
            return -1;
          return 92; /* salt */

        case E_CCmode:
          if (!register_operand (operands[0], E_CCmode)
              || GET_MODE (x2) != E_CCmode
              || !register_operand (operands[1], E_SFmode)
              || !register_operand (operands[2], E_SFmode)
              || !
#line 2544 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 99; /* slt_sf */

        default:
          return -1;
        }

    case LTU:
      if (pattern0 (x1) != 0
          || !
#line 2429 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_SALT))
        return -1;
      return 93; /* saltu */

    case NE:
    case EQ:
      return recog_8 (x1, insn, pnum_clobbers);

    case LE:
      if (pattern3 (x1) != 0
          || !
#line 2544 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 100; /* sle_sf */

    case UNEQ:
      if (pattern3 (x1) != 0
          || !
#line 2544 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 101; /* suneq_sf */

    case UNLT:
      if (pattern3 (x1) != 0
          || !
#line 2544 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 102; /* sunlt_sf */

    case UNLE:
      if (pattern3 (x1) != 0
          || !
#line 2544 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 103; /* sunle_sf */

    case UNORDERED:
      if (pattern3 (x1) != 0
          || !
#line 2544 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 104; /* sunordered_sf */

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST:
        case REG:
        case SYMBOL_REF:
          operands[1] = x4;
          if (!call_insn_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_VOIDmode))
            return -1;
          x11 = XEXP (x2, 1);
          operands[2] = x11;
          if (
#line 2654 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!SIBLING_CALL_P (insn)))
            return 109; /* call_value_internal */
          if (GET_MODE (x3) != E_SImode
              || !
#line 2696 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!TARGET_WINDOWED_ABI && SIBLING_CALL_P (insn)))
            return -1;
          return 111; /* sibcall_value_internal */

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 7
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x13 = XVECEXP (x4, 0, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x14 = XVECEXP (x4, 0, 1);
          operands[2] = x14;
          if (!tls_symbol_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x2, 1);
          operands[3] = x11;
          if (!
#line 3025 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS))
            return -1;
          return 126; /* tls_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 1:
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 1
              || GET_MODE (x6) != E_SImode)
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          operands[0] = x15;
          if (!const_int_operand (operands[0], E_SImode))
            return -1;
          return 112; /* entry */

        case 4:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 0
              || GET_MODE (x6) != E_SImode)
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          operands[0] = x15;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 115; /* eh_set_a0_windowed */

        case 0:
          if (pattern11 (x1) != 0)
            return -1;
          return 120; /* set_frame_ptr */

        case 2:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          if (!mem_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 3103 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_RELEASE_SYNC))
            return -1;
          return 130; /* sync_lock_releasesi */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (XINT (x2, 1))
        {
        case 12:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          operands[1] = x15;
          return 118; /* *frame_blockage */

        case 8:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || !
#line 2984 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR))
            return -1;
          return 122; /* get_thread_pointersi */

        case 5:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          operands[1] = x15;
          if (!tls_symbol_operand (operands[1], E_SImode)
              || !
#line 3003 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS))
            return -1;
          return 124; /* tls_func */

        case 6:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          operands[1] = x15;
          if (!tls_symbol_operand (operands[1], E_SImode)
              || !
#line 3013 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS))
            return -1;
          return 125; /* tls_arg */

        case 9:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x15 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x15, operands[0]))
            return -1;
          return 129; /* *memory_barrier */

        default:
          return -1;
        }

    case GE:
      if (pattern4 (x1) != 0)
        return -1;
      return 133; /* *signed_ge_zero */

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_13 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 1);
              switch (GET_CODE (x3))
                {
                case BSWAP:
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x5 = XEXP (x2, 0);
                  operands[0] = x5;
                  x6 = XEXP (x3, 0);
                  operands[1] = x6;
                  x7 = XEXP (x4, 0);
                  operands[2] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern16 (x3, E_HImode) != 0)
                        return -1;
                      return 31; /* bswaphi2 */

                    case E_SImode:
                      if (pattern16 (x3, E_SImode) != 0
                          || !
#line 657 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize > 1 && !optimize_size))
                        return -1;
                      return 32; /* bswapsi2_internal */

                    default:
                      return -1;
                    }

                case UNSPEC_VOLATILE:
                  if (pattern7 (x2) != 0)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x8 = XVECEXP (x3, 0, 0);
                  operands[0] = x8;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x7 = XEXP (x4, 0);
                  operands[1] = x7;
                  if (!scratch_operand (operands[1], E_SImode))
                    return -1;
                  return 115; /* eh_set_a0_windowed */

                case REG:
                case SUBREG:
                case MEM:
                  switch (GET_CODE (x3))
                    {
                    case MEM:
                      res = recog_11 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                      break;

                    case REG:
                    case SUBREG:
                      res = recog_12 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                      break;

                    default:
                      break;
                    }
                  operands[1] = x3;
                  if (!mem_operand (operands[1], E_SImode))
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != SET)
                    return -1;
                  x9 = XEXP (x4, 1);
                  if (GET_CODE (x9) != UNSPEC_VOLATILE
                      || XVECLEN (x9, 0) != 3
                      || XINT (x9, 1) != 3
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x5 = XEXP (x2, 0);
                  operands[0] = x5;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XVECEXP (x9, 0, 1);
                  operands[2] = x10;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XVECEXP (x9, 0, 2);
                  operands[3] = x11;
                  if (!register_operand (operands[3], E_SImode))
                    return -1;
                  x12 = XVECEXP (x9, 0, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  x7 = XEXP (x4, 0);
                  if (!rtx_equal_p (x7, operands[1])
                      || !
#line 3119 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_S32C1I))
                    return -1;
                  return 131; /* sync_compare_and_swapsi */

                case NE:
                case EQ:
                  operands[2] = x3;
                  if (!boolean_operator (operands[2], E_SImode))
                    return -1;
                  x13 = XEXP (x3, 1);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x5 = XEXP (x2, 0);
                  operands[0] = x5;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x6 = XEXP (x3, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x4, 0);
                  operands[3] = x7;
                  if (!scratch_operand (operands[3], E_SImode))
                    return -1;
                  return 135; /* eqne_zero */

                default:
                  return -1;
                }

            case RETURN:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 0
                  || GET_MODE (x7) != E_SImode
                  || !
#line 2738 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(xtensa_use_return_instruction_p ()))
                return -1;
              return 113; /* return */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 4)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x14 = XVECEXP (x2, 0, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              return 116; /* eh_set_a0_call0 */

            default:
              return -1;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != IF_THEN_ELSE)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != NE)
            return -1;
          x15 = XEXP (x6, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x13 = XEXP (x3, 1);
          if (GET_CODE (x13) != LABEL_REF)
            return -1;
          x16 = XEXP (x3, 2);
          if (GET_CODE (x16) != PC)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x17 = XEXP (x9, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x18 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x18) != UNSPEC
              || XVECLEN (x18, 0) != 1)
            return -1;
          x19 = XVECEXP (x18, 0, 0);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XEXP (x6, 0);
          operands[2] = x20;
          x21 = XEXP (x13, 0);
          operands[1] = x21;
          x7 = XEXP (x4, 0);
          operands[0] = x7;
          x22 = XEXP (x9, 0);
          if (!rtx_equal_p (x22, operands[0]))
            return -1;
          switch (XINT (x18, 1))
            {
            case 10:
              if (!register_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || !
#line 2305 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                return -1;
              return 89; /* zero_cost_loop_start */

            case 11:
              if (pnum_clobbers != NULL
                  && nonimmediate_operand (operands[2], E_SImode)
                  && nonimmediate_operand (operands[0], E_SImode)
                  && 
#line 2322 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                {
                  *pnum_clobbers = 1;
                  return 90; /* zero_cost_loop_end */
                }
              if (!register_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || !
#line 2338 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                return -1;
              return 91; /* loop_end */

            default:
              return -1;
            }

        case 4:
          if (pattern5 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x3 = XEXP (x2, 1);
          x6 = XEXP (x3, 0);
          x20 = XEXP (x6, 0);
          operands[2] = x20;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x3, 1);
          x21 = XEXP (x13, 0);
          operands[1] = x21;
          x4 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x4, 0);
          operands[0] = x7;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x23 = XVECEXP (x1, 0, 3);
          x24 = XEXP (x23, 0);
          operands[3] = x24;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          x22 = XEXP (x9, 0);
          if (!rtx_equal_p (x22, operands[0])
              || !
#line 2322 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
            return -1;
          return 90; /* zero_cost_loop_end */

        default:
          return -1;
        }

    case CALL:
      x25 = XEXP (x1, 0);
      if (GET_CODE (x25) != MEM)
        return -1;
      x26 = XEXP (x25, 0);
      operands[0] = x26;
      if (!call_insn_operand (operands[0], E_SImode))
        return -1;
      x27 = XEXP (x1, 1);
      operands[1] = x27;
      if (
#line 2632 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!SIBLING_CALL_P (insn)))
        return 108; /* call_internal */
      if (GET_MODE (x25) != E_SImode
          || !
#line 2674 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!TARGET_WINDOWED_ABI && SIBLING_CALL_P (insn)))
        return -1;
      return 110; /* sibcall_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 114; /* nop */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 4:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 116; /* eh_set_a0_call0 */

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 117; /* blockage */

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2993 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR))
            return -1;
          return 123; /* set_thread_pointersi */

        default:
          return -1;
        }

    case TRAP_IF:
      x25 = XEXP (x1, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x27 = XEXP (x1, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 119; /* trap */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 121; /* *unspec_nop */

    default:
      return -1;
    }
}

static rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SMIN
      || GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return NULL;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode)
      || !(
#line 543 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX && TARGET_CLAMPS
   && xtensa_match_CLAMPS_imms_p (operands[3], operands[2])) && 
#line 546 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
    return NULL;
  return gen_split_3 (insn, operands);
}

static rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 761 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ()))
        return NULL;
      return gen_split_5 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_SImode))
        {
          if ((
#line 779 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)) && 
#line 781 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
            return gen_split_6 (insn, operands);
          if ((
#line 803 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[2])), 12, 31)) && 
#line 805 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
            return gen_split_7 (insn, operands);
        }
      if (!shifted_mask_operand (operands[2], E_SImode)
          || !(
#line 823 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(! xtensa_simm12b (INTVAL (operands[2]))) && 
#line 825 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
        return NULL;
      return gen_split_8 (insn, operands);

    case ASHIFT:
    case LSHIFTRT:
      if (pattern13 (x2) != 0
          || !(
#line 1092 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[3])) > 0) && 
#line 1094 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
        return NULL;
      return gen_split_10 (insn, operands);

    default:
      return NULL;
    }
}

static rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_SImode)
    {
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (GET_CODE (x3))
        {
        case PLUS:
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) == ASHIFT
              && GET_MODE (x5) == E_SImode)
            {
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  if (addsubx_operand (operands[3], E_SImode)
                      && const_int_operand (operands[2], E_SImode)
                      && 
#line 202 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX && can_create_pseudo_p ()))
                    return gen_split_1 (insn, operands);
                }
            }
          break;

        case MINUS:
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (const_int_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_SImode)
              && (
#line 267 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(xtensa_simm8 (-INTVAL (operands[1]))
   || xtensa_simm8x256 (-INTVAL (operands[1]))) && 
#line 270 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
            return gen_split_2 (insn, operands);
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_SImode)
    return NULL;
  x6 = XEXP (x5, 0);
  if (!logical_shift_operator (x6, E_SImode))
    return NULL;
  operands[6] = x6;
  operands[5] = x3;
  if (!addsub_operator (operands[5], E_SImode))
    return NULL;
  x8 = XEXP (x6, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x9 = XEXP (x6, 1);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_SImode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode)
      || !(
#line 1135 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX
   && IN_RANGE (exact_log2 (INTVAL (operands[4])), 1, 3)) && 
#line 1138 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
    return NULL;
  return gen_split_11 (insn, operands);
}

static rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!boolean_operator (x3, E_VOIDmode))
    return NULL;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return NULL;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return NULL;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return NULL;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[0] = x7;
      if (register_operand (operands[0], E_SImode))
        {
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) == CONST_INT
              && XWINT (x8, 0) == -2147483648L)
            {
              operands[2] = x3;
              x9 = XEXP (x4, 0);
              operands[1] = x9;
              if ((
#line 1971 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ABS) && 
#line 1973 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return gen_split_25 (insn, operands);
            }
        }
      if (GET_CODE (x7) != SUBREG)
        return NULL;
      x10 = XEXP (x7, 0);
      if (GET_CODE (x10) != NOT
          || GET_MODE (x10) != E_SImode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[2] = x3;
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (SUBREG_BYTE (x7))
        {
        case 0:
          switch (GET_MODE (x7))
            {
            case E_HImode:
              if (!
#line 2126 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!BYTES_BIG_ENDIAN))
                return NULL;
              return gen_split_27 (insn, operands);

            case E_QImode:
              if (!
#line 2126 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!BYTES_BIG_ENDIAN))
                return NULL;
              return gen_split_28 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (GET_MODE (x7) != E_HImode
              || !
#line 2145 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(BYTES_BIG_ENDIAN))
            return NULL;
          return gen_split_29 (insn, operands);

        case 3:
          if (GET_MODE (x7) != E_QImode
              || !
#line 2161 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(BYTES_BIG_ENDIAN))
            return NULL;
          return gen_split_30 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      if (GET_MODE (x7) != E_SImode)
        return NULL;
      x12 = XEXP (x7, 1);
      operands[1] = x12;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return NULL;
          x8 = XEXP (x3, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          operands[3] = x3;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_SImode)
              || !const_int_operand (operands[1], E_SImode))
            return NULL;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          if (!(
#line 2094 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[1])) < 0) && 
#line 2096 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_26 (insn, operands);

        case REG:
        case SUBREG:
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          operands[4] = x3;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x9 = XEXP (x4, 0);
          operands[3] = x9;
          if (const_int_operand (operands[1], E_SImode))
            {
              if ((
#line 2178 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[1]) + 1), 17, 31)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) << (32 - floor_log2 (INTVAL (operands[1]) + 1)))) && 
#line 2182 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return gen_split_31 (insn, operands);
              if ((
#line 2218 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[1])), 1, 30)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) >> floor_log2 (-INTVAL (operands[1])))) && 
#line 2222 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return gen_split_32 (insn, operands);
            }
          if (!shifted_mask_operand (operands[1], E_SImode)
              || !(
#line 2253 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(/* (INTVAL (operands[2]) & ((1 << ctz_hwi (INTVAL (operands[1]))) - 1)) == 0  // can be omitted
   && */ xtensa_b4const_or_zero ((uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])))) && 
#line 2256 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_33 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case SMAX:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case NOT:
          if (GET_MODE (x2) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 715 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ()))
                    return gen_split_4 (insn, operands);
                }
            }
          break;

        case AND:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
          if (GET_MODE (x2) == E_SImode)
            {
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) == AND
                  && GET_MODE (x4) == E_SImode)
                {
                  x5 = XEXP (x2, 1);
                  if (GET_CODE (x5) == AND
                      && GET_MODE (x5) == E_SImode)
                    {
                      x3 = XEXP (x1, 0);
                      operands[0] = x3;
                      if (register_operand (operands[0], E_SImode)
                          && pattern17 (x2) == 0
                          && (
#line 903 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && INTVAL (operands[3]) + INTVAL (operands[4]) == -1
   && (exact_log2 (INTVAL (operands[3]) + 1) > 16
       || exact_log2 (INTVAL (operands[4]) + 1) > 16)) && 
#line 908 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                        return gen_split_9 (insn, operands);
                    }
                }
            }
          break;

        case PLUS:
        case MINUS:
          res = split_3 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x2;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmed_operand (operands[0], E_DImode)
                  && move_operand (operands[1], E_DImode)
                  && (
#line 1246 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)) && 
#line 1249 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( reload_completed)))
                return gen_split_12 (insn, operands);
              if (register_operand (operands[0], E_DImode)
                  && const_int_operand (operands[1], E_DImode)
                  && 
#line 1265 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!TARGET_CONST16
   && ! xtensa_split1_finished_p ()))
                return gen_split_13 (insn, operands);
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && const_int_operand (operands[1], E_SImode)
                  && 
#line 1314 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!TARGET_CONST16 && !TARGET_AUTO_LITPOOLS
   && ! xtensa_split1_finished_p ()
   && ! xtensa_simm12b (INTVAL (operands[1]))))
                return gen_split_14 (insn, operands);
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && const_int_operand (operands[1], E_HImode)
                  && 
#line 1314 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!TARGET_CONST16 && !TARGET_AUTO_LITPOOLS
   && ! xtensa_split1_finished_p ()
   && ! xtensa_simm12b (INTVAL (operands[1]))))
                return gen_split_15 (insn, operands);
              break;

            case E_DFmode:
              if (nonimmed_operand (operands[0], E_DFmode)
                  && move_operand (operands[1], E_DFmode)
                  && (
#line 1581 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode)) && 
#line 1584 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( reload_completed)))
                return gen_split_19 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case IF_THEN_ELSE:
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && constantpool_operand (operands[1], E_SImode)
              && 
#line 1326 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(! optimize_debug && reload_completed))
            return gen_split_16 (insn, operands);
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && constantpool_operand (operands[1], E_HImode)
              && 
#line 1326 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(! optimize_debug && reload_completed))
            return gen_split_17 (insn, operands);
          break;

        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && constantpool_operand (operands[1], E_SFmode)
              && 
#line 1545 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(! optimize_debug && reload_completed))
            return gen_split_18 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case ASHIFT:
        case ASHIFTRT:
        case LSHIFTRT:
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          if (GET_CODE (x2) == ASHIFT
              && GET_MODE (x2) == E_SImode)
            {
              x5 = XEXP (x2, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  && 
#line 1653 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
                return gen_split_20 (insn, operands);
            }
          operands[4] = x2;
          if (!xtensa_shift_per_byte_operator (operands[4], E_SImode))
            return NULL;
          x5 = XEXP (x2, 1);
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          switch (GET_CODE (x5))
            {
            case AND:
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != ASHIFT
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode)
                  || !(
#line 1716 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3) && 
#line 1719 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_21 (insn, operands);

            case NEG:
              x6 = XEXP (x5, 0);
              if (pattern15 (x6) != 0)
                return NULL;
              x8 = XEXP (x6, 0);
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x7 = XEXP (x6, 1);
              operands[3] = x7;
              if (!const_int_operand (operands[3], E_SImode)
                  || !(
#line 1737 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3) && 
#line 1740 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return NULL;
              return gen_split_22 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
        case IOR:
          if (!xtensa_bit_join_operator (x2, E_SImode))
            return NULL;
          x4 = XEXP (x2, 0);
          if (!logical_shift_operator (x4, E_SImode))
            return NULL;
          x5 = XEXP (x2, 1);
          if (!logical_shift_operator (x5, E_SImode))
            return NULL;
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x12 = XEXP (x4, 1);
          if (GET_MODE (x12) != E_SImode)
            return NULL;
          x6 = XEXP (x5, 0);
          if (!register_operand (x6, E_SImode))
            return NULL;
          switch (GET_CODE (x12))
            {
            case NEG:
              operands[6] = x2;
              operands[4] = x4;
              x13 = XEXP (x12, 0);
              operands[3] = x13;
              if (!register_operand (operands[3], E_SImode))
                return NULL;
              operands[5] = x5;
              operands[2] = x6;
              x9 = XEXP (x5, 1);
              if (!rtx_equal_p (x9, operands[3])
                  || !(
#line 1787 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[5], operands[4]) != UNKNOWN) && 
#line 1790 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_23 (insn, operands);

            case AND:
              if (pattern20 (x2) != 0
                  || !(
#line 1869 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[5], operands[6]) != UNKNOWN
   && (INTVAL (operands[4]) & 0x1f) == 3 << 3) && 
#line 1873 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_24 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 0
              || GET_MODE (x2) != E_SImode
              || pattern11 (x1) != 0
              || !
#line 2953 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(reload_completed && !frame_pointer_needed))
            return NULL;
          return gen_split_37 (insn, operands);

        case AND:
          if (GET_MODE (x2) != E_SImode)
            return NULL;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return NULL;
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 3192 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_38 (insn, operands);

        case GE:
          if (pattern4 (x1) != 0)
            return NULL;
          return gen_split_39 (insn, operands);

        case NE:
        case EQ:
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != CONST_INT)
            return NULL;
          if (XWINT (x5, 0) == 0L
              && GET_CODE (x2) == EQ
              && GET_MODE (x2) == E_SImode)
            {
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (register_operand (operands[1], E_SImode)
                      && (
#line 3234 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_NSA) && 
#line 3236 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
                    return gen_split_40 (insn, operands);
                }
            }
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode)
              || !boolean_operator (x2, E_SImode))
            return NULL;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case AND:
              if (pattern14 (x2) != 0
                  || !(
#line 3290 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)
   || IN_RANGE (exact_log2 (-INTVAL (operands[2])), 1, 30)) && 
#line 3293 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_42 (insn, operands);

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_SImode)
                  || XWINT (x5, 0) != -2147483648L)
                return NULL;
              operands[2] = x2;
              if (!(
#line 3318 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_ABS) && 
#line 3320 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_43 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 4:
          if (pattern5 (x1) != 0)
            return NULL;
          x14 = XVECEXP (x1, 0, 0);
          x15 = XEXP (x14, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 0);
          operands[0] = x17;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return NULL;
          x18 = XEXP (x15, 1);
          x19 = XEXP (x18, 0);
          operands[1] = x19;
          x20 = XVECEXP (x1, 0, 1);
          x21 = XEXP (x20, 0);
          operands[2] = x21;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return NULL;
          x22 = XVECEXP (x1, 0, 3);
          x23 = XEXP (x22, 0);
          operands[3] = x23;
          if (!scratch_operand (operands[3], E_VOIDmode))
            return NULL;
          x24 = XEXP (x20, 1);
          x25 = XEXP (x24, 0);
          if (!rtx_equal_p (x25, operands[0])
              || !
#line 2358 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize && reload_completed))
            return NULL;
          return gen_split_34 (insn, operands);

        case 2:
          x20 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x20) != CLOBBER)
            return NULL;
          x21 = XEXP (x20, 0);
          if (!scratch_operand (x21, E_SImode))
            return NULL;
          x14 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x14))
            {
            case SET:
              x15 = XEXP (x14, 1);
              switch (GET_CODE (x15))
                {
                case UNSPEC_VOLATILE:
                  if (pattern7 (x14) != 0)
                    return NULL;
                  x26 = XVECEXP (x15, 0, 0);
                  operands[0] = x26;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  operands[1] = x21;
                  if (!
#line 2853 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(reload_completed))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case NE:
                case EQ:
                  operands[2] = x15;
                  if (!boolean_operator (operands[2], E_SImode))
                    return NULL;
                  x18 = XEXP (x15, 1);
                  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x27 = XEXP (x14, 0);
                  operands[0] = x27;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  x16 = XEXP (x15, 0);
                  operands[1] = x16;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  operands[3] = x21;
                  if (!
#line 3255 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
( reload_completed))
                    return NULL;
                  return gen_split_41 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x14, 0) != 1
                  || XINT (x14, 1) != 4)
                return NULL;
              x28 = XVECEXP (x14, 0, 0);
              operands[0] = x28;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              operands[1] = x21;
              if (!
#line 2865 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(reload_completed))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 3374 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(HARD_REGISTER_P (operands[0])
   && COMPLEX_MODE_P (GET_MODE (operands[0]))))
        return NULL;
      return gen_split_44 (insn, operands);

    default:
      return NULL;
    }
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (peep2_current_count < 2
          || peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      operands[6] = x3;
      if (!reload_operand (operands[6], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x4, 1);
      operands[7] = x6;
      if (!reload_operand (operands[7], E_SImode))
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SFmode))
        return NULL;
      x9 = XEXP (x7, 1);
      operands[4] = x9;
      if (!register_operand (operands[4], E_SFmode))
        return NULL;
      x10 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x10) != SET)
        return NULL;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_SFmode))
        return NULL;
      x12 = XEXP (x10, 1);
      operands[5] = x12;
      if (!register_operand (operands[5], E_SFmode)
          || !
#line 3351 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(REGNO (operands[0]) == REGNO (operands[4])
   && REGNO (operands[1]) == REGNO (operands[5])
   && peep2_reg_dead_p (4, operands[0])
   && peep2_reg_dead_p (4, operands[1])))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_1 (insn, operands);

    case CONST_INT:
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != PLUS
          || GET_MODE (x6) != E_SImode)
        return NULL;
      x13 = XEXP (x6, 1);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x14 = XEXP (x6, 0);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x5 = XEXP (x4, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode))
        return NULL;
      x15 = XEXP (x9, 0);
      operands[4] = x15;
      if (!register_operand (operands[4], E_SImode))
        return NULL;
      x16 = XEXP (x9, 1);
      if (!rtx_equal_p (x16, operands[0])
          || !
#line 3434 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(IN_RANGE (INTVAL (operands[1]) + INTVAL (operands[2]),
	     (-128 - 32768), (127 + 32512))
   && REGNO (operands[0]) != REGNO (operands[3])
   && REGNO (operands[0]) != REGNO (operands[4])
   && peep2_reg_dead_p (3, operands[0])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_2 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_VOIDmode)
          || !register_operand (operands[0], E_VOIDmode)
          || !
#line 3461 "../../gcc-14.1.1-20240508/gcc/config/xtensa/xtensa.md"
(REG_NREGS (operands[0]) == 1 && GP_REG_P (REGNO (operands[0]))
   && REG_NREGS (operands[1]) == 1 && GP_REG_P (REGNO (operands[1]))
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_3 (insn, operands);

    default:
      return NULL;
    }
}
